####################################################
# Windrop  Vladislav
# : tvrsh mod Vladislav
# : 1.0
# :    youtube   , ,  ,       .
####################################################

namespace eval etube {
foreach p [array names etube *] { catch {unset etube($p) } }
setudef flag noetube

variable etube
array set etube {
ignored "wordtoignore1 wordtoignore2"
delay 10
outtype 3
}

bind pubm - * ::etube::etube

proc ::etube::etube {nick uhost hand chan text} {
variable etube
if {[channel get $chan noetube]} { return 0 }
if {[info exists etube(lasttime,$chan)] && [expr $etube(lasttime,$chan) + $etube(delay)] > [clock seconds]} { return 0 }
set etube(start) [clock clicks]
regsub -all -- {\017|\002|\037|\026|\003(\d{1,2})?(,\d{1,2})?} $text "" text
set url [lsearch -inline [split $text] *http://*youtube*watch*]
if {$url == ""} {return 0}
set yt_tok [::http::config -useragent "Opera/9.80 (Windows NT 5.1; U; ru) Presto/2.6.30 Version/10.62"]
set yt_tok [::http::geturl "$url&hl=ru" -timeout 20000]  
set data [::http::data $yt_tok]
::http::cleanup $yt_tok
putlog "\[etube\] $nick/$chan"
set title ""; set length ""; set views ""; set author ""; set date ""; set desc ""; set category ""; set comment ""; set comments ""; set cauthor ""; set cdate "";
regsub -all -- {\n|\r|\t} $data " " data
set errormsg ""
regexp -- {<div id="watch-player-unavailable-message-container">(.+?)</div>} $data - errormsg
if {$errormsg != ""} {
::etube::largetext PRIVMSG $chan "$errormsg"
set etube(lasttime,$chan) [clock seconds]
return 0
}
set verifymsg ""
regexp -- {<div id="verify-details">(.+?)</div>} $data - verifymsg
if {$verifymsg != ""} {
::etube::largetext PRIVMSG $chan "$verifymsg"
set etube(lasttime,$chan) [clock seconds]
return 0
}
regexp {<span id="eow-title" .*? title="(.*?)"} $data "" title
regsub -all -- {\<[^\>]*\>|\t} $title "" title
set title [string trim $title]
foreach ignword [split $etube(ignored)] {
if {[string match -nocase *$ignword* $title]} { set etube(lasttime,$chan) [clock seconds]; return 0 } 
}
regexp {"length_seconds": (\d+),} $data "" length
regexp {<span class="watch-view-count">(.*?)</span>} $data "" views
regsub -all -- {\<[^\>]*\>|\t} $views "" views
set views [string trim $views]
if {[regexp -nocase -- {<span class="likes">(.*?)</span>(.*?)<span class="dislikes">(.*?)</span>(.*?)</span>} $data -> likesdislikes1 likesdislikes2 likesdislikes3 likesdislikes4]} {regsub -all {\s+$} $likesdislikes4 "" likesdislikes4; set likesdislikes " ($likesdislikes1$likesdislikes2$likesdislikes3$likesdislikes4)"} {set likesdislikes "."}
regexp {<div id="watch-headline-user-info">(.*?)</a>} $data "" author
regexp {title="(.*?)"} $author "" author
regexp {>(.*?) </span>} $author "" author
regexp {<span id="eow-date.*?" class="watch-video-date" >(.*?)</span>} $data "" date
set date [string trim $date]
regexp {<p id="eow-description" >(.*?)</p>} $data "" desc
regsub -all -- {<br />} $desc " " desc
regsub -all -- {\<[^\>]*\>|\t} $desc "" desc
regexp {<p id="eow-category">(.*?)</p>} $data "" category
regsub -all -- {\<[^\>]*\>|\t} $category "" category
regexp {<ul class="comment-list" .*?>(.*?)</li>} $data "" comments
regexp {<div class="comment-text" dir="ltr">(.*?)</div>} $comments "" comment
regsub -all -- {\uFEFF} $comment "" comment
regsub -all -- {\<[^\>]*\>|\t} $comment "" comment
set comment [string trim $comment]
regexp {<span class="author.*?>(.*?)</a>} $comments "" cauthor
regexp {<span class="time">(.*?)</span>} $comments "" cdate
regsub -all {\s+$} $cdate "" cdate
regsub -all {  .*?$} $cdate "" cdate
if {$desc == "no description available" || $desc == " "} {set desc ""}
if {[string length $desc] >= 750} {set desc "[string range $desc 0 750]..."}
if {[string length $comment] >= 750} {set comment "[string range $comment 0 750]..."}
switch $etube(outtype) {
            1 {
            ::etube::largetext PRIVMSG $chan "\002$title\002 $::gcolor(14)([::etube::duration $length])$::gcolor(5) \017 $author $::gcolor(14)($date)\017 | : $category, : [string map [list " views" "" " view" "" " " "" " " ""] $views]$likesdislikes"
            }
            2 {
            ::etube::largetext PRIVMSG $chan "\002$title\002 $::gcolor(14)([::etube::duration $length])$::gcolor(5) \017 $author $::gcolor(14)($date)\017 | : $category, : [string map [list " views" "" " view" "" " " "" " " ""] $views]$likesdislikes"
            if {$desc != ""} {::etube::largetext PRIVMSG $chan ": $desc"}
            }
            3 {
            ::etube::largetext PRIVMSG $chan "\002$title\002 $::gcolor(14)([::etube::duration $length])$::gcolor(5) \017 $author $::gcolor(14)($date)\017 | : $category, : [string map [list " views" "" " view" "" " " "" " " ""] $views]$likesdislikes"
            if {$desc != ""} {::etube::largetext PRIVMSG $chan ": $desc"}
            if {$cauthor != "" && $comment != ""} {::etube::largetext PRIVMSG $chan "  \002 $cauthor\002: $comment $::gcolor(14)([string trim $cdate])"}
            }
}
set etube(lasttime,$chan) [clock seconds]
return 0
}

proc ::etube::largetext {type target text {delims {" ",.!?}}} {
set lineLen [expr 512 - [string length ":$::botname $type [join $target] :\r\n"]]
if {[string length $text] <= $lineLen} { 
putserv "$type $target :[::etube::strip.html $text]"
return 0
}
set _text [split $text $delims]
set x 0
set i 0
while {$x < $lineLen} {
if {$i >= [llength $_text]} { 
return 0
}
set wordlen [string length [lindex $_text $i]]
if {$x + $wordlen > $lineLen} { 
break
}
incr x $wordlen
incr x
incr i
}
putserv "$type $target :[::etube::strip.html [string range $text 0 [expr $x - 1]]]"
set color [string range [lindex [split [string range $text 0 [expr $x - 1]] "\003"] [expr [llength [split [string range $text 0 [expr $x - 1]] "\003"]] - 1]] 0 1]
if {![isnumber $color]} {set color ""}
::etube::largetext $type $target \003$color[string trimleft [string range $text $x end]] $delims
}

proc ::etube::strip.html {t} {
regsub -all -nocase -- {<.*?>(.*?)</.*?>} $t {\1} t
regsub -all -nocase -- {<.*?>} $t {} t
set t [string map {{&amp;} {&}} $t]
set t [string map -nocase {{&mdash;} {-} {&raquo;} {} {&laquo;} {} {&quot;} {"}  \
		{&lt;} {<} {&gt;} {>} {&nbsp;} { } {&amp;} {&} {&copy;} {} {&#169;} {} {&bull;} {} {&#183;} {-} {&sect;} {} {&reg;} {} \
		&#8214;    || \
		&#38;      &     &#91;      (     &#92;      /     &#93;      )      &#123;     (     &#125;     ) \
		&#163;          &#168;          &#169;          &#171;           &#173;          &#174;      \
		&#161;          &#191;          &#180;          &#183;           &#185;          &#187;      \
		&#188;          &#189;          &#190;          &#192;           &#193;          &#194;      \
		&#195;          &#196;          &#197;          &#198;           &#199;          &#200;      \
		&#201;          &#202;          &#203;          &#204;           &#205;          &#206;      \
		&#207;          &#208;          &#209;          &#210;           &#211;          &#212;      \
		&#213;          &#214;          &#215;          &#216;           &#217;          &#218;      \
		&#219;          &#220;          &#221;          &#222;           &#223;          &#224;      \
		&#225;          &#226;          &#227;          &#228;           &#229;          &#230;      \
		&#231;          &#232;          &#233;          &#234;           &#235;          &#236;      \
		&#237;          &#238;          &#239;          &#240;           &#241;          &#242;      \
		&#243;          &#244;          &#245;          &#246;           &#247;          &#248;      \
		&#249;          &#250;          &#251;          &#252;           &#253;          &#254;      \
		&#176;          &#8231;         &#716;     .     &#363;     u      &#299;     i     &#712;     ' \
		&#596;     o     &#618;     i     &apos;     ' } $t]
	       set t [string map -nocase {&iexcl;    \xA1  &curren;   \xA4  &cent;     \xA2  &pound;    \xA3   &yen;      \xA5  &brvbar;   \xA6 \
		&sect;     \xA7  &uml;      \xA8  &copy;     \xA9  &ordf;     \xAA   &laquo;    \xAB  &not;      \xAC \
		&shy;      \xAD  &reg;      \xAE  &macr;     \xAF  &deg;      \xB0   &plusmn;   \xB1  &sup2;     \xB2 \
		&sup3;     \xB3  &acute;    \xB4  &micro;    \xB5  &para;     \xB6   &middot;   \xB7  &cedil;    \xB8 \
		&sup1;     \xB9  &ordm;     \xBA  &raquo;    \xBB  &frac14;   \xBC   &frac12;   \xBD  &frac34;   \xBE \
		&iquest;   \xBF  &times;    \xD7  &divide;   \xF7  &Agrave;   \xC0   &Aacute;   \xC1  &Acirc;    \xC2 \
		&Atilde;   \xC3  &Auml;     \xC4  &Aring;    \xC5  &AElig;    \xC6   &Ccedil;   \xC7  &Egrave;   \xC8 \
		&Eacute;   \xC9  &Ecirc;    \xCA  &Euml;     \xCB  &Igrave;   \xCC   &Iacute;   \xCD  &Icirc;    \xCE \
		&Iuml;     \xCF  &ETH;      \xD0  &Ntilde;   \xD1  &Ograve;   \xD2   &Oacute;   \xD3  &Ocirc;    \xD4 \
		&Otilde;   \xD5  &Ouml;     \xD6  &Oslash;   \xD8  &Ugrave;   \xD9   &Uacute;   \xDA  &Ucirc;    \xDB \
		&Uuml;     \xDC  &Yacute;   \xDD  &THORN;    \xDE  &szlig;    \xDF   &agrave;   \xE0  &aacute;   \xE1 \
		&acirc;    \xE2  &atilde;   \xE3  &auml;     \xE4  &aring;    \xE5   &aelig;    \xE6  &ccedil;   \xE7 \
		&egrave;   \xE8  &eacute;   \xE9  &ecirc;    \xEA  &euml;     \xEB   &igrave;   \xEC  &iacute;   \xED \
		&icirc;    \xEE  &iuml;     \xEF  &eth;      \xF0  &ntilde;   \xF1   &ograve;   \xF2  &oacute;   \xF3 \
		&ocirc;    \xF4  &otilde;   \xF5  &ouml;     \xF6  &oslash;   \xF8   &ugrave;   \xF9  &uacute;   \xFA \
		&ucirc;    \xFB  &uuml;     \xFC  &yacute;   \xFD  &thorn;    \xFE   &yuml;     \xFF } $t]
set t [[namespace current]::regsub-eval {&#([0-9]{1,5});} $t {string trimleft \1 "0"}]
regsub -all {[\x20\x09]+} $t " " t
regsub -all -nocase -- {<.*?>} $t {} t
regsub -all {^\s+} $t "" t
return $t
}

proc ::etube::regsub-eval {re string cmd} {
return [subst [regsub -all $re [string map {\[ \\[ \] \\] \$ \\$ \\ \\\\} $string] "\[format %c \[$cmd\]\]"]]
}

proc ::etube::duration {s} {
variable etube
set minutes [expr {$s / 60}]
set seconds [expr {$s % 60}]
if {[string length $seconds]==1} {set seconds "0$seconds"}
set res ""
if {$minutes != 0} {lappend res "$minutes:"} {lappend res "0:"}
if {$seconds != 0} {lappend res "$seconds"} {lappend res "00"}
return [string map {": " ":"} $res]
}
}

set ourtube(version) "1.0"