####################################################
# Windrop  Vladislav 
# : tvrsh
# : 1.0
# :  .
# : !
####################################################

namespace eval slovesa {
foreach p [array names slovesa *] { catch {unset slovesa($p) } }

setudef flag noinslovesa

variable slovesa
array set slovesa {
binds {slo }
msg 1
delay 10
}

###                                                                  ###
#     ,       TCL: #
# ____________________________________________________________________ #
###                                                                  ###

foreach bind [split $slovesa(binds) " "] {
bind pub -|- "$::gprefix(1)$bind" ::slovesa::slovesa_pub
if {$slovesa(msg) >= 1} {
bind msg -|- "$::gprefix(1)$bind" ::slovesa::slovesa_msg
}
}

proc ::slovesa::slovesa_msg {nick uhost hand text} {
variable slovesa
::slovesa::slovesa_proc $nick $uhost $hand $nick [lindex [split $text] 0]
}

proc ::slovesa::slovesa_pub {nick uhost hand chan text} {
variable slovesa
if {[channel get $chan noinslovesa]} { return }
::slovesa::slovesa_proc $nick $uhost $hand $chan [lindex [split $text] 0]
}

proc ::slovesa::slovesa_proc {nick uhost hand chan text} {
variable slovesa 
if {[info exists slovesa(lasttime,$chan)] && [expr $slovesa(lasttime,$chan) + $slovesa(delay)] > [clock seconds]} {
putserv "NOTICE $nick :      $slovesa(delay) [lindex {.   } [::slovesa::numgrp $slovesa(delay)]]."
putserv "NOTICE $nick : [expr $slovesa(delay) - [expr [clock seconds] - $slovesa(lasttime,$chan)]] [lindex {.   } [::slovesa::numgrp [expr $slovesa(delay) - [expr [clock seconds] - $slovesa(lasttime,$chan)]]]]   ."
return 0
}
if {[string is space $text]} {
putserv "NOTICE $nick :: $::lastbind \<\> -    \<\>."
return
}
set slovesa_tok [::http::config -urlencoding "cp1251" -useragent "Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; PPC; 240x320)"]
if {![info exists ::sp_version]} {
set query [encoding convertfrom cp1251 [encoding convertto iso8859-1 $text]]
} else {
set query $text
}
set query [http::formatQuery [::slovesa::en2ru $query]]
set slovesa_tok [::http::geturl "http://slovesa.ru/assearch?q=$query" -timeout 30000]  
set data [::http::data $slovesa_tok]
::http::cleanup $slovesa_tok
putlog "\[slovesa\] $nick/$chan"
if {[string match "*<b>  </b>*" $data]} {
putserv "PRIVMSG $chan :  ."
return 0
}
    regexp {<div class="tagcloud".*?>(.*?)</span></div></div>} $data "" data
    regsub -all -- {\<[^\>]*\>|\n} $data "" data
    set data [string trim [join [string tolower $data]] "&nbsp;"]
    set data [split [string map {&nbsp; "$::gcolor(14),$::gcolor(5)"} $data]]
    set msg "$::gcolor(14)   $::gcolor(5)[::slovesa::en2ru $text] $::gcolor(14)( $::gcolor(6)[llength $data]$::gcolor(14)):$::gcolor(5) "
    append msg "[join $data]$::gcolor(14).\003"
    ::slovesa::largetext PRIVMSG $chan [subst -nocommands $msg]
    set slovesa(lasttime,$chan) [clock seconds]
    return 0
}

proc ::slovesa::largetext {type target text {delims {" ",.!?}}} {
     global slovesa
     regsub -all {\{} $text "" text
     regsub -all {\}} $text "" text
     set text [string map {&nbsp; " " &#1093; } $text]
     regsub -all {\s+} $text " " text
     set lineLen [expr 512 - [string length ":$::botname $type [join $target] :\r\n"]]
     if {[string length $text] <= $lineLen} { 
     putserv "$type $target :$text"
     return 0
     }
    set _text [split $text $delims]
    set x 0
    set i 0
    while {$x < $lineLen} {
    if {$i >= [llength $_text]} { 
    return 0
    }
    set wordlen [string length [lindex $_text $i]]
    if {$x + $wordlen > $lineLen} { 
    break
    }
    incr x $wordlen
    incr x
    incr i
    }
putserv "$type $target :[string range $text 0 [expr $x - 1]]"
set color [string range [lindex [split [string range $text 0 [expr $x - 1]] "\003"] [expr [llength [split [string range $text 0 [expr $x - 1]] "\003"]] - 1]] 0 1]
if {![isnumber $color]} {set color ""}
::slovesa::largetext $type $target \003$color[string trimleft [string range $text $x end]] $delims
}

proc ::slovesa::en2ru {t} { return [string map {f  \,  d  u  l  t  \`  \;  p  b  q  r  k  v  y  j  g  h  c  n  e  a  \[  w  x  i  m  o  \]  \'  s  \.  z } [string tolower $t]] }

proc ::slovesa::numgrp {number} { 
    switch -glob -- "$number" { 
        *11 {return 3} 
        *12 {return 3} 
        *13 {return 3} 
        *14 {return 3} 
        *1 {return 1} 
        *2 {return 2} 
        *3 {return 2} 
        *4 {return 2} 
        default {return 3} 
}
}
}