####################################################
# Windrop  Vladislav
# : Stream
# : 1.3
# :          //,   //  . 
####################################################

namespace eval amode {}

setudef flag automode

bind pub m|m $::gprefix(1)avoiceadd		::amode::pub_avoiceadd
bind pub m|m $::gprefix(1)avoicedel		::amode::pub_avoicedel
bind pub m|m $::gprefix(1)avoicelist	::amode::pub_avoicelist
bind pub m|m $::gprefix(1)aopadd		::amode::pub_aopadd
bind pub m|m $::gprefix(1)aopdel		::amode::pub_aopdel
bind pub m|m $::gprefix(1)aoplist		::amode::pub_aoplist
bind pub m|m $::gprefix(1)ahopadd		::amode::pub_ahopadd
bind pub m|m $::gprefix(1)ahopdel		::amode::pub_ahopdel
bind pub m|m $::gprefix(1)ahoplist		::amode::pub_ahoplist

bind pub m|m $::gprefix(1)deopadd		::amode::pub_deopadd
bind pub m|m $::gprefix(1)deopdel		::amode::pub_deopdel
bind pub m|m $::gprefix(1)deoplist		::amode::pub_deoplist
bind pub m|m $::gprefix(1)dehopadd		::amode::pub_dehopadd
bind pub m|m $::gprefix(1)dehopdel		::amode::pub_dehopdel
bind pub m|m $::gprefix(1)dehoplist		::amode::pub_dehoplist
bind pub m|m $::gprefix(1)devoiceadd	::amode::pub_devoiceadd
bind pub m|m $::gprefix(1)devoicedel	::amode::pub_devoicedel
bind pub m|m $::gprefix(1)devoicelist	::amode::pub_devoicelist

bind join - *			            ::amode::onjoin
bind nick - *			            ::amode::onnick
bind mode - *			            ::amode::onmode

#################################################

foreach p [array names amode *] {catch {unset amode($p)}}

#   
set amode(maxlen)		400
#   .        +v, +o  +h
set amode(exemptflags)	"E"
#     ,   
set amode(datafile)	"data/amode.data"
#   (1-,0-)
set amode(delay)        1

#################################################

proc ::amode::readdata {} {
global amode
if {![catch {set fid [open $amode(datafile) "r"]}]} {
while {![eof $fid]} {
set data [split [string trim [gets $fid]] " "]
if {[llength $data] >= 2} {
if {![info exists amode([lindex $data 0])]} {set amode([lindex $data 0]) [list [lindex $data 1]]
} else {lappend amode([lindex $data 0]) [lindex $data 1]}
}
}
close $fid
putlog "\[amode\]  [llength [array names amode data,*]]   "
} else {putlog "\[amode\]     '$amode(datafile)'!"}
}

proc ::amode::writedata {} {
global amode
set fid [open "$amode(datafile)" "w+"]
foreach name [array names amode data,*] {
foreach data $amode($name) {
puts $fid "$name $data"
}
}
close $fid
}

proc ::amode::init {} {
foreach tmr [utimers] {if {[lindex $tmr 1] == "::amode::mode"} {killutimer [lindex $tmr 2]}}
::amode::readdata
}

proc ::amode::tolower {text} { return [string map {                                                                 } [string tolower $text]] }

proc ::amode::out {nick chan text} {
if {$nick == $chan} {putserv "PRIVMSG $nick :$text"
} else {putserv "NOTICE $nick :$text"}
}

#################################################

proc ::amode::pub_avoiceadd {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodeadd $nick $uhost $hand $chan "v" [join $args]
}

proc ::amode::pub_aopadd {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodeadd $nick $uhost $hand $chan "o" [join $args]
}
proc ::amode::pub_ahopadd {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodeadd $nick $uhost $hand $chan "h" [join $args]
}
proc ::amode::pub_deopadd {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodeadd $nick $uhost $hand $chan "d" [join $args]
}
proc ::amode::pub_dehopadd {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodeadd $nick $uhost $hand $chan "q" [join $args]
}
proc ::amode::pub_devoiceadd {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodeadd $nick $uhost $hand $chan "w" [join $args]
}

proc ::amode::pub_avoicedel {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodedel $nick $uhost $hand $chan "v" [join $args]
}

proc ::amode::pub_aopdel {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodedel $nick $uhost $hand $chan "o" [join $args]
}

proc ::amode::pub_ahopdel {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodedel $nick $uhost $hand $chan "h" [join $args]
}
proc ::amode::pub_deopdel {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodedel $nick $uhost $hand $chan "d" [join $args]
}
proc ::amode::pub_dehopdel {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodedel $nick $uhost $hand $chan "d" [join $args]
}
proc ::amode::pub_devoicedel {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodedel $nick $uhost $hand $chan "w" [join $args]
}

proc ::amode::pub_avoicelist {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodelist $nick $uhost $hand $chan "v" [join $args]
}

proc ::amode::pub_aoplist {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodelist $nick $uhost $hand $chan "o" [join $args]
}

proc ::amode::pub_ahoplist {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodelist $nick $uhost $hand $chan "h" [join $args]
}

proc ::amode::pub_deoplist {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodelist $nick $uhost $hand $chan "d" [join $args]
}
proc ::amode::pub_dehoplist {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodelist $nick $uhost $hand $chan "d" [join $args]
}
proc ::amode::pub_devoicelist {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {![channel get $chan automode]} { return }
	::amode::amodelist $nick $uhost $hand $chan "w" [join $args]
}

proc ::amode::onjoin {nick uhost hand chan} {
	global amode botnick
	if {![channel get $chan automode]} { return }

	if {![string equal $nick $botnick]} {::amode::check $nick $uhost $hand $chan
	} else {::amode::checkchan $chan}
}

proc ::amode::onnick {nick uhost hand chan newnick} {
	global amode botnick
	if {![channel get $chan automode]} { return }

	if {![string equal $newnick $botnick]} {::amode::check $newnick $uhost $hand $chan}
}

proc ::amode::onmode {nick uhost hand chan mode victim} {
	global amode botnick
	if {![channel get $chan automode]} { return }

	if {[string equal $victim $botnick] && $mode == "+o"} {::amode::checkchan $chan}
	if {(![string equal $victim $botnick] && [isop $botnick $chan]) && ($mode == "+o" || $mode == "+h" || $mode == "+v" ) } {::amode::check $victim [getchanhost $victim $chan] [nick2hand $victim $chan] $chan}
}

#################################################

proc ::amode::amodeadd {nick uhost hand chan mode args} {
global amode lastbind
set mask [string trim [join $args]]
if {[string length $mask] < 1} {::amode::out $nick $chan ": $lastbind <>"; return}
set pos1 [string first "!" $mask]
set pos2 [string first "@" $mask]
if {$pos1 != -1} {
if {$pos2 < $pos1} {set mask "$mask@*"
} elseif {$pos2 == [string length $mask]} {set mask "$mask*"}
} elseif {$pos2 != -1} {set mask "*!*$mask"
} elseif {[string first "." $mask] != -1} {set mask "*!*@$mask"
} else {set mask "$mask!*@*"}	
if {[info exists amode(data,$chan,$mode)]} {
foreach data $amode(data,$chan,$mode) {
if {[string equal $mask $data]} {
::amode::out $nick $chan " '$mask'    [::amode::strmode $mode]   $chan."
return
}
}
lappend amode(data,$chan,$mode) $mask
} else {set amode(data,$chan,$mode) [list $mask]}
foreach user [chanlist $chan] {
if {[string match $mask "$user![getchanhost $user $chan]"]} {
::amode::delayedmode $user $chan $mode
}
}
::amode::writedata
::amode::out $nick $chan "  [::amode::strmode $mode] '$mask'   $chan."
}

proc ::amode::amodedel {nick uhost hand chan mode args} {
global amode lastbind
set mask [string trim [join $args]]
if {[string length $mask] < 1} {::amode::out $nick $chan ": $lastbind <>"; return}
if {![info exists amode(data,$chan,$mode)]} {
::amode::out $nick $chan " [::amode::strmode $mode]   $chan ."
return
}
set pos1 [string first "!" $mask]
set pos2 [string first "@" $mask]
if {$pos1 != -1} {
if {$pos2 < $pos1} {set mask "$mask@*"
} elseif {$pos2 == [string length $mask]} {set mask "$mask*"}
} elseif {$pos2 != -1} {set mask "*!*$mask"
} elseif {[string first "." $mask] != -1} {set mask "*!*@$mask"
} else {set mask "$mask!*@*"}	
set res ""
foreach data $amode(data,$chan,$mode) {
if {![string equal $mask $data]} {lappend res $data}
}
if {[llength $res] < [llength $amode(data,$chan,$mode)]} {
::amode::out $nick $chan " [::amode::strmode $mode]  '$mask'   $chan."
set amode(data,$chan,$mode) $res
::amode::writedata
} else {::amode::out $nick $chan " '$mask'   [::amode::strmode $mode]   $chan."}
}

proc ::amode::amodelist {nick uhost hand chan mode args} {
global amode lastbind
set mask [string trim [join $args]]
if {[string length $mask] < 1} {set mask "*"}
if {![info exists amode(data,$chan,$mode)]} {
::amode::out $nick $chan " [::amode::strmode $mode]   $chan ."
return
}
set res ""
foreach data $amode(data,$chan,$mode) {
if {[string match $mask $data]} {lappend res $data}
}
if {[llength $res] < 1} {::amode::out $nick $chan " [::amode::strmode $mode]  ."; return}
while {[llength $res] > 0} {
if {[string length [join $res "; "]] <= $amode(maxlen) || [llength $res] == 1} {::amode::out $nick $chan [join $res "; "]; break}
set msg ""
set newtext ""
foreach word $res {
if {[expr {[string length $msg] + [string length $word] + 2}] <= $amode(maxlen)} {lappend msg $word
} else { if {$msg == "" && [string length $word] > $amode(maxlen)} {lappend msg $word
} else {lappend newtext $word}}
}
if {$msg != ""} {::amode::out $nick $chan [join $msg "; "]}
set res $newtext
}
}

proc ::amode::check {nick uhost hand chan} {
global amode
if {$hand != "" && $hand != "*" && [validuser $hand]} {
if {[matchattr $hand "$amode(exemptflags)|$amode(exemptflags)" $chan]} {return}
}
foreach name [array names amode data,$chan,*] {
foreach mask $amode($name) {
if {[string match $mask "$nick!$uhost"]} {
::amode::delayedmode $nick $chan [lindex [split $name ","] 2]
}
}
}
}

proc ::amode::checkchan {chan} {
global botnick
if {![botisop $chan]} {return}
foreach user [chanlist $chan] {
if {![string equal $user $botnick]} {
::amode::check $user [getchanhost $user $chan] [nick2hand $user $chan] $chan
}
}
}

proc ::amode::delayedmode {nick chan mode} {
global amode
foreach tmr [utimers] {
set cmd [lindex $tmr 1]
if {[string equal [lindex $cmd 0] "::amode::mode"] && [string equal [lindex $cmd 1] $chan]} {
lappend amode(modes,$chan) [list $nick $mode]
return
}
}
set amode(modes,$chan) [list [list $nick $mode]]
set delays [split [channel get $chan aop-delay] " "]
if {[llength $delays] < 1} {set delays [list 5 10]}
if { $amode(delay) } {
set seconds [expr {[lindex $delays 0] + int(rand()*([lindex $delays 1] - [lindex $delays 0]))}]
utimer $seconds [list ::amode::mode $chan]
} else { ::amode::mode $chan }
}

proc ::amode::mode {chan} {
global amode
foreach mode $amode(modes,$chan) {
set nick [lindex $mode 0]
set mode [lindex $mode 1]
if {[onchan $nick $chan]} {
if {[string equal $mode "v"] && ![isvoice $nick $chan]} {
pushmode $chan +v $nick
} else { 
if {[string equal $mode "o"] && ![isop $nick $chan]} {
pushmode $chan +o $nick
} else {
if {[string equal $mode "h"] && ![ishalfop $nick $chan]} {
pushmode $chan +h $nick
}
}
}
if {[string equal $mode "d"] && [isop $nick $chan]} {
pushmode $chan -o $nick
} else {
if {[string equal $mode "q"] && [ishalfop $nick $chan]} {
pushmode $chan -h $nick
} else {
if {[string equal $mode "w"] && [isvoice $nick $chan]} {
pushmode $chan -v $nick
}
}
}
}
}
unset amode(modes,$chan)
}

proc ::amode::strmode {mode} {
switch -exact $mode {
		v { return "" }
		o { return "" }
		h { return "" }
		d { return "" }
		q { return "" }
		w { return "" }
		default { return "" }
}
}
::amode::init