####################################################
# Windrop  Vladislav 
# : Tothwolf
# : 1.1 
####################################################

catch {set numversion}
if {([info exists numversion]) && ($numversion >= 1061600) && ($numversion <= 1061900)} then {
putlog "Error: dccwhois.tcl is not compatible with Eggdrop version [lindex $version 0]. Please upgrade to 1.6.20 or later."
return
}

proc dcc:whois {hand idx arg} {
global dccwhois_flags
set arg [split [string trimright $arg]]
set who [lindex $arg 0]
if {([string compare "" $who]) && ([string compare [string toupper $hand] [string toupper $who]])} then {
set chan [lindex [console $idx] 0]
if {![matchattr $hand $dccwhois_flags $chan]} then {
putdcc $idx "You do not have access to whois handles other than your own."
return 0
}
}
*dcc:whois $hand $idx $arg
return 0
}

proc init_dccwhois {} {
global dccwhois_flags
if {[array exists dccwhois_flags]} then {
array unset dccwhois_flags
}
foreach bind [binds "\\*dcc:whois"] {
foreach {type flags name count command} $bind {break}
if {[string compare $name "whois"]} then {
continue
}
set dccwhois_flags $flags
unbind $type $flags $name $command
}
if {(![info exists dccwhois_flags]) || (![string compare "" $dccwhois_flags])} then {
set dccwhois_flags "to|o"
}
bind dcc -|- whois dcc:whois
return
}

init_dccwhois