####################################################
# Windrop  Vladislav 
# : tvrsh
# : 1.1
# :         .
# : !
####################################################

namespace eval asknick {}
foreach p [array names asknick *] { catch {unset asknick($p) } }

setudef flag noasknick

###                            ###
#     : #
# ______________________________ #
###                            ###

set asknick(askfile) "data/ask/askfile.txt"
set asknick(ansfile) "data/ask/ansfile.txt"
set asknick(type)    "0"
set asknick(prefix)  "\002::\002"
set asknick(delay)   10

###                                                                  ###
#     ,       TCL: #
# ____________________________________________________________________ #
###                                                                  ###

bind pub - $::gprefix(1) ::asknick::asknick_proc
proc ::asknick::asknick_proc {nick uhost hand chan text} {
global asknick lasttime victim maxans dest
if {[channel get $chan noasknick]} { return 0 }
if {[isbotnick [lindex [split $text] 0]]} { putserv "PRIVMSG $chan :$nick,      !"; return 0 }
set victim [lindex [split $text] 0]
if {$victim == ""} { putserv "NOTICE $nick :: $::gprefix(1) <>"; return 0 }
if {![onchan $victim $chan]} { putserv "NOTICE $nick :    ."; return 0 }
if {[info exists lasttime]} {
if {[expr [expr [unixtime] - $lasttime] < $asknick(delay)]} { 
return 0
}
}
switch $asknick(type) {
"0" { set dest "PRIVMSG $chan"}
"1" { set dest "NOTICE $nick"}
"2" { set dest "PRIVMSG $nick"}
}
set askfile [open $asknick(askfile) "r"]
set askdata [read -nonewline $askfile]
close $askfile
set ansfile [open $asknick(ansfile) "r"]
set ansdata [read -nonewline $ansfile]
close $ansfile
set anslines [split $ansdata "\n\r"]
set asklines [split $askdata "\n"]
set numlines [llength $asklines]
set num [rand $numlines]
set asknickq [lindex $asklines $num]
putserv "[subst -nocommands $dest] :$::gcolor(6)$asknick(prefix) $::gcolor(6)$victim$::gcolor(14),  $::gcolor(6)[expr $num + 1]$::gcolor(14)/$numlines: $::gcolor(5)$asknickq"
set maxans [llength $anslines]  
set anklines [split $ansdata "\n"]
putserv "[subst -nocommands $dest] :$::gcolor(6)$asknick(prefix) $::gcolor(14)        $::gcolor(5)1 $::gcolor(14) $::gcolor(5)$maxans$::gcolor(14)."
set lasttime [unixtime]
bind pubm - "*" ::asknick::asknick_answer
return 0
}

proc ::asknick::asknick_answer {nick uhost hand chan text} {
global asknick lasttime victim maxans dest
if {[string tolower $nick] != [string tolower $victim]} { return 0 }
if {[channel get $chan noasknick]} { return 0 }
if {![isnumber [lindex [split $text] 0]]} { return 0 }
set ansfile [open $asknick(ansfile) "r"]
set ansdata [read -nonewline $ansfile]
close $ansfile
set anslines [split $ansdata "\n"]
if {[lindex [split $text] 0] <= $maxans && [lindex [split $text] 0] >= 1} {
putserv "[subst -nocommands $dest] :$::gcolor(6)$asknick(prefix) $::gcolor(6)$nick$::gcolor(14),  : $::gcolor(5)[lindex $anslines [expr [lindex [split $text] 0] - 1]]"
unbind pubm - "*" ::asknick::asknick_answer
return 0
} else {
putserv "[subst -nocommands $dest] :$nick,    .  :)" 
return 0
}
}