######################################################
# Windrop  Vladislav
# :  ""
# : !
######################################################

# 
if {![info exists ::ggchan] || $::gschan == ""} {set ::gschan "#windrop"}

set subwordchan $::gschan

set pathforsubwordscript "data/subword/"
set fixwindropgluk 0
set infotext "$::gcolor(5)  >>>$::gcolor(14)    c.           ,   ().            .        ''  .
$::gcolor(6)$::gprefix(1)$::gcolor(14) - :   ,  3       ;  ,       ;      . 
$::gcolor(6)$::gprefix(1) $::gcolor(14)\[$::gcolor(6)$::gcolor(14)\] -   . 
$::gcolor(6)$::gprefix(1)$::gcolor(14) -    . 
$::gcolor(6)$::gprefix(1)$::gcolor(14) -  ."

#---      .
proc namecheck username {return 1}

#---         
proc fixgluk variable {return $variable}

#--------     
proc list2string {list divider} {
set finalresult ""
set result ""
set ind 0
set len [llength $list]
while {$len > $ind} {
if {$result != ""} {append result $divider}
append result [lindex $list $ind]
if {[llength [split $result ""]] > 200} {if {$finalresult != ""} {append finalresult "$::gcolor(5)\n$::gcolor(5)"}; append finalresult $result; set result "";}
incr ind 1
}
if {$result != ""} {if {$finalresult != ""} {append finalresult "$::gcolor(5)\n$::gcolor(5)"}; append finalresult "$result"; }
return $finalresult
}

#---------     ,     minbukv
proc randslovo minbukv {
global pathforsubwordscript
set fdict [open "${pathforsubwordscript}bases/dictionary.txt"]
seek $fdict [expr {int( [file size "${pathforsubwordscript}bases/dictionary.txt"] * rand() )}]
set slovo [gets $fdict]
set slovo ""
while {[llength [split $slovo ""]] < $minbukv} {
if {[eof $fdict]} {seek $fdict 0}
set slovo [gets $fdict]
}
close $fdict
return $slovo
}

#-----------      ---
proc lowreg text {
set text [split $text ""]
set alphlow  "                                 "
set alphhigh "                                 "
set posi 0
set foret ""
while  {$posi < [llength $text]} {
set a [lsearch $alphhigh [lindex $text $posi]]
if {$a != -1} then { append foret [lindex $alphlow $a]; } else { append foret [lindex $text $posi] }
incr posi 1
}
return $foret
}


#-----------      ---
proc verhreg text {
set text [lowreg $text]
set text [split $text ""]
set alphlow  "                                 "
set alphhigh "                                 "
set posi 0
set foret ""
while  {$posi < [llength $text]} {
set a [lsearch $alphlow [lindex $text $posi]]
if {$a != -1} then { append foret [lindex $alphhigh $a]; } else { append foret [lindex $text $posi] }
incr posi 1
}
return $foret
}

#------- ,    
proc validword {slovechko slovo} {
set slovechko [split [verhreg $slovechko] ""]
set slovo [split [verhreg $slovo] ""]
if {([llength $slovechko] >= [llength $slovo]) || (2 > [llength $slovechko])} {return 0}
foreach bukva $slovechko {
if {[set index [lsearch $slovo $bukva]] == -1} {return 0}
set slovo [lreplace $slovo $index $index "*"]
}
return 1
}

#---------- ,        

proc high {word1 word2} {
set alphhigh "                                "
set word1 [split [verhreg $word1] ""]
set word2 [split [verhreg $word2] ""]
if {$word1 == $word2} {return 0}
if {$word1 == ""} {return 1}
if {$word2 == ""} {return 2}
set order 1
if {[llength $word1] > [llength $word2]} {set temp $word2; set word2 $word1; set word1 $temp; set order 0;}
set actpos 0
set maxpos [llength $word1]

while {$maxpos > $actpos} {
set p1 [lsearch $alphhigh [lindex $word1 $actpos]]
set p2 [lsearch $alphhigh [lindex $word2 $actpos]]
if {$p2 > $p1} {if {$order} then {return 1} else {return 2}}
if {$p1 > $p2} {if {$order} then {return 2} else {return 1}}
incr actpos 1
}

if {$order} then {return 1} else {return 2}
}

#-------------        
proc searchword {lst wrd} {
if {[set maxcnt [llength $lst]] == 0} {return 0}
set cnt 0
while {$maxcnt > $cnt} {
if {[set stat [high $wrd [lindex $lst $cnt]]] == 0} {return -1}
if {$stat == 1} {return $cnt}
incr cnt 1
}
return $maxcnt
}

#-------------    ,     distance    
proc distword distance {
global pathforsubwordscript
set fdic [open "${pathforsubwordscript}bases/dictionary.txt"]
set otstup 0
set testchr ""
while {($testchr != "\n") && [expr {$distance - $otstup}] != 0} {
seek $fdic [expr {$distance - $otstup}]
set testchr [read $fdic 1]
incr otstup 1
}
if {$testchr != "\n"} {seek $fdic 0}
set rret [gets $fdic]
close $fdic
return $rret
}

#------------    (. .) 
proc validate word {
global pathforsubwordscript
set higran 0
set lowgran [file size "${pathforsubwordscript}bases/dictionary.txt"]
while 1 {
set middle [expr {int ( 0.5 * ($higran + $lowgran) ) }]
set wrd [distword $middle]
set act [high $word $wrd]
if {$act == 0} {return 1}
if {$act == 1} then {set lowgran $middle; if { (2 > ($lowgran - $higran)) && ($word != [distword $higran]) } then {return 0} elseif {2 > ($lowgran - $higran)} {return 1} } else {set higran $middle; if { (2 > ($lowgran - $higran)) && ($word != [distword $lowgran]) } then {return 0} elseif {2 > ($lowgran - $higran)} {return 1}}

}
}

#------------
#  countvict --      
# addcountvict <nick> <howmany> (returns seecountnick+howmany)
# seecountnick <nick> (returns value of nick's balls)

proc addcountvict {nick balls} {
global pathforsubwordscript
if {[file exists "${pathforsubwordscript}victlist.txt"]} then {set chid [open "${pathforsubwordscript}victlist.txt"]} else {set chid 0}
set wrid [open "${pathforsubwordscript}newvictlist.txt" w]

set retval 0
if {$chid != 0} {
while {! [eof $chid] } {
    set actstr [gets $chid];
    if {[lindex $actstr 0] == $nick} { set retval [expr {[lindex $actstr 1] + $balls}]; set actstr [lreplace $actstr 1 3 $retval [expr {[lindex $actstr 2] + 1}] [clock seconds]] }
    if {([lindex $actstr 3] != "") && (2592000 > ([clock seconds] - [lindex $actstr 3])) } {puts $wrid $actstr}
    }
    close $chid
    }

if { $retval == 0 }  { set retval $balls; puts $wrid "$nick $balls 1 [clock seconds]" }

    close $wrid
    file delete "${pathforsubwordscript}victlist.txt"
    file rename "${pathforsubwordscript}newvictlist.txt" "${pathforsubwordscript}victlist.txt"
    return $retval
}


#------------  


proc mylpush {ind pos towhat} {
set now [expr {[llength $ind] - 2}]
while {$now >= $pos} { set ind [lreplace $ind [expr {$now+1}] [expr {$now+1}] [lindex $ind $now]]; incr now -1; }
set ind [lreplace $ind $pos $pos $towhat]
return $ind
}



proc topstring {num} {

global pathforsubwordscript

set wonlist ""
set ratwonlist ""
set cnter 0
while {$cnter < $num} {lappend wonlist " 0"; incr cnter 1; }
set cnter 0
while {$cnter < $num} {lappend ratwonlist " 0.0 0"; incr cnter 1; }

if {[file exists "${pathforsubwordscript}victlist.txt"]} then {set chid [open "${pathforsubwordscript}victlist.txt"]} else {set chid 0}

if {$chid != 0} {
while {! [eof $chid] } {
    set actvil [gets $chid]
    set nck [lindex $actvil 0]
    set ozki [lindex $actvil 1]
    if {($nck != "") && ($ozki > 99)} {
    set cnter [expr {$num - 1}]
    while {$cnter > -1} {
    set bigger [expr {$ozki <= [lindex [lindex $wonlist $cnter] 1]}];
    if {$bigger && ( $cnter == [expr {$num - 1}] ) } {break};
    if {$bigger} {set tmp ""; lappend tmp $nck; lappend tmp $ozki; set wonlist [mylpush $wonlist [expr {$cnter+1}] $tmp]; break };
    if { (!$bigger) && ($cnter == 0)} {set tmp ""; lappend tmp $nck; lappend tmp $ozki; set wonlist [mylpush $wonlist 0 $tmp];};
    incr cnter -1;
    }

    set chast [expr {[lindex $actvil 1] / ([lindex $actvil 2] + 0.0)}]
    set cnter [expr {$num - 1}]
    while {$cnter > -1} {
    set bigger [expr {($chast < [set aaaa [lindex [lindex $ratwonlist $cnter] 1]])||(($chast == $aaaa)&&($ozki <= [lindex [lindex $wonlist $cnter] 2]))}];
    if {$bigger && ( $cnter == [expr {$num - 1}] ) } {break};
    if {$bigger} {set tmp ""; lappend tmp $nck; lappend tmp $chast; lappend tmp $ozki; set ratwonlist [mylpush $ratwonlist [expr {$cnter+1}] $tmp]; break };
    if { (!$bigger) && ($cnter == 0)} {set tmp ""; lappend tmp $nck; lappend tmp $chast; lappend tmp $ozki; set ratwonlist [mylpush $ratwonlist 0 $tmp];};
    incr cnter -1;
    }


    }
    }
    close $chid
}

set cnter 0
set formstring " : "
while {$cnter < $num} {set tek [lindex $wonlist $cnter]; append formstring "$::gcolor(14)#$::gcolor(6)[expr {$cnter+1}]$::gcolor(14) - $::gcolor(5)[lindex $tek 0]$::gcolor(14) ($::gcolor(4)[lindex $tek 1]$::gcolor(14))"; if { $cnter == ($num - 1) } then {append formstring "$::gcolor(14); "} else {append formstring "$::gcolor(14), "}; incr cnter 1; }
set cnter 0
append formstring "$::gcolor(14) : "
while {$cnter < $num} {set tek [lindex $ratwonlist $cnter]; append formstring "$::gcolor(14)#$::gcolor(6)[expr {$cnter+1}]$::gcolor(14) - $::gcolor(5)[lindex $tek 0]$::gcolor(14) ($::gcolor(4)[expr {int(100 * [lindex $tek 1]) / 100.0}]$::gcolor(14))"; if { $cnter == ($num - 1) } then {append formstring "$::gcolor(14)."} else {append formstring "$::gcolor(14), "}; incr cnter 1; }
return $formstring

}

proc won_howmany_and_pos_and_chast {nick} {
global pathforsubwordscript
if {[file exists "${pathforsubwordscript}victlist.txt"]} then {set chid [open "${pathforsubwordscript}victlist.txt"]} else {set chid 0}

set pl 0
set statusfind 0
if {$chid != 0} {
while {! [eof $chid] } {
    incr pl 1
    set actvil [gets $chid]
    if {[lindex $actvil 0] == $nick} {set statusfind [lindex $actvil 1]; break }
    }
    close $chid
    }
    if {! $statusfind} {set pl 0; set chst 0;}
    if {$statusfind} {set chst [expr {$statusfind / ([lindex $actvil 2] + 0.0)}];}
    return "$statusfind $pl $chst";
}


proc won_place {wons excludepos rate} {
global pathforsubwordscript
set counthigh 0
set ratecounthigh 0
set chid [open "${pathforsubwordscript}victlist.txt"]
set pl 0

while {! [eof $chid]} {
incr pl 1
set actvil [gets $chid]
set actwons [lindex $actvil 1]
if {$actwons > 99} {
set actrate [expr {[lindex $actvil 1] / ([lindex $actvil 2] + 0.0)}]
if {$pl >= $excludepos} then {if {$actwons >= $wons} {incr counthigh 1}} else {if {$actwons > $wons} {incr counthigh 1}}
if {$pl == $excludepos} then {incr ratecounthigh 1} elseif {$pl > $excludepos} then {if {($actrate > $rate)||(($actrate == $rate)&&($actwons >= $wons))} then {incr ratecounthigh 1}} else {if {($actrate > $rate)||(($actrate == $rate)&&($actwons > $wons))} then {incr ratecounthigh 1}}
}
}

close $chid
return "$counthigh $ratecounthigh"
}




#---------    
#********************************************

set lastactiontime 0
set slovo ""
set reached ""
proc putout {handle text} {
global subwordchan
set strings [split $text \n]
set len [llength $strings]
set dlen 0
while {$len > $dlen} {
set txt [lindex $strings $dlen]
if {$txt != ""} {if {$handle == "$subwordchan"} then {putchan $subwordchan $txt} else {putserv "$handle :$txt" }}
incr dlen;
}
}


#---------  
proc catchajoin {nick mask handle channel} {
global slovo subwordchan botnick ;
if {[string tolower $channel] != [string tolower $subwordchan]} {return}
if { $nick == $botnick } {return}
putnotc $nick "$::gcolor(14)()    , $::gcolor(5)$nick$::gcolor(14)?     $subwordchan.    ,   $::gcolor(4)$::gprefix(1)$::gcolor(14).    : $::gcolor(6)\002$slovo\002$::gcolor(14).";
if {![namecheck $nick]} then {putnotc $nick "$::gcolor(4)         :   ,    (     ).   ,        .";}
}

proc showhelpforpub {a b c d e} {
global subwordchan infotext;
putout "NOTICE $a" $infotext;
}

proc startgame {a b c d e} {
global lastactiontime slovo reached subwordchan;
if {[lsearch -exact [split [string tolower $subwordchan]] [string tolower $d]] == -1} {
putfast "NOTICE $a : ''   $d  ,   $subwordchan"
return
}
if {([clock seconds] - $lastactiontime) >= 180 } then {set slovo [verhreg [randslovo 10]];
putchan $subwordchan "$::gcolor(5),   !"
putchan $subwordchan "$::gcolor(14)      $::gcolor(4)$::gprefix(1)\003"
putchan $subwordchan "$::gcolor(14)  :$::gcolor(6) $slovo";
set reached ""; 
} else {
putchan $subwordchan "$::gcolor(14)    $::gcolor(6) [expr {180 + $lastactiontime - [clock seconds] }]$::gcolor(14) ,           $::gcolor(6) $slovo"; 
} 
}

proc showreached {a b c d e} {
global reached subwordchan;
if {[string tolower $d] != [string tolower $subwordchan]} {return}
if {$reached == ""} then {
putchan $subwordchan "$::gcolor(14)        .";
} else {
putout $subwordchan "$::gcolor(14)     : $::gcolor(5)[list2string $reached "$::gcolor(14),$::gcolor(5) "]$::gcolor(14).";
}
}

proc checkplay {nick a b c text} {
global lastactiontime slovo reached subwordchan;
if {[string tolower $c] != [string tolower $subwordchan]} {return}
set nick [fixgluk $nick];
set text [verhreg [fixgluk $text]];
if {[set inspos [searchword $reached $text]] != -1} then {
if {($slovo != "!") && [validword $text $slovo] && [validate $text]} {
if {[namecheck $nick] != 0} then {
set allcounsub [addcountvict $nick [llength [split $text ""]]]
putchan $subwordchan "$::gcolor(4)$::gcolor(14), $::gcolor(5)$nick$::gcolor(14)!   $::gcolor(5) [verhreg $text]$::gcolor(14)  $::gcolor(6) $slovo$::gcolor(14)  $::gcolor(4) [llength [split $text ""]]$::gcolor(14) [lindex {.   } [subword:numgrp [llength [split $text ""]]]],      $::gcolor(4) $allcounsub$::gcolor(14) [lindex {.   } [subword:numgrp $allcounsub]]!";
} else {
putchan $subwordchan "$::gcolor(4)$::gcolor(14), $::gcolor(5)$nick$::gcolor(14)!   $::gcolor(5) [verhreg $text]$::gcolor(14)  $::gcolor(6) $slovo$::gcolor(14)  $::gcolor(4) [llength [split $text ""]]$::gcolor(14) [lindex {.   } [subword:numgrp [llength [split $text ""]]]]. $::gcolor(14) ,          .       $::gcolor(4) $::gcolor(14) .";
};
set reached [linsert $reached $inspos [verhreg $text]];
set lastactiontime [clock seconds];
}
} else {
putnotc $nick "$::gcolor(14) $::gcolor(5)$text$::gcolor(14)   ...";
} 
}

proc showtop {nick a b c text} {
global subwordchan 
if {[string tolower $c] != [string tolower $subwordchan]} {return}

putchan $subwordchan "$::gcolor(14)   , [topstring 3]";
}

proc showplace {nick a b c text} {
global subwordchan
if {[string tolower $c] != [string tolower $subwordchan]} {return}
set nick [fixgluk $nick];
set text [fixgluk $text];
if {[llength $text] == 1} {
set nick $text
};
set wyhdann [won_howmany_and_pos_and_chast $nick];
set won [lindex $wyhdann 0];
if {$won == 0} then {
putchan $subwordchan "$::gcolor(5)$nick$::gcolor(14)      !";
} else {
set rate [lindex $wyhdann 2];
set places [won_place $won [lindex $wyhdann 1] $rate]; 
if {$won>99} then {
set placeprint "$::gcolor(6) [lindex $places 0]$::gcolor(14)     $::gcolor(6) [lindex $places 1]$::gcolor(14)    !";
} else {
set placeprint "     ,    100 !";
};
putchan $subwordchan "$::gcolor(5)$nick$::gcolor(14)    $::gcolor(14)$::gcolor(4) $won$::gcolor(14) [lindex {.   } [subword:numgrp $won]]    $::gcolor(5) [expr {int(100 * $rate) / 100.0}]$::gcolor(14); $placeprint";
} 
}

proc changetopic {a b c d} {
global pathforsubwordscript subwordchan;
putserv "topic $subwordchan :[subst [read [open "${pathforsubwordscript}topic.txt"]]]" 
}

proc testword {nick a b c text} {
global pathforsubwordscript subwordchan;
if {[string tolower $c] != [string tolower $subwordchan]} {return}
set text [fixgluk $text];
if {[llength $text] != 1} then {
putchan $subwordchan ": $::gprefix(1) <_>";
return 0; 
} else {
if {[validate $text]} {
putchan $subwordchan " [verhreg $text]   !"
} else {
set mmmm [open "${pathforsubwordscript}nopingwords.txt" a]; 
puts $mmmm "$text"; 
close $mmmm; 
putchan $subwordchan " [verhreg $text]  !"
} 
} 
}

proc subword:numgrp {number} { switch -glob -- "$number" { *11 {return 3} *12 {return 3} *13 {return 3} *14 {return 3} *1 {return 1} *2 {return 2} *3 {return 2} *4 {return 2} default {return 3} } }

#-------- 
bind pubm - * checkplay
bind pub - $::gprefix(1) showhelpforpub
bind pub - $::gprefix(1) startgame
bind pub - $::gprefix(1) showreached
bind pub - $::gprefix(1) showplace
bind pub - $::gprefix(1) showtop

#bind pub - $::gprefix(1) testword
#bind msg - topic changetopic

#        .
#bind join - * catchajoin