####################################################
# Windrop  Vladislav 
# : Vertigo mod Vladislav
# : 1.0
# :   www.foreca.com
# : ! !
####################################################

namespace eval ::foreca {

bind pub - $::gprefix(1) [namespace current]::weather:pub
bind pub - $::gprefix(1) [namespace current]::weather:pub
bind msg - $::gprefix(1) [namespace current]::weather:msg
bind msg - $::gprefix(1) [namespace current]::weather:msg

#         3  ?       "+"  
variable fullformat "1"

variable site       "http://www.foreca.com"
variable timeout    "30"
variable timer      "5"
variable useragent  "Opera/9.80 (Windows NT 5.1; U; ru) Presto/2.6.30 Version/10.62"
variable chflag     nofweather
variable fcookies   "lv=cnU6MTAwNDYzODI5O3J1OjEwMDU4MTA0OTtydToxMDA1MjQ5MDE%3D; st2=lang%3Dru%26units%3Dmetric%26tf%3D24h%26u%3DU4XYU0R304QA"
setudef flag        $chflag

proc weather:msg {nick uhost hand text} {
weather:pub $nick $uhost $hand $nick $text
return 1
}

proc weather:pub {nick uhost hand chan text} {
variable chflag
variable timer
if {$chan != $nick && [channel get $chan $chflag]} { return }
if {[info exists [namespace current]::wait] && [expr [clock seconds] - $[namespace current]::wait] < $timer} { putserv "[expr {$nick == $chan ? "PRIVMSG":"NOTICE"}] $nick :  .     [expr  $timer - ([clock seconds] - $[namespace current]::wait)] ."; return 0; }
set [namespace current]::wait [clock seconds]
if {[string is space $text]} { putserv "[expr {$nick == $chan ? "PRIVMSG":"NOTICE"}] $nick :: $::lastbind \[-\] \<\> -    ."; return; }
if {[regexp -- {^-(\d+)} $text -> num]} {regsub -- "^-$num\s?" $text "" text} else {set num 1}; set text [string trim $text]
set ext 0; variable fullformat
if {[string match "*+*" $text] || $fullformat == "1"} {set text [string map {+ ""} $text]; set ext 1}
if {[string length $text] > 50} { putserv "[expr {$nick == $chan ? "PRIVMSG":"NOTICE"}] $nick :      - 50."; return; }
if {[string length $text] < 3} {putserv "[expr {$nick == $chan ? "PRIVMSG":"NOTICE"}] $nick :      - 3."; return; }
if {[string match "" [string tolower $text]]} {set text ""}; if {[string match "" [string tolower $text]]} {set text "-"}; if {[string match "" [string tolower $text]]} {set text ""}; if {[string match "" [string tolower $text]]} {set text ""}; if {[string match "" [string tolower $text]]} {set text "  "}; if {[string match "" [string tolower $text]]} {set text ""}
variable timeout; variable useragent; variable site; variable fcookies
::http::config -useragent $useragent -urlencoding utf-8
if {[catch {set token [::http::geturl $site -method POST -protocol 1.0 -query [::http::formatQuery loc_id "" geode_lon "" geode_lat "" q $text do_search "Find place"] -headers [list "Accept-Language" "ru-RU,ru;q=0.9,en;q=0.8" "Accept-Charset" "iso-8859-1, utf-8, utf-16, *;q=0.1" Cookie $fcookies] -timeout [expr $timeout * 1000] -command [list [namespace current]::weather:data $nick $chan $text [scan $num %d] 1 $ext]]} err]} {putserv "[expr {$nick == $chan ? "PRIVMSG":"NOTICE"}] $nick :    : $err"; return 1}
}

proc weather:data {nick chan text num total ext token} {
set ncode [::http::ncode $token]; set status [::http::status $token]
array set meta [::http::meta $token]
variable site; variable timeout; variable fcookies
::http::config -urlencoding cp1251
if {[string index $ncode 0] == "3" && [info exists meta(Location)]} {
::http::cleanup $token
if {[catch {set token [::http::geturl "$site[string map {{%2f} {/}} [::http::formatQuery [encoding convertfrom cp1251 $meta(Location)]]]" -timeout [expr $timeout * 1000] -protocol 1.0 -headers [list "Accept-Language" "ru-RU,ru;q=0.9,en;q=0.8" "Accept-Charset" "iso-8859-1, utf-8, utf-16, *;q=0.1" Cookie $fcookies] -command [list [namespace current]::weather:data $nick $chan $text $num $total $ext]]} err]} {putserv "[expr {$nick == $chan ? "PRIVMSG":"NOTICE"}] $nick :     (): $err"; return 1; }
return
}
if {$ncode != "200" || $status ne "ok"} {::http::cleanup $token; putserv "PRIVMSG $chan :Server returned a $ncode-error code or timeout occured."; putserv "PRIVMSG $chan :[array get meta]"; return 0}
set data [::http::data $token]
::http::cleanup $token
regsub -all -- "\n|\r|\t" $data "" data
if {[string match -nocase "*No results*" $data] || [string match -nocase "* *" $data]} {putserv "PRIVMSG $chan :  ."; return}
if {[regexp -nocase -- {<div class="clearb"></div>.*?<!-- START -->(.+?)<!-- END -->} $data -> data]} {
set clist [list]; set clist_ [list]; foreach _ [split [string map {{<dd>} \n} $data] \n] {
if {[regexp -nocase -- {<a href="(.*?)"><strong>(.*?)</strong></a>,} $_ -> city city2]} {
if {[string tolower $city2] eq [string tolower $text] && $city ni $clist} {lappend clist $city} {lappend clist_ $city2}
}
}
if {![llength $clist]} { if {![llength $clist_]} {putserv "PRIVMSG $chan :  ."} {putserv "NOTICE $nick : : [join $clist_ ", "]."}; return }
set clist2 [list]; foreach _ $clist {
if {[string match -nocase "*russia/*" $_]} {lappend clist2 [list 0 $_]} elseif {[string match -nocase "*ukraine/*" $_]} {lappend clist2 [list 1 $_]} {lappend clist2 [list 2 $_]}
}
set clist2 [lsort $clist2]
set clist3 [list]; foreach _ $clist2 {
lappend clist3 [lindex $_ 1]
}
set total [llength $clist3]
if {$num > $total || $num eq "0"} {set clink [lindex $clist3 0]; set num 1} else {set clink [lindex $clist3 [expr $num - 1]]}
if {[catch {set token [::http::geturl "$site[string map {{%2f} {/}} [::http::formatQuery [encoding convertfrom cp1251 $clink]]]" -timeout [expr $timeout * 1000] -protocol 1.0 -headers [list "Accept-Language" "ru-RU,ru;q=0.9,en;q=0.8" "Accept-Charset" "iso-8859-1, utf-8, utf-16, *;q=0.1" Cookie $fcookies] -command [list [namespace current]::weather:data $nick $chan $text $num $total $ext]]} err]} {putserv "[expr {$nick == $chan ? "PRIVMSG":"NOTICE"}] $nick :Error while connecting to remote server after select city: $err"; return 1; }
return
}
set stat "N/A"; set mloc1 ""; set mloc2 ""; set mloc ""
if {[regexp -nocase -- {<a href=".*?">(.*?)</a>.*?<img src="/img/arrow2.gif" alt="&gt;&gt;".*?<a href=".*?browse">(.*?)</a>.*?</strong>} $data -> stat1 stat2]} { set stat "$stat1 $stat2"; }
regsub -nocase -- {^.*?<div class="content-right hslice" id="webslice_content">} $data "" data
set wloc "N/A"
regexp -nocase -- {<h1 class="entry-title">(.*?)</h1>} $data -> wloc
regexp -nocase -- {<img class="world".*?<a href=".*?browse">(.*?)</a>.*?<a href=".*?browse">(.*?)</a>.*?<img src="/img/arrow1.gif" alt="&gt;&gt;".*?</strong>\s*</div>} $data -> mloc1 mloc2
if {$mloc1 != "" && $mloc2 != ""} {set mloc " \($mloc1, $mloc2\)"} 
regsub -nocase -- {^.*?<!-- START -->} $data "" data
regsub -nocase -- {<p class="in"><p class="in">$} $data "" data
if {[string match -nocase "*No results*" $data] || [string match -nocase "* *" $data]} { putserv "PRIVMSG $chan :  ."; return; }
set temp "N/A"; set windd ""; set windv ""; set sky "N/A"; set ftemp "N/A"; set pres "N/A"; set bpnt "N/A"; set relw "N/A"; set time "N/A"
#catch {::egglib::writedata fw.txt [list $data]}
if {![regexp -nocase -- {.*?src="/img/symb-wind/.*?.gif" alt="(.*?)".*?<strong>(.*?)</strong>} $data -> windd windv]} {regexp -nocase -- {.*?src=".*?/s/symb-wind/.*?.gif" alt="(.*?)".*?<strong>(.*?)</strong>} $data -> windd windv}
regexp -nocase -- {<.*?class=".*?txt-xxlarge"><strong>(.*?)</strong>.*?} $data -> temp
if { ![regexp -nocase -- {<div class="right txt-tight">(.*?)<div class="bot txt-tight grey">(.*?)<br />.*?<div class="c2">} $data -> data_ time]} { putserv "PRIVMSG $chan :Error while getting data."; return }
set edata [list]
regsub -nocase -- {^.*?<div class="c2">} $data "" data
set data [string map -nocase {{<div class="c2_a">} \n} $data]
if {$ext} {
foreach _ [split $data \n] {
if {[regexp -nocase -- {<strong>(<a href=".*?">.*?</a>.*?<br />\s*</div>)} $_ -> __] || [regexp -nocase -- {(<a href=".*?">.*?<strong>.*?</a>\s*</div>)} $_ -> __]} {
set __ [string map -nocase {{&deg;} {%c14 C}} [string totitle [string trim [regsub -all -- {[\x20\x09]+} [regsub -all -- {<.*?>} [regsub -all -- {<a href=".*?" title="(.*?)">} $__ " \\1"] ""] " "]]]]
lappend edata "$::gcolor(14)[string map -nocase { " %c05%c14:"  " %c05%c14:"  " %c05%c14:"  " %c05%c14:"  " %c05%c14:"  " %c05%c14:"  " %c05%c14:"  %c05%c14:  %c05%c14: : :%c06 " :" ", :%c12"} [join [lrange [split $__] 0 end]]]"
}
}
}
if {$windd eq "" || $windv eq ""} { set windd "N/A"; set windv ""; } 
set wparams [list]
foreach _ [split [string map -nocase {{<br />} \n} $data_] \n] {
lappend wparams [string map -nocase {{<strong>} {} {</strong>} {} {<div>} {} {</div>} {} {&deg;} {  C}} [regsub -all -- {[\x20\x09]+} $_ " "]]
}
if {![llength $wparams]} { putserv "PRIVMSG $chan :Error while getting data (2)."; return; }
if {$total > 1} {set idx "$::gcolor(14)\[$::gcolor(6)$num$::gcolor(14)/$total\] :: "} {set idx ""}
putserv "PRIVMSG $chan :$idx[regsub -all -- {\x20+} "$::gcolor(14)   $::gcolor(5)[regsub -nocase {^.*?<strong>} $wloc ""]$::gcolor(14)$mloc  $::gcolor(5)[string trim [regsub -- {[^0-9\-\/\:\x20]} $time ""]]$::gcolor(14): :$::gcolor(6) $temp$::gcolor(14) C\, [string map {{ c} {C} { ,} {} {. } {}} [string tolower "[lindex $wparams 1],$::gcolor(6) [lindex $wparams 0]$::gcolor(14), [join [lrange [string map {" " ""} $wparams] 4 end] ", "]"]] : [windconv $windd]$windv" " "]."
if {$edata != ""} {putserv "PRIVMSG $chan :[join [::egglib::meta_to_colors $edata] "$::gcolor(14) :: "]."}
}

proc windconv {wind} {
switch -exact [string tolower $wind] {
w {return " "}
e {return " "}
s {return " "}
n {return " "}
ne {return "- "}
nw {return "- "}
sw {return "- "}
se {return "- "}
default {return $wind}
}
}
}