######################################################
# Windrop  Vladislav 
# : adium
# : 1.2
# :       .
# : ! -   ;
#	     !  -   ;
#	     !  -   ;
#	     !  -   ;
#	     !  -   ;
#	     !  -   ;
#	     !  -   ;
#	     !  -   ;
#	     !   -   .
#	     !  -   .
#	     !   -   
######################################################

namespace eval genname {
	variable unamespace		[string range [namespace current] 2 end]
	variable pause			{10}
	variable prefix			$::gprefix(1)
	variable flags			{-|-}
	variable binds			{genname }
      
      setudef flag nogenname

	foreach b [split $binds " "] { bind pub ${flags} "${prefix}${b}" [namespace current]::main }

	proc main {nick uhost hand chan text} {
	variable pause
      variable lastcall
      if {[channel get $chan nogenname]} { return }
	if {[info exists lastcall($uhost)]} {
	if {[expr [expr [unixtime] - $lastcall($uhost)] < $pause]} {
	set det [expr [unixtime] - $lastcall($uhost)]
	set wtime [expr $pause - $det]
	variable prefix
	putserv "NOTICE $nick :    $::gprefix(1)  [timereplace $wtime]."
	return 0
	}
      }
	set lastcall($uhost) [unixtime]
	set text [string tolower [lindex [string range [join $text] 0 end] 0]]
	switch -- $text {
			{dwarf} - {} {
				set l1 [list B D F G Gl H K L M N R S T Th V]
				set l2 [list a e i o oi u]
				set l3 [list bur fur gan gnus gnar li lin lir mli nar nus rin ran sin sil sur]
				set name "[lindex $l1 [rand [llength $l1]]][lindex $l2 [rand [llength $l2]]][lindex $l3 [rand [llength $l3]]]"
				putserv "PRIVMSG $chan :$::gcolor(14)  : $::gcolor(5)$name$::gcolor(14).\003"
				return 0
			      }
			{elf} - {} {
				set l1 [list Al An Bal Bel Cal Cel El Ell Elr Elv Eow Er F Fal Fel Fin G Gal Gel Gl Is Lan Leg Lm N Nal Nel S Sal Sel T Tal Tel Thr Tin]
				set l2 [list a  adrie ara e  ebri ele ere i io ithra ilma il-Ga ili o orfi  u y]
				set l3 [list las lad ldor ldur lind lith mir n nd ndel ndil ndir nduil ng mbor r rith ril riand rion s ssar thien viel wen wyn]
				set name "[lindex $l1 [rand [llength $l1]]][lindex $l2 [rand [llength $l2]]][lindex $l3 [rand [llength $l3]]]"
				putserv "PRIVMSG $chan :$::gcolor(14)  : $::gcolor(5)$name$::gcolor(14).\003"
				return 0
			      }
			{gnome} - {} {
				set l1 [list Aar An Ar As C H Han Har Hel Iir J Jan Jar K L M Mar N Nik Os Ol P R S Sam San T Ter Tom Ul V W Y]
				set l2 [list a aa ai e ei i o uo u uu]
				set l3 [list ron re la ki kseli ksi ku ja ta na namari neli nika nikki nu nukka ka ko li kki rik po to pekka rjaana rjatta rjukka la lla lli mo nni]
				set name "[lindex $l1 [rand [llength $l1]]][lindex $l2 [rand [llength $l2]]][lindex $l3 [rand [llength $l3]]]"
				putserv "PRIVMSG $chan :$::gcolor(14)  : $::gcolor(5)$name$::gcolor(14).\003"
				return 0
			      }
			{halfling} - {} {
				set l1 [list B Ber Br D Der Dr F Fr G H L Ler M Mer N P Pr Per R S T W]
				set l2 [list a e i ia o oi u]
				set l3 [list bo ck decan degar do doc go grin lba lbo lda ldo lla ll lo m mwise nac noc nwise p ppin pper sha tho to]
				set name "[lindex $l1 [rand [llength $l1]]][lindex $l2 [rand [llength $l2]]][lindex $l3 [rand [llength $l3]]]"
				putserv "PRIVMSG $chan :$::gcolor(14)  : $::gcolor(5)$name$::gcolor(14).\003"
				return 0
			      }
			{saxon} - {} {
				set l1 [list Ald Aeld Alf Aelf Alh Aelh Athel Aethel Beo Beor Berh Brih Briht Cad Cead Cen Coel Cuth Cyne Ed Ead El Eal Eld Eg Ecg Eorp God Guth Har Hwaet Leo Leof Oft Ot Oth Os Osw Peht Pleg Rad Raed Sig Sige Si Sihr Tat Tath Tost Ut Uht Ul Ulf Wal Walth Wer Wit Wiht Wil Wulf]
				set l2 [list gar heah here bald war weard wulf dred red stan wold tric ric wald mon wal walla wealh frith gyth rum bert berht gar win wine wiu for mund thoef eof had erth ferth thin er ther tar thar wig wicg mer floed ith hild run drun ny]
				set name "[lindex $l1 [rand [llength $l1]]][lindex $l2 [rand [llength $l2]]]"
				putserv "PRIVMSG $chan :$::gcolor(14)  : $::gcolor(5)$name$::gcolor(14).\003"
				return 0
			      }
			{orc} - {} {
				set l1 [list B Er G Gr H P Pr R V Vr T Tr M Dr]
				set l2 [list a i o oo u ui]
				set l3 [list dash dish dush gar gor gdush lo gdish k lg nak rag rbag rg rk ng nk rt ol urk shnak mog mak rak]
				set name "[lindex $l1 [rand [llength $l1]]][lindex $l2 [rand [llength $l2]]][lindex $l3 [rand [llength $l3]]]"
				putserv "PRIVMSG $chan :$::gcolor(14)  : $::gcolor(5)$name$::gcolor(14).\003"
				return 0
			      }
			{country} - {} {
				set l1 [list Aqu Bos Ven Cor Aghr Aren Shad Bel Dar Nem Han Num Py Nord Oph Fr I L Mec Ron Sh Ter Abb Akb An Asg Er Gh K Lib Pel Sab St Har Kh Neb Nil T Th Ak Khor Sam Vil Cyl Mik Gon R Mor Cim]
				set l2 [list i o a e u y ai ae ea ia]
				set l3 [list lonia nia rium nthium pur jun zar verus far dia mar lia thon heim r sol nthe dier nta co mu m son drah tania kia lum k za ros num shtia tea mir shan gia kh jar mi xur thu lus khmet a ran f sun ra hpur yet ska lannon land dor han ria]
				set name "[lindex $l1 [rand [llength $l1]]][lindex $l2 [rand [llength $l2]]][lindex $l3 [rand [llength $l3]]]"
				putserv "PRIVMSG $chan :$::gcolor(14)  : $::gcolor(5)$name$::gcolor(14).\003"
				return 0
			      }
			{town} - {} {
				set l1 [list Abing Al Ald Aln Ames Amp Ash At Ave Aving Ax Back Bake Bamp Ban Beck Ber Berke Bevers Bi Bick Bin Block Bol Bos Bottes Bow Brad Brans Brat Bre Bree Bridg Brink Bris Brom Broom Bud Cad Caer Came Car Cart Castle Cavers Charter Ched Chew Chippen Coly Corn Cors Cran Credi Crick Crow Culm Dagger Dart Dedding Deer Din Ditte Dittis Dor Dragon Drif Dry Dun Dur Dwarf East Ebring Eding Elf Elk En Erming Exe Fair Faring Flad Fording Forth Framp From Gis Glas Gnome Goblin Gras Grey Guis Hail Hart Haver Helm Here Hex Hol Hop In Kelm Ken Kew Kil King Kirk Knight La Lam Lan Laner Laving Led Leo Lindis Lyd Lymp Mal Malmes Marsh Mel Mell Minchin Monk Mont Mow Muchel Net Nether Nev New Nib North Pen Per Pether Pew Pris Rad Rend Ring Rip Rock Rom Roth Sapper Sel Seming Shaftes Shield Shob Shrews Sid Sken Skip Somer South Spear Staf Stan Stan Staple Staun Stoke Sword Syd Taun Tavi Tel Tewkes Tint Titch Tiver Tort Tot Trout Uff Uffing Ulvers Uplea Urch Wan War Wel Wen West Whit Wide Wim Winch Wit Withing Wood Woot Wor Wot Wring Yat]
				set l2 [list bane beck borne borough bourn bourne bray bridge burgh burn burton bury by chester comb combe con cost culme dal der dish don dor e east ent ern es farn fel field font ford frith glade glen gold gomery ham hampton house how hurst iard keep kirk lade land leigh leon ley lingham low meet mel mere minster moot mouth nard ne nes newton ney noller nor on pas peck rest ridge scott sey shire silver sley spring stock stoke ston stone sward swear tage ter tol ton ton ton ton ton ton ton ton ton ton town vale vern wall water well went west wick wood worth worthy yard]
				set name "[lindex $l1 [rand [llength $l1]]][lindex $l2 [rand [llength $l2]]]"
				putserv "PRIVMSG $chan :$::gcolor(14)  : $::gcolor(5)$name$::gcolor(14).\003"
				return 0
			      }
			{tavern} - {} {
				set l1 [list Dancing Laughing Running Prancing Drunken Flying Sleeping Leaping Fighting Sleeping Red Green Blue Yellow White Black Rusty Silver Golden Shiny Bronze Iron]
				set l2 [list Badger Bear Beaver Boar Bull Cat Cow Dragon Dog Deer Duck Dwarf Elf Elk Eagle Fairy Ferret Gnome Goblin Goat Goose Hen Lamb Lion Orc Ogre Pig Pony Rooster Sheep Troll Unicorn]
				set l3 [list Red Green Blue Yellow White Black Rusty Silver Golden Shiny Bronze Iron]
				set l4 [list Tree Bucket Shield Sword Spear Bow Arrow Axe Barrel Keg Tap Mug Chalice Helm Wheel Saw Plow Bell Crown Ship Sun Moon Star Coin Bottle]
				set n1 "[lindex $l1 [rand [llength $l1]]] [lindex $l2 [rand [llength $l2]]]"
				set n2 "[lindex $l3 [rand [llength $l3]]] [lindex $l4 [rand [llength $l4]]]"
				set n3 "[lindex $l2 [rand [llength $l2]]]'s Head"
				set n4 "[lindex $l2 [rand [llength $l2]]] and [lindex $l2 [rand [llength $l2]]]"
				set n5 "[lindex $l4 [rand [llength $l4]]] and [lindex $l4 [rand [llength $l4]]]"
				set str [list $n1 $n2 $n3 $n4 $n5]
				set name "[lindex $str [rand [llength $str]]]"
				putserv "PRIVMSG $chan :$::gcolor(14)  : $::gcolor(5)$name$::gcolor(14).\003"
				return 0
			      }
			{finsk} - {} {
				set l1 [list Aar An Ar As C H Han Har Hel Iir J Jan Jar K L M Mar N Nik Os Ol P R S Sam San T Ter Tom Ul V W Y]
				set l2 [list a aa ai e ei i o uo u uu]
				set l3 [list ron re la ki kseli ksi ku ja ta na namari neli nika nikki nu nukka ka ko li kki rik po to pekka rjaana rjatta rjukka la lla lli mo nni]
				set name "[lindex $l1 [rand [llength $l1]]][lindex $l2 [rand [llength $l2]]][lindex $l3 [rand [llength $l3]]]"
				putserv "PRIVMSG $chan :$::gcolor(14)  : $::gcolor(5)$name$::gcolor(14).\003"
				return 0
			      }
			default {
				set l1 [list                                                                                             ]
				set l2 [list              ]
				set l3 [list                                        ]
				set name "[lindex $l1 [rand [llength $l1]]][lindex $l2 [rand [llength $l2]]][lindex $l3 [rand [llength $l3]]]"
				putserv "PRIVMSG $chan :$::gcolor(14) : $::gcolor(5)$name$::gcolor(14).\003"
                        putserv "NOTICE $nick :  : $::gprefix(1) |||||||||\003"
				return 0
			      }
	}
	}

	proc timereplace {text} {
		set text [duration $text]
		set t [lindex $text end-1]
		set m [lindex $text end-3]
		set ti 0
		set mi 0
		if {$t == "0" || $t == "11" || $t == "12" || $t == "13" || $t == "14"} {
		regsub -all -- {seconds} $text {} text
		set ti 1
		} elseif {$t == "1"} {
		regsub -all -- {second} $text {} text
		set ti 1
		} elseif {$t == "2" || $t == "3" || $t == "4"} {
		regsub -all -- {seconds} $text {} text
		set ti 1
		} elseif {$t >= 5 && !$ti} {
		switch -- [string index $t end] { 
		0 { regsub -all -- {seconds} $text {} text }
		1 { regsub -all -- {seconds} $text {} text }
		2 - 3 - 4 { regsub -all -- {seconds} $text {} text }
		default { regsub -all -- {seconds} $text {} text }
		}
		}
		if {$m == "0" || $m == "11" || $m == "12" || $m == "13" || $m == "14"} {
		regsub	-all	--	{minutes}	$text	{}		text
		set mi 1
		} elseif {$m == "1"} {
		regsub	-all	--	{minute}	$text	{}	text
		set mi 1
		} elseif {$m == "2" || $m == "3" || $m == "4"} {
		regsub	-all	--	{minutes}	$text	{}	text
		set mi 1
		} elseif {$m >= 5 && !$mi} {
		switch -- [string index $m end] {
		0 { regsub -all -- {minutes} $text {} text }
		1 { regsub -all -- {minutes} $text {} text }
		2 - 3 - 4 { regsub -all -- {minutes} $text {} text }
		default { regsub -all -- {minutes} $text {} text }
		}
		}
		return $text
	      }
}