####################################################
# Windrop  Vladislav 
# : Shrike && Vertigo
# : 1.6.7
# : .
# : !+
####################################################
namespace eval ::weather {

setudef flag noweather

bind pub - $::gprefix(1)+ 		      ::weather::pub_weather
bind msg - $::gprefix(1)+ 		      ::weather::msg_weather
bind pub - $::gprefix(1)+ 		::weather::pub_weather
bind msg - $::gprefix(1)+		::weather::msg_weather

bind dcc n weatherupdate   	::weather::dcc_weatherupdate
bind dcc n weatherupd   	::weather::dcc_weatherupdate
bind dcc n wupd   		::weather::dcc_weatherupdate

foreach p [array names [namespace current]::weather *] { catch {unset [namespace current]::weather($p) } }

variable timeout 	   20
variable debug 	   0
variable usexml      0
variable use_proxy   0
variable proxy_host  "proxy1.bezeqint.net"
variable proxy_port  3128
variable file        "data/weather/weather.dat"
variable aliases     "data/weather/weather.aliases"
variable agent       "Opera/9.80 (Windows NT 5.1; U; ru) Presto/2.2.15 Version/10.10"
variable redirs      0

if {![file exists $aliases]} { set f [open $aliases w+]; close $f; }

proc msg_weather { nick uhost hand args } {
if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
::weather::weather $nick $uhost $nick $nick $args
}

proc pub_weather { nick uhost hand chan args } {
if {[channel get $chan noweather]} { return }
if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
::weather::weather $nick $uhost $hand $chan $args
}

########################################################
proc weather { nick uhost hand chan args } {
 	variable file; variable agent; variable debug; variable timeout; variable use_proxy; variable proxy_host; variable proxy_port; variable aliases; variable usexml
	if {![file readable $file]} {putquick "NOTICE $nick :   !      ,    .weatherupdate"; return 0}
	set f [open $file r]
	fconfigure $f -encoding cp1251
 	set cities [lrange [split [read $f] \n] 0 end-1]
	close $f	
 	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	if {[llength $args]==0} { putquick "NOTICE $nick :: $::lastbind \[-\] \[+\] \<\>"; return }	
		if {[string first "=" [join $args]] != -1 && ([matchattr $hand o] || [matchattr $hand |o $chan])} {
		set f [open $aliases r]
		fconfigure $f -encoding cp1251
		set tmp [lrange [split [read $f] \n] 0 end-1]
		close $f
		set alias [string trim [lindex [split [join $args] =] 0]]
		if {[string first "*" $alias] != -1 || [string first "?" $alias] != -1 || [string is space $alias]} {
		putserv "PRIVMSG $chan :$nick:       ?,  *  ."
		return
		}
		set city [string map {\} "" \{ ""} [string trim [lindex [split [join $args] =] 1]]]	
		if {[set id [lsearch -nocase -exact -index 0 $tmp $alias]] != -1} {
		if {![string is space $city]} {
		putserv "PRIVMSG $chan :$nick:  '$alias'     '[lindex $tmp $id 1]'."
		return
		} else {
		set tmp [lreplace $tmp $id $id]
		set f [open $aliases w+]
		fconfigure $f -encoding cp1251
		puts $f [join $tmp \n]
		flush $f
		close $f
		putserv "PRIVMSG $chan :$nick:  '$alias' ."
		return
		}
		}
		if {[string is space $city]} {
		putserv "PRIVMSG $chan :$nick:  '$alias'  ."
		return
		}
		set tmp [list]
		if {[catch {set slist [lsearch -all -nocase -inline -index 0 $cities $city]} err]} {
		putlog "::weather::aliases:error - $err"
		putserv "PRIVMSG $chan :$nick:  '$city'    ..."
		return
		}
		foreach _  $slist {
		if {[lsearch -exact $tmp [lindex $_ 0]] == -1} {lappend tmp [lindex $_ 0]}
		}
		if {![llength $tmp]} {
		putserv "PRIVMSG $chan :$nick:  '$city'    ..."; return
		}
		if {[llength $tmp] > 1 && [llength $tmp] <= 15} {
		putserv "PRIVMSG $chan :$nick:      : [join $tmp ", "].  ."; return
		}
		if {[llength $tmp] > 15} {
		putserv "PRIVMSG $chan :$nick:     \([llength $tmp]\)   '$city' -    ."
		return
		}
		set f [open $aliases a]
		fconfigure $f -encoding cp1251
		puts $f [list $alias [lindex $tmp 0]]
		flush $f
		close $f
		putserv "PRIVMSG $chan : '$alias'   '[lindex $tmp 0]' ."
		return
		}
	
	if {[regexp -nocase -- {\+(\d+)} $args - nd_]} {putlog "weather: next day: $nd_"; set nd $nd_; set args [string map "{+$nd_ } {}" $args]} else { set nd 0 }
	if {$nd > "12"} {set nd "1"}
	if {![regexp -- {-(\d+)\s+} $args -> wnum]} {set wnum 0} else {
	set args [string map "{-$wnum } {}" $args]
	if {$wnum > [llength $cities]} {set wnum 0}
	}
	set query $args
	set f [open $aliases r]
	fconfigure $f -encoding cp1251
	set tmp [lrange [split [read $f] \n] 0 end-1]
	close $f
	if {[llength $tmp] > 0 && [set id [lsearch -nocase -exact -index 0 $tmp $query]] != -1} {
	set query [lindex $tmp $id 1]
	}
	if {[info exists weather(host,$uhost)]} { putserv "notice $nick :    ..."; return }
	set wid ""
	set founds [list]
	foreach _ $cities {
	if {[string match -nocase "$query*" $_]} {
	lappend founds [string trim [lindex [split $_ "#"] end]]
	}
	}
	if {[llength $founds] > 1} {
	if {$wnum > [llength $founds]} {set wnum [llength $founds]}
	if {$wnum > 0} {set wnum [expr $wnum -1]}
	set wid [lindex $founds $wnum]
	} else {
	set wid [lindex $founds 0]
	}
	if {$wid eq "" || [string is space $query]} { putquick "notice $nick :,   '$query'    -.-"; return }
	set weather(host,$uhost) 1
	::http::config -useragent $agent -urlencoding utf-8
	if { $use_proxy } {::http::config -proxyhost $proxy_host -proxyport $proxy_port }

if {$usexml} {
set url_0 "http://informer.gismeteo.ru/xml/${wid}.xml"
} else {
set url_0 "http://m.gismeteo.ru/citysearch/by_name/?gis_search=[::http::formatQuery $query]"
}
	if {[catch {
	set token [::http::geturl "$url_0" -timeout 20000 \
	-command [list [namespace current]::got_data $nick $uhost $chan $nd $query $wnum 0 0]]
	} err]} {
	putquick "NOTICE $nick :   .  : $err"
	unset -nocomplain err weather(host,$uhost)
	return
	}
}

proc ::weather::got_data {nick uhost chan nd query wnum req.num founds token} {
variable debug
variable usexml
variable redirs
	set ncode [::http::ncode $token]
	set http_header [::http::code $token]
	if {[string index $ncode 0] eq 4} {
	putserv "NOTICE $nick :   .  : [::http::code $token]."
	::http::cleanup $token
	return
	}
	array set meta [::http::meta $token]
	set html [http::data $token]
if { $debug } { putlog "\[weather\] callback executed... analyzing data..." }
if {$debug} {putlog "\[weather:meta\] $http_header"}
if {$debug} {foreach {k v} [http::meta $token] {putlog "\[weather:meta\] $k: $v"}}
if {$debug} {foreach _ [split $html \n] {putlog "\[weather:data\] $_"}}
if {[string index $ncode 0] == "3" && [info exists meta(Location)]} {
::http::cleanup $token
if {[incr redirs] >= 3} {putlog "::weather:: maximum redirects reached - stopping. URL=$meta(Location)"; set redirs 0; return}
if {[catch {
	if {[string range $meta(Location) 0 6] eq "http://"} {set sturl ""} {set sturl "http://m.gismeteo.ru"}
	set token [::http::geturl "$sturl$meta(Location)" -timeout 20000 \
	-command [list [namespace current]::got_data $nick $uhost $chan $nd $query $wnum ${req.num} $founds]]
	} err]} {
	putquick "NOTICE $nick :   .       $meta(Location): $err"
	unset -nocomplain err weather(host,$uhost)
	return
	}
      return
      }
      set redirs 0
	http::cleanup $token
  	set wp1 ""; set wp2 ""; set s1 ""; set s2 ""; set wt ""	; set city ""; set day ""
	regsub -all -- "\n|\r|\t" $html "" html
	if {$usexml} {
	regexp -nocase -- {<TOWN index="\d+" sname="(.*?)" latitude=} $html -> city
	binary scan [subst -nocomm -novar [string map {"%" "\\x"} $city]] a* city
	set city [encoding convertfrom cp1251 $city]
	set html [string map {{<FORECAST} \n} $html]
	set weatherdata [list]
      foreach _ [split $html \n] {	
	if {[regexp -nocase -- {day="(\d+)" month="(\d+)" year="(\d+)" hour="(\d+)".*?<PHENOMENA cloudiness="(\d+)".*?precipitation="(\d+)".*?<PRESSURE max="(\d+)" min="(\d+)"/>.*?<TEMPERATURE max="(.*?)" min="(.*?)"/>.*?<WIND min="(\d+)" max="(\d+)" direction="(\d+)"/>.*?<RELWET max="(\d+)" min="(\d+)"/>.*?</FORECAST} $_ -> day month year hour sky sky2 pres2 pres1 temp2 temp1 wind1 wind2 wdir hum]} {
set hour [scan $hour %d]
if {$hour >= 0 && $hour < 6} {
set hour ""
} elseif {$hour >= 6 && $hour < 12} {
set hour ""
} elseif {$hour >= 12 && $hour < 18} {
set hour ""
} else {
set hour ""
}
set day "[string map {Sun "," Mon "," Tue "," Wed "," Thu "" Fri "," Sat "," Jan  Feb  Mar  Apr  May  Jun  Jul  Aug  Sep  Oct  Nov  Dec } [clock format [clock scan "[scan $day %d]/[scan $month %d]/$year" -format "%d/%m/%Y"] -format "%a %e %b %Y"]] ."
set pres "${pres1}...$pres2 .."
set temp "${temp1}$::gcolor(14)...$::gcolor(6)$temp2$::gcolor(14) C"
set wind "[lindex {               } $wdir] ${wind1}...$wind2 /"
set sky "[lindex {   } $sky][lindex {{} {} {} {, } {, } {, } {, } {, }} $sky2]"
set hum "${hum}%"
lappend weatherdata [list $day $hour $sky [colorifier $temp] $pres $hum $wind]
}
}
} else {
if {${req.num} == "0" && [string match -nocase "*<div class=\"cities_by_name\">*" $html]} {
if {[string match -nocase "*  *  *" $html]} {
putserv "PRIVMSG $chan :  ."
return
}
regsub -nocase -- {^.*?<div class="cities_by_name">} $html "" html
set c.found [list]
set html [string map -nocase {"<li><a href=" "\n<li><a href="} $html]
foreach _ [split $html \n] {
if {[regexp -nocase -- {<li><a href="(.*?)"><span><b>(.*?)</span></a>} $_ -> cityurl cityname]} {
lappend c.found [list [regsub -all -- {<.*?>} $cityname ""] $cityurl]
}
}
if {![llength ${c.found}]} {
putserv "PRIVMSG $chan :$nick:      ..."
return
}
set founds [llength ${c.found}]
if {$wnum > $founds} {set wnum 0}
set c.line [lindex ${c.found} $wnum]
set query [lindex ${c.line} 0]
set newurl [lindex ${c.line} 1]
if {$nd >= "1"} {append newurl "$nd/"}
if {[catch {
if {[string range $newurl 0 6] eq "http://"} {set sturl ""} {set sturl "http://m.gismeteo.ru"}
set token [::http::geturl "$sturl$newurl" -timeout 20000 -command [list [namespace current]::got_data $nick $uhost $chan $nd $query $wnum ${req.num} $founds]]
} err]} {
putquick "NOTICE $nick :   .  : $err"
unset err
return
}
return
} else {
regexp -nocase -- {<div class="date">(.*?)</div>} $html -> day
regexp -nocase -- {class="triangle">(.*?)</} $html -> city
if {[string is space $city]} {set city [string totitle $query]}
if {[info patchlevel] >= "8.5"} {
if {[catch {set day [clock scan [string map -nocase {"" "Sun" "" "Mon" "" "Tue" "" "Wed" "" "Thu" "" "Fri" "" "Sat" "" "Jan" "" "Feb" "" "Mar" "" "Apr" "" "May" "" "Jun" "" "Jul" "" "Aug" "" "Sep" "" "Oct" "" "Nov" "" "Dec" "." ""} $day] -format "%a %e %b %Y"]} err]} {
putlog "\[weather\] Warning! $err"
if {$nd eq 1} {set day ""} else {set day "$day ()"}
} else {
set day [clock seconds]
if {$nd >= 1} {set day [expr $day + (86400*$nd)]}
set day "[string map {Sun "," Mon "," Tue "," Wed "," Thu "" Fri "," Sat "," Jan  Feb  Mar  Apr  May  Jun  Jul  Aug  Sep  Oct  Nov  Dec } [clock format $day -format "%a %e %b %Y"]] ."
}
} else {
if {$nd eq 1} {set day ""} else {set day "$day ()"}
}
set html [string map {\t "" \r "" \n "" {<tbody>} \x0A {"tbody"} \x0A} $html]
set weatherdata [list]
foreach _ [split $html \x0A] {	
if {[regexp -nocase -- {<tr><th.*?>(.*?)</th>.*?<td class="clpersp"><p>(.*?)</p></td><td class="temp">(.*?)</td>.*?<(dt|td)>:</(dt|td)>.*?<strong>(\d+)</strong>.*?<(dt|td)>:</(dt|td).*?<strong>(\d+\%)</strong>.*?<(dt|td)>:</(dt|td)>.*?<strong>(.*?)</strong>.*?<strong>(.*?)</strong>\s?/</.*?</tbody>} $_ -> days sky temp trash1 trash2 pres trash3 trash4 hum trash5 trash6 wind1 wind2] || [regexp -nocase -- {<th.*?>(.+?)</th>.*?<td class=.*?>(.+?)&deg;</td>.*?clpersp"><p>(.+?)</p>.*?>:.*?<strong>(.+?)</strong>.*?>:.*?<strong>(\d+\%)</strong>.*?>:.*?<strong>(.+?)</strong>,\s*?<strong>(\d+)</strong>.*?</tr>} $_ - days temp sky pres hum wind1 wind2]} {
lappend weatherdata [list $day [string map -nocase {"" "" "" "" "" "" "" ""} $days] [string tolower $sky] [colorifier [string map {"" "$::gcolor(14) C" "&deg;" "$::gcolor(14) C"} [string trim [regsub -nocase -- "<span.*?;\">" $temp ""]]]] "$pres .." $hum [join [list [string map -nocase {"" "-" "" "-" "" "-" "" "-" "" "" "" "" "" "" "" "" "" " 0" "" ""} $wind1] "$wind2 /"]]]
}
}
}
}
if {![string is digit -strict $ncode]} {set ncode "N/A"}
if {![llength $weatherdata]} {putserv "PRIVMSG $chan :$nick:     ($ncode && $http_header)."; unset -nocomplain weather(host,$uhost); return 0}	
if {$founds > 1} {set rezs "$::gcolor(14)\[$::gcolor(6)[expr $wnum +1]$::gcolor(14)/$founds\] "} else {set rezs ""}
if {[llength $weatherdata] >= 3} {
set msg ""
set msg_ ""
foreach {day days_ sky_ temp_ pres_ hum_ wind_} [join [lrange $weatherdata 0 1]] {
regsub -all {\s+} $sky_ " " sky_
append msg " $::gcolor(5)$days_ $::gcolor(14)- : $::gcolor(6)$temp_$::gcolor(14), : $pres_$::gcolor(14), : $wind_, : $hum_,$::gcolor(6) $sky_$::gcolor(14);\003"
}
regsub -all {\s+} $day " " day
putquick "PRIVMSG $chan :${rezs}$::gcolor(14)   $::gcolor(5)$city$::gcolor(14)  $::gcolor(5)$day$::gcolor(14):"; putquick "PRIVMSG $chan :[string trim $msg]"
foreach {day days_ sky_ temp_ pres_ hum_ wind_} [join [lrange $weatherdata 2 end]] {
regsub -all {\s+} $sky_ " " sky_
append msg_ "$::gcolor(14); $::gcolor(5)$days_ $::gcolor(14)- : $::gcolor(6)$temp_$::gcolor(14), : $pres_, : $wind_, : $hum_,$::gcolor(6) $sky_\003"
}
putquick "PRIVMSG $chan :[string range $msg_ 5 end]$::gcolor(14)."
} else {
foreach {day days_ sky_ temp_ pres_ hum_ wind_} [join [lrange $weatherdata 0 1]] {
regsub -all {\s+} $sky_ " " sky_
append msg " $::gcolor(5)$days_ $::gcolor(14)- : $::gcolor(6)$temp_$::gcolor(14), : $pres_, : $wind_, : $hum_,$::gcolor(6) $sky_$::gcolor(14);\003"
}
regsub -all {\s+} $day " " day
putquick "PRIVMSG $chan :${rezs}$::gcolor(14)   $::gcolor(5)$city$::gcolor(14)  $::gcolor(5)$day$::gcolor(14):"; putquick "PRIVMSG $chan :$msg"
}
unset -nocomplain weather(host,$uhost)
}

proc colorifier {temp} {
set temp [regsub -all -- {\+(\d+)} $temp "$::gcolor(6)+\\1$::gcolor(14)"]
set temp [regsub -all -- {\-(\d+)} $temp  "$::gcolor(12)-\\1$::gcolor(14)"] 
return $temp
}

proc dcc_weatherupdate {hand idx args} {
variable file
variable agent
putlog "::weather:: Updating database started..."
::http::config -useragent $agent
if {[catch {set token [::http::geturl "http://bar.gismeteo.ru/gmbartlist.xml" -timeout 20000 -binary 1]} err]} {putlog "::weather:: Updating failed. Error while connecting to server: $err"; return 0}
set status [::http::status $token]
set code [::http::ncode $token]
if {$status eq "timeout"} {
putlog "::weather:: Updating failed. Timeout connect to server."
::http::cleanup $token
return
}
if {$code ne "200" || $status ne "ok"} {
putlog "::weather:: Updating failed. Server returned a $code error code. Http-status is: ${status}."
::http::cleanup $token
return
}
set data [encoding convertfrom cp1251 [::http::data $token]]
::http::cleanup $token
set citys [list]
foreach _ [split $data \n] {
if {[regexp -nocase -- {^<t\ n="(.*?)"\ i="(\d+)"\ c=.*?>} $_ -> city index]} {lappend citys "[string tolower $city] \#$index";}
}
if {![llength $citys]} {putlog "::weather:: Updating failed! Error while parsing data."; return 0}
set f [open $file w+]
fconfigure $f -encoding cp1251
foreach _ $citys {
puts $f $_
}
close $f
putlog "::weather:: Update complete! Database now contents [llength $citys] cities."
}
variable usexml
}