####################################################
# Windrop  Vladislav 
# : Vertigo
# : 0.1
# :       ICQ
# : ! !+
####################################################

namespace eval ::icqinfo {

	bind pub - $::gprefix(1)icq+ "[namespace current]::pub 0"
	bind pub - $::gprefix(1)+ "[namespace current]::pub 0"
	bind pub - $::gprefix(1)icq  "[namespace current]::pub 1"
	bind pub - $::gprefix(1)  "[namespace current]::pub 1"

	variable timeout               "25000"
	variable uagent                "Opera/9.80 (Windows NT 6.1; U; ru) Presto/2.6.30 Version/10.60"
	variable timer                   "10"
        variable flagactas		"no"
        variable chflag			"$flagactas[namespace tail [namespace current]]"
        setudef  flag 			$chflag

proc pub {{short "0"} nick uhost hand chan text} {
variable chflag ; variable flagactas
variable timeout; variable uagent; variable timer			
if {![channel get $chan $chflag] ^ $flagactas eq "no" } { return }
set text [string map {- ""} [stripcodes bcruag $text]]
if {[string is space $text]} {
if {$short == "1"} {
putserv "NOTICE $nick :: $::gprefix(1) \< ICQ\> -     ICQ."; return } else {
putserv "NOTICE $nick :: $::gprefix(1)+ \< ICQ\> -       ICQ."; return }
}
if {[info exists [namespace current]::check(lasttime,$uhost)] && [expr $[namespace current]::check(lasttime,$uhost) + $timer] > [clock seconds]} { putserv "NOTICE $nick :      $timer ."; return }
set [namespace current]::check(lasttime,$uhost) [clock seconds]
if {![regexp -- {^([0-9]{5,9})$} $text]} { putserv "PRIVMSG $chan :$nick:   ICQ    5  9 ."; return }
::http::config -useragent $uagent
if {[catch {set token [::http::geturl "http://www.icq.com/people/$text/&lang=ru" -timeout $timeout -command [list [namespace current]::data $nick $chan $text $short]]} err]} {putserv "NOTICE $nick :    ."; putlog "::icqinfo:: connecting error: $err"; return 1}
}

proc data {nick chan text short token} {
set status [::http::status $token]
set code [::http::ncode $token]
if {$status eq "error"} {
putserv "NOTICE $nick :   ."
putlog "::icqinfo:: data error: [::http::error $token]"
::http::cleanup $token
return
}
if {$status eq "timeout"} {
putserv "NOTICE $nick :   - ."
putlog "::icqinfo:: data error: timeout"
::http::cleanup $token
return
}
if {$code ne "200"} {
putserv "NOTICE $nick :   -   ."
putlog "::icqinfo:: data error: http-code is [::http::code $token]"
::http::cleanup $token
return
}
	set data [::http::data $token]
	::http::cleanup $token
	set userstatus ""
	regexp -nocase -- {<img\ssrc="http://c.icq.com/people/img/(online|offline|away|occupied)\.gif"\salt=".*?"\stitle=".*?">} $data -> userstatus
	set userstatus [string map -nocase {online "%c10 " offline "%c04  " away "%c07" occupied "%c02"} $userstatus]
        if {[regexp -nocase -- {<td class="sb-l2-r" id="big_status_line">(.*?)</td>} $data -> userstatus2]} { if {$userstatus2 != " ?"} {set out2 " $::gcolor(14)($::gcolor(7)$userstatus2$::gcolor(14)) "} {set out2 ""} } {set out2 ""}
        if {[regexp -nocase -- {<div class=".*?" id="not_friend_flname">(.*?)</div>} $data -> usersname]} {set out3 " $::gcolor(6)$usersname$::gcolor(14) "} {set out3 ""}
	regsub -- {^.*?<!-- Short Profile -->|^.*?id="shortprofile">} $data "" data
	set data [string map {\n "" \r "" \t ""} $data]
	regsub -all -nocase -- {<div class="d1-.*?\sinfo_line">} $data "\n" data
	set res [list]
	foreach _ [split $data \n] {
	if {[regexp -nocase -- {<div class="info_name">(.+?)</div>.*?<div class="info_value">(.+?)</div>} $_ -> name value]} {
	if {$value != $text} {lappend res "$::gcolor(14)$name:$::gcolor(6) $value"}
	}
	}
	set res [string map {{&amp;} {&} {&nbsp;} { } {&gt;} {>} {&lt;} {<} {&quot;} {"} {&#039;} {'}} $res]
	if {![llength $res]} {
	if {$userstatus eq ""} { putserv "PRIVMSG $chan :      $text."; return} else {putserv "PRIVMSG $chan :$::gcolor(14)$::gcolor(5) $text $::gcolor(14)- \002[::egglib::meta_to_colors $userstatus]\002"; return}
        }
	set out ""
	if {$userstatus ne ""} {append out "$::gcolor(14)$::gcolor(5) $text $::gcolor(14)- \002[::egglib::meta_to_colors $userstatus]\002"} else {append out "$::gcolor(14)$::gcolor(5) $text $::gcolor(14)- \002\002"}
	if {$short == "0"} {append out " $::gcolor(14)::$out3$out2-> [string map {{&quot;} {"}} [join $res "$::gcolor(14); "]]"}
	regsub -all {\s+} $out " " out; ::ccs::put_msgdest $chan $out
	}
	return
}