####################################################
# Windrop  Vladislav 
# : anaesthesia
# : 1.18
# :     . 
# : !
####################################################

namespace eval kino {
#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    , ,   
	variable author			"anaesthesia"
	variable version		"1.18"
	variable date			"09-11-2011"
	variable unamespace	        [namespace tail [namespace current]]

	#     (   )
	variable pubprefix 		$::gprefix(1)
	variable pubflag		{-|-}

	#   ()
	# pubcmd:_ "1 2 ..."
	#     ,      
	variable pub:kino	       "$unamespace "

	#    ,   
	variable msgprefix		$::gprefix(1)
	variable msgflag		{-|-}

	#       
	variable msg:kino		${pub:kino}

	#*      ,      
	#*     variable [pub|msg]:handler "string ..."

	#     
	variable		m_template	{$::gcolor(5)%% ::\003 \002\002 %% $::gcolor(5)@\003 \037$::gcolor(12)%%\003\037 \n%% \n\002 \002: %% \n%% \n%%}
	#     
	variable		a_template	{%_% \n%_%}

	#      
	#  $unick, $uhost, $uchan
	#  tcl ,    id   .
	variable requserid		{$uhost}
	
	#        id
	variable maxreqperuser	        5

	#     
	variable maxrequests	        15

	#   ,       ,  
	variable pause		        15
	
	#  -
	#   "proxyhost.dom:proxyport"   ,  -  
	variable proxy 			{}

	#   ,   "" --  
	# ,         --  
	#  "no"        
	#         
	# (      ,     )
	variable flagactas		"no"
	
	#   ,   /   
	#          
	#        
	#      
	variable chflag			"$flagactas$unamespace"
	setudef  flag 			$chflag

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    --     
	#     
	variable logrequests	{'$unick', '$uhost', '$handle', '$uchan', '$ustr'}
	
	#     ,   --  
	#  $uchan & $unick
	variable pubsend		{PRIVMSG $uchan :}

	#     ,   --  
	#   $unick ($uchan == $unick)
	variable msgsend		{PRIVMSG $unick :}
	
	#    / 
	#  $unick
	variable errsend		{NOTICE $unick :}

	#      
	variable maxredir		4
	
	#    ,   30 
	variable timeout		30000

	#    
	variable err_ok		        {  }

	#     ,     
	#       
	variable err_fail		{     .      -.}

	#     
	variable err_queue_full	{           .   .}
	
	#       id
	variable err_queue_id	{    .}
	
	#          
	#   $timewait --  ,   
	#   
	variable err_queue_time {   .       $timewait .}
	
#----------------------------------------------------------------------------
#     
#----------------------------------------------------------------------------

	# ,     
	variable 		searchurl		"http://s.kinopoisk.ru"
	variable 		fetchurl		"http://www.kinopoisk.ru"
		
	#  
	variable 		reqqueue
	array unset 	        reqqueue

	#  
	variable 		laststamp
	array unset		laststamp 

#---body---

	proc msg:kino {unick uhost handle str} {pub:kino $unick $uhost $handle $unick $str ; return}

	proc pub:kino {unick uhost handle uchan str} {
		variable requserid ; variable unamespace
		variable chflag ; variable flagactas ; variable logrequests
		variable pubprefix ; variable pubsend ; variable msgsend ; variable errsend
		variable maxres ; variable type ; variable src
		variable fetchurl ; variable searchurl
		set id [subst -noc $requserid]
		set prefix [subst -noc $errsend]
		if {$unick ne $uchan} {if {![channel get $uchan $chflag] ^ $flagactas eq "no" } { return }}
		set why [queue_isfreefor $id]
		if {$why != ""} {lput puthelp $why $prefix ; return}

#---
		set ustr $str
		if {[regexp -nocase -- {\?} $ustr]} {regsub -- {\?\s*} $ustr "" ustr ; set src 1} {set src 0}
		::http::config -urlencoding utf-8 -useragent "Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; PPC; 240x320)"	
		if {[string is space $ustr]} {
		if {$uchan eq $unick} {set prefix [subst -noc $msgsend]} {set prefix [subst -noc $errsend]}
		lput puthelp ": $::gprefix(1) <> ::      ." $prefix		
		return
		}
		if {$logrequests ne ""} {set logstr [subst -noc $logrequests] ; lput putlog $logstr "$unamespace: "}
		if {[queue_add "${searchurl}/index.php?kp_query=[uenc $ustr cp1251]" $id "[namespace current]::kino:parser" [list $unick $uhost $uchan]]} {
		variable err_ok; if {$err_ok ne ""} {lput puthelp "$err_ok." $prefix}
		} {
		variable err_fail ; if {$err_fail ne ""} {lput puthelp "$err_fail" $prefix}
		}
	       return
	       }

#---parser
	proc kino:parser {errid errstr body extra} {
		upvar $errid lerrid $errstr lerrstr $body lbody $extra lextra
		variable err_fail ; variable pubsend ; variable msgsend ; variable errsend
		variable maxres ; variable src ; variable fetchurl ; variable m_template ; variable a_template ;  variable searchurl
		foreach {unick uhost uchan ustr} $lextra {break}
		if {$lerrid ne {ok}} {lput putserv [subst -noc $err_fail] [subst -noc $errsend] ; return}
		if {$uchan eq $unick} {set prefix [subst -noc $msgsend]} {set prefix [subst -noc $pubsend]}
		if {[info exists ::sp_version]} {set str [encoding convertfrom cp1251 $lbody]} {set str $lbody}

#----------------------------------------------------------------------------
##---parser-specific------
#----------------------------------------------------------------------------

	regsub -all -- "\n|\r|\t" $str "" str
        if {[regexp -nocase -- {<h2.*?> ,      ...</h2>} $str]} {lput putserv "\037  \037." $prefix; return}
	if {$src} {
	if {[regexp -nocase -- {<div class="search_results">.*?<p class="header">(.*?)</p>(.*?)<div class="search_gray">} $str -> istr idata]} {
	set s2 ""
	foreach {- dt} [regexp -all -inline -- {<p class="name">(.*?)<span class="gray"><a} $idata] {regsub -all -- "<li.*?>.*?</li>" $dt "" dt ; set dt [string map {"<span class=\"year\">" "" "<span class=\"gray\">" "" "</span>" "" } $dt] ; regsub -all -- "<.*?>" $dt " " dt ; append s2 "$dt "} 
	lput putserv "$istr [sspace [sconv $s2]]" $prefix
	} {lput putserv "\037 \037." $prefix}
	return
	}
	set m_tit "" ; set m_dat ""
	set m_desc "" ; set m_act ""
	set m_sim "" ; set a_dat ""
	set a_bf "" ; set m_rat ""
       set trivia "" ; set mimdb ""
	if {[regexp -nocase -- {<div class="element most_wanted">.*?<p class="name"><a href="(.+?)">(.+?)</a>} $str -> kurl kname]} {
        if {[string range $kurl 0 6] eq "http://"} {set furl ""} {set furl $fetchurl}
	queue_add "${furl}${kurl}" [unixtime] "[namespace current]::kino:parser" [list $unick $uhost $uchan "${furl}${kurl}"]
	} {
	if {[regexp -nocase -- {<!--    -->(.*?)<!-- /   -->} $str -> kinf]} {
	if {[regexp -nocase -- {<H1 style=.*?class="moviename-big".*?>(.+?)</H1>} $kinf -> kname]} {regsub -all -- "<.*?>" $kname "" kname ; set m_name [string map {{;} {}} [string trim [sconv $kname]]]}
                     regsub -all -- {<tr><td class="type"></td><td style="color: #555">-</td></tr>} $kinf "" kinf
                     regsub -all -- {<tr><td class="type"></td>.*?</td></tr>} $kinf "" kinf
                     regsub -all -- {<tr><td class="type"></td>.*?</td></tr>} $kinf "" kinf
                     regsub -all -- {<tr><td class="type"></td>.*?</td></tr>} $kinf "" kinf
                     regsub -all -- {<tr><td class="type"></td>.*?</td></tr>} $kinf "" kinf
                     regsub -all -- {<tr><td class="type"></td>.*?</td></tr>} $kinf "" kinf
                     regsub -all -- {<tr><td class="type"></td>.*?</td></tr>} $kinf "" kinf
                     regsub -all -- {<tr><td class="type"></td>.*?</td></tr>} $kinf "" kinf
                     regsub -all -- {<tr><td class="type"> MPAA</td>.*?</td></tr>} $kinf "" kinf
                     regsub -all -- {<tr><td class="type"></td><td.*?>-</td></tr>} $kinf "" kinf
                     regsub -all -- {</td></tr>} $kinf \n kinf
				  foreach kinfl [split $kinf \n] {
				  if {[regexp -nocase -- {<tr><td class="type".*?>(.*?)<td.*?>(.*?)$} $kinfl -> mtit mdat]} {
				  regsub -all -- "<.*?>" $mtit "" mtit ; regsub -all -- "<.*?>" $mdat "" mdat
                                  regsub -all -- ", \\.\\.\\." $mdat "" mdat
				  append m_dat "\002[sconv [sspace $mtit]]\002: [sspace [sconv [sspace $mdat]]] "
				  }
                                  if {[regexp -nocase -- {<td class="type"\s+></td>\s+<td class=""\s+>\s+<div style="position: relative">\s+<a href=".*?">(.*?)</a>} $kinfl -> mdat1]} {
				  regsub -all -- "<.*?>" $mdat1 "" mdat1
                                  regsub -all -- ", \\.\\.\\." $mdat1 "" mdat1
                                  append m_dat "\002\002: [sspace [sconv [sspace $mdat1]]] "
                                  }
                                  if {[regexp -nocase -- {<td class="type".*?></td>.*?<div style=".*?">\s+<a href.*?>(.*?)</a>} $kinfl -> mdat2]} {
				  append m_dat "\002\002: [sspace [sconv [sspace $mdat2]]] "
                                  }
                                  if {[regexp -nocase -- {<td .*?class="type".*?></td>.*?<div style.*?>\s+<a href.*?>(.*?)</a>} $kinfl -> mdat3]} {
				  append m_dat "\002\002: [sspace [sconv [sspace $mdat3]]] "
                                  }
                                  if {[regexp -nocase -- {<td .*?class="type".*?> \(\)</td>.*?<div style.*?><a href.*?>(.*?)</a>} $kinfl -> mdat4] || [regexp -nocase -- {<td .*?class="type".*?> \(\)</td>.*?<div style.*?>\s+<a href.*?>(.*?)</a>} $kinfl -> mdat4]} {
				  append m_dat "\002 ()\002: [sspace [sconv [sspace $mdat4]]] "
                                  }
                                  if {[regexp -nocase -- {<td .*?class="type".*?> \(\)</td>.*?<div style.*?>\s+<a href.*?>(.*?)</a>} $kinfl -> mdat6]} {
				  append m_dat "\002 ()\002: [sspace [sconv [sspace $mdat6]]] "
                                  }
                                  if {[regexp -nocase -- {  DVD</td>.*?<a href=.*?>(.*?)</a>} $kinfl -> mdat8]} {
				  append m_dat "\002DVD\002: [sspace [sconv [sspace $mdat8]]] "
                                  }
                                  }
			if {[regexp -nocase -- {<!--   -->(.*?)<!-- /  -->} $str -> kinf]} {
			regsub -all -- {<span class="title">(.*?)</span>} [string map {</a> ", "} $kinf] "\002\\1\002" kinf
			regsub -all -- "<.*?>" $kinf " " kinf
			append m_act "[string map {" ," ""} [sconv [sspace $kinf]]]/ "
			}
			if {[regexp -nocase -- {<span class="_reachbanner_">(.*?)</span>} $str -> mdesc]} {
			regsub -all -- "<.*?>" $mdesc "" mdesc
			set m_desc [sconv [sspace $mdesc]]
			}
                        if {[regexp -nocase -- {<span class="perc">(.*?)</span>.*?<span class="reviews_num">(.*?)</span>} $str -> perc percnum]} {set perc "\002\002: [sspace [sconv $perc]] ([sspace [sconv $percnum]])"} {set perc ""}
			if {[regexp -nocase -- {<li class='trivia'>(.*?)</li>} $str -> trivia]} {set trivia "\002  , :\002 [sspace [sconv $trivia]]"}
                        if {[regexp -nocase -- {<div class="block_2">.*?none">.*?<span>(.*?)</span>.*?<span.*?>(.*?)</span>.*?<div style=.*?>(.*?)<div class="block3">} $str -> mrate mraten mimdb] || [regexp -nocase -- {<div class="block_2">.*?none">.*?<span>(.*?)</span>.*?<span.*?>(.*?)</span>.*?<div class="block3">} $str -> mrate mraten]} {
			regsub -all -- "<.*?>" $mrate "" mrate ; regsub -all -- "<.*?>" $mraten "" mraten ; regsub -all -- "<.*?>" $mimdb "" mimdb
			set m_rat "\002\002: $mrate ([sspace [sconv $mraten]]) [sspace [sconv [string map {": " " \002\002: "} $mimdb]]] $perc"
			} {
                        if {[regexp -nocase -- {<span id="await_percent" class="perc">(.*?)</span>.*?<span>(.*?)</span>} $str -> mrate mraten]} {
			set m_rat "\002\002: $mrate ([sspace [sconv $mraten]]) $perc"
                        }
                        }
			if {[regexp -nocase -- {<dl id="film_recom".*?>.*?</dt>(.*?)<dd class="last">} $str -> msim]} {
                        regsub -all -nocase -- "<i></i>" $msim "" msim
			regsub -all -nocase -- "<i>" $msim "\[" msim ; regsub -all -nocase -- "</i>" $msim "\]" msim
			regsub -all -nocase -- "</dd>" $msim " \002|\002 " msim
			regsub -all -- "<.*?>" $msim " " msim
			set m_sim "\002\002: [sconv [sspace $msim]]"
                        regsub -all {\002\|\002$} $m_sim "" m_sim
	                }
		        }
		if {[regexp -nocase -- {<!--    -->(.*?)<!-- /   -->} $str -> ainf]} {
		if {[regexp -nocase -- {<H1.*?class="moviename-big">(.+?)</H1>} $ainf -> aname]} {regsub -all -- "<.*?>" $aname "" aname}
		regsub -all -- {</td></tr>} $ainf \n ainf
		foreach ainfl [split $ainf \n] {
		if {[regexp -nocase -- {<tr><td class="type".*?>(.*?)<td.*?>(.*?)$} $ainfl -> atit adat]} {
		regsub -all -- "<.*?>" $atit " " atit ; regsub -all -- "<.*?>" [string map {"<br />" ", "} $adat] "" adat ; regsub -all -- "" $atit "" atit ;
		append a_dat "\002[sconv [sspace $atit]]\002: [sconv [sspace $adat]] "
		}
		}
		if {[regexp -nocase -- {<!--   -->(.*?)<!-- /  -->} $str -> finf]} {
		regsub -all -- {<span class="title">(.*?)</span>} [string map {</a> " \002|\002 "} $finf] "\002\\1\002" bfilm
                regsub -all -- "<i>(.*?)</i>" $bfilm "" bfilm
		regsub -all -- "<.*?>" $bfilm " " bfilm
		append a_bf "[sconv [sspace $bfilm]]"
                regsub -all {\002\|\002$} $a_bf  "" a_bf 
		}
		}
		set m_link [string trimright $ustr "sr/1/"]
                set m_rat [string map {"IMDb" "\002IMDb\002" "" " "} $m_rat]
		if {$m_dat ne ""} {
                if {$m_desc == ""} {set m_desc " ."}
		foreach m_l [split [subst -noc [string map {%% \$m_name %% \$m_link %% \$m_dat %% \$m_act %% \$m_desc %% \$trivia %% \$m_rat %% \$m_sim} $m_template]] \n] {regsub -all -- {\s+} $m_l " " m_l; lput putserv [string trim [string map {"&nbsp" ""} $m_l]] $prefix}
		} {
		foreach m_l [split [subst -noc [string map {%_% \$a_dat %_% \$a_bf} $a_template]] \n] {lput putserv [string map {"&nbsp" ""} $m_l] $prefix}
		}
	        }
	        return
	        }		

#----------------------------------------------------------------------------
##---end-parser------
#----------------------------------------------------------------------------

	proc sspace {strr} {return [string trim [regsub -all {[\t\s]+} $strr { }]]}

	proc uenc {strr {encd {utf-8}}} {
	set str "" ; foreach byte [split [encoding convertto $encd $strr] ""] {scan $byte %c i ; if {[string match {[%<>"]} $byte] || $i < 65 || $i > 122} {append str [format %%%02X $i]} {append str $byte}}
	return [string map {%3A : %2D - %2E . %30 0 %31 1 %32 2 %33 3 %34 4 %35 5 %36 6 %37 7 %38 8 %39 9 \[ %5B \\ %5C \] %5D \^ %5E \_ %5F \` %60} $str]
        }

	proc sconv {strr} {
	set escapes {
        &nbsp; \x20 &quot; \x22 &amp; \x26 &apos; \x27 &ndash; \x2D
        &lt; \x3C &gt; \x3E &tilde; \x7E &euro; \x80 &iexcl; \xA1
        &cent; \xA2 &pound; \xA3 &curren; \xA4 &yen; \xA5 &brvbar; \xA6
        &sect; \xA7 &uml; \xA8 &copy; \xA9 &ordf; \xAA &laquo; \xAB
        &not; \xAC &shy; \xAD &reg; \xAE &hibar; \xAF &deg; \xB0
        &plusmn; \xB1 &sup2; \xB2 &sup3; \xB3 &acute; \xB4 &micro; \xB5
        &para; \xB6 &middot; \xB7 &cedil; \xB8 &sup1; \xB9 &ordm; \xBA
        &raquo; \xBB &frac14; \xBC &frac12; \xBD &frac34; \xBE &iquest; \xBF
        &Agrave; \xC0 &Aacute; \xC1 &Acirc; \xC2 &Atilde; \xC3 &Auml; \xC4
        &Aring; \xC5 &AElig; \xC6 &Ccedil; \xC7 &Egrave; \xC8 &Eacute; \xC9
        &Ecirc; \xCA &Euml; \xCB &Igrave; \xCC &Iacute; \xCD &Icirc; \xCE
        &Iuml; \xCF &ETH; \xD0 &Ntilde; \xD1 &Ograve; \xD2 &Oacute; \xD3
        &Ocirc; \xD4 &Otilde; \xD5 &Ouml; \xD6 &times; \xD7 &Oslash; \xD8
        &Ugrave; \xD9 &Uacute; \xDA &Ucirc; \xDB &Uuml; \xDC &Yacute; \xDD
        &THORN; \xDE &szlig; \xDF &agrave; \xE0 &aacute; \xE1 &acirc; \xE2
        &atilde; \xE3 &auml; \xE4 &aring; \xE5 &aelig; \xE6 &ccedil; \xE7
        &egrave; \xE8 &eacute; \xE9 &ecirc; \xEA &euml; \xEB &igrave; \xEC
        &iacute; \xED &icirc; \xEE &iuml; \xEF &eth; \xF0 &ntilde; \xF1
        &ograve; \xF2 &oacute; \xF3 &ocirc; \xF4 &otilde; \xF5 &ouml; \xF6
        &divide; \xF7 &oslash; \xF8 &ugrave; \xF9 &uacute; \xFA &ucirc; \xFB
        &uuml; \xFC &yacute; \xFD &thorn; \xFE &yuml; \xFF &#151; -
	}
	set strr [string map {\[ \\\[ \] \\\] \{ \\\{ \} \\\}} [string map $escapes [join [lrange [split $strr] 0 end]]]] 
  	regsub -all -- {&#([[:digit:]]{1,5});} $strr {[format %c [string trimleft "\1" "0"]]} strr
 	regsub -all -- {&#x([[:xdigit:]]{1,4});} $strr {[format %c [scan "\1" %x]]} strr
 	regsub -all -- {&#?[[:alnum:]]{2,7};} $strr "" strr
	return [subst -nov $strr]
	}

	proc lput {cmd str {prefix {}} {maxchunk 420}} {
	set buf1 ""; set buf2 [list]
	foreach word [split $str] {append buf1 " " $word ; if {[string length $buf1]-1 >= $maxchunk} {lappend buf2 [string range $buf1 1 end]; set buf1 ""}}
	if {$buf1 != ""} {lappend buf2 [string range $buf1 1 end]}
	foreach line $buf2 {$cmd $prefix$line}
	return
	}

	proc queue_isfreefor {{ id {}}} {
	variable reqqueue ; variable maxreqperuser ; variable maxrequests ; variable laststamp
	variable pause ; variable err_queue_full ; variable err_queue_id ; variable err_queue_time 
	if {[info exists laststamp(stamp,$id)]} {set timewait [expr {$laststamp(stamp,$id) + $pause - [unixtime]}] ; if {$timewait > 0} {return [subst -noc $err_queue_time]}}
	if {[llength [array names reqqueue -glob "*,$id"]] >= $maxreqperuser} {return $err_queue_id}
	if {[llength [array names reqqueue]] >= $maxrequests} {return $err_queue_full}		
	return
	}

	proc queue_add {newurl id parser extra {redir 0}} {
	variable reqqueue ; variable proxy ; variable timeout ; variable laststamp
	::http::config -proxyfilter "[namespace current]::queue_proxy"
	if {![catch {set token [::http::geturl $newurl -command [namespace current]::queue_done -binary true -timeout $timeout -headers {Accept-Charset {iso-8859-1, utf-8, utf-16, *;q=0.1}}]} errid]} {					
	set reqqueue($token,$id) [list $parser $extra $redir] ; set laststamp(stamp,$id) [unixtime]
	} {::http::config -proxyfilter http::ProxyRequired; return false}
        ::http::config -proxyfilter http::ProxyRequired
	return true
	}

	proc queue_proxy {url} {
	variable proxy
	if {$proxy ne {}} {return [split $proxy {:}]}		
	return [list]
	}
	
	proc queue_done {token} {
	upvar #0 $token state
	variable reqqueue ; variable maxredir ; variable fetchurl ; variable searchurl
	set errid  	[::http::status $token]
	set errstr 	[::http::error  $token]		
	set	id  	[array  names reqqueue "$token,*"]
	foreach {parser extra redir} $reqqueue($id) {break}
	regsub -- "^$token," $id {} id
	while (1) {
	if {$errid == "ok" && [::http::ncode $token] == 302} {
	if {$redir < $maxredir} {			
	array set meta $state(meta)
	if {[info exists meta(Location)]} {queue_add "$fetchurl$meta(Location)" $id $parser "$extra $fetchurl$meta(Location)" [incr redir] ; break}
	} {set errid "error" ; set errstr "Max. redir."}
	} 
	if {[catch {$parser {errid} {errstr} {state(body)} {extra}} errid]} {lput putlog $errid "[namespace current] "}
	break
	}			
	array unset reqqueue "$token,*"
	::http::cleanup $token
	return
	}

	proc queue_clear_stamps {} {
	variable laststamp ; variable timeout ; variable timerID
	set curr [expr {[unixtime] - 2 * $timeout / 1000}];
	foreach {id} [array names laststamp] {if {$laststamp($id) < $curr} {array unset laststamp $id}}		
	set timerID [timer 10 "[info level 0]"]
	}

	proc cmdaliases {{action {bind}}} {
	foreach {bindtype} {pub msg dcc} {
	foreach {bindproc} [info vars "[namespace current]::${bindtype}:*"] {
	variable "${bindtype}prefix" ; variable "${bindtype}flag"			
	foreach {alias} [set $bindproc] {catch {$action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc}}				
	}
	}	
	return
	}

#---init
	if {[info exists timerID]} {catch {killtimer $timerID} ; catch {unset timerID}}	
	[namespace current]::queue_clear_stamps
	[namespace current]::cmdaliases unbind
	[namespace current]::cmdaliases
}
