######################################################
# Windrop  Vladislav 
# : Buster
# : 01.01
# :    .
# : !
######################################################

namespace eval lun {

  variable pubprefix	$::gprefix(1)
  variable pub:lun	[list "-|-" "" ""]

  variable msgprefix	$pubprefix
  variable msg:lun	${pub:lun}

  variable maxreqperid	  1
  variable resttime	  30
  variable proxy	        ""
  setudef flag nolun

# ---------------------------------------------------------------------------
  variable fetchurl       "http://terr.ru"
  variable timeout        30

  variable errstr

  set errstr(ok)          "  ."
  set errstr(fail)        "   .  : '%error'."
  set errstr(tryagain)    "  ."
  set errstr(isfull)      "        . $errstr(tryagain)"
  set errstr(inprogress)  "     . $errstr(tryagain)"
  set errstr(noflood)     "      %time. $errstr(tryagain)"
  set errstr(aliases)     "  : %alias1n."
  set errstr(parserfail)  "    .      ?"

  set errstr(use)         ": %alias0 \[\]."
  set errstr(help)	  "      . $errstr(use)"
  
  variable putirc

  set putirc(pub)     	   "PRIVMSG %nick :"
  set putirc(msg)     	   "PRIVMSG %nick :"
  set putirc(notice)  	   "NOTICE %nick :"

# ---------------------------------------------------------------------------
#
# ---------------------------------------------------------------------------

  proc msg:lun {unick uhost uhandle ustr} {
  pub:lun $unick $uhost $uhandle $unick $ustr
  return
  }

  proc pub:lun {unick uhost uhandle uchan ustr} {
    variable fetchurl
    variable queueid
    variable errstr
    if {$unick ne $uchan} {if {[channel get $uchan nolun]} { return }}
    set ustr [stripcodes {bcruag} $ustr]
	variable putirc
	array set putpfx [string map [list {%nick} $unick {%channel} $uchan] [array get putirc]]
	if {[regexp -nocase -- {} $ustr]} {
	set query "tom=1"
	} else {
	set query "tom=0"
	}
    set id [set $queueid]
    ::http::config -useragent "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; .NET CLR 1.1.4322; .NET CLR 1.0.3705)"
    set errid [httpqueue_add "$fetchurl/ref/lun.php?$query" $id [namespace origin {parser}] [list $unick $uhost $uchan]]
    foreach { status cause } $errid { break }
    if { $status eq {ignore} } { return }
    lput putserv $cause -prefix $putpfx(notice) -wraplen 400
    return
    }

  proc parser { errid errtxt body extra } {
  upvar $errid lerrid $errtxt lerrtxt $body lbody $extra lextra
  foreach { unick uhost uchan } $lextra { break }
  variable errstr
  variable putirc
  array set putpfx [string map [list {%nick} $unick {%channel} $uchan] [array get putirc]]
  if { $lerrid ne {ok} } {
  lput puthelp $lerrtxt -prefix $putpfx(notice) -wraplen 400
  return
  }
      set data [encoding convertfrom cp1251 $lbody]
	set data [string map [list "\n" " " "<br>" ""]  $data]
	set ndpat "<b>(.+?)</b></font>(.+?)"
	set rlist [regexp -nocase -inline ".+?<h3>(.+?)</b>.+?$ndpat<font.+?>$ndpat<font.+?>$ndpat</table>" $data]
	set clist [list]
	set ptype [expr { $unick eq $uchan ? $putpfx(msg) : $putpfx(pub) }]
	if {[llength $rlist] == 0} {
	lput putserv $errstr(parserfail) -prefix $putpfx(notice) -wraplen 400
	return
	}
	foreach { val } [lrange $rlist 1 end] {
	lappend clist [regsub -all "\\s{2,}" [string trim $val] " "]
	}
	foreach { date tsym sym tchar char tdream dream } $clist { break }
	lput putserv "$::gcolor(5)$date\003" -prefix $ptype -wraplen 400
	lput putserv "$::gcolor(6)$tsym\003 $sym" -prefix $ptype -wraplen 400
	lput putserv "$::gcolor(6)$tchar\003 $char" -prefix $ptype -wraplen 400 -wordwrap true
	lput putserv "$::gcolor(6)$tdream\003 $dream" -prefix $ptype -wraplen 400
      return
      }

# ---------------------------------------------------------------------------
# Grabbed from esl-loader.tcl
#
# ---------------------------------------------------------------------------
  proc prerehash { type } {
    cleanup
  }

  proc startup { } {
    variable author
    variable version
    variable date

    bind EVNT -|- prerehash [namespace origin prerehash]

    autobinder true

    return
  }

  proc cleanup { } {
    variable author
    variable version
    variable date
    variable timerid
    variable httpqueue

    # unbind aliases
    autobinder false

    # kill cleanup timer if exists
    if { $timerid ne {} } {
      killutimer $timerid
    }

    # remove pending http requests
    foreach { request } [array names httpqueue -glob "http,*,*"] {
      regexp -- {^http,(.+?),} $request -> token
      ::http::reset $token
    }

    unbind EVNT -|- prerehash [namespace origin prerehash]


    namespace delete [namespace current]
    return
  }

# ---------------------------------------------------------------------------
# Grabbed from esl-http.tcl
#
# ---------------------------------------------------------------------------
  variable queueid        {uhost}
  variable queuelength    10


  variable    httpqueue
  array unset httpqueue

  variable    timerid     {}

  proc httpqueue_isfree { { id {} } } {
    variable httpqueue

    variable maxreqperid
    variable resttime
    variable queuelength

    variable errstr

    if { [info exists httpqueue(tstamp,$id)] } {
      foreach { laststamp floodcount } $httpqueue(tstamp,$id) { break }
      set timeremain [expr { $laststamp + $resttime - [unixtime]}]

      if { $timeremain > 0 } {

        if { $floodcount > 0 } {
          return [list {ignore} {}]
        }

        set httpqueue(tstamp,$id) [list $laststamp [expr { $floodcount + 1 }] ]
        return [list {noflood} [string map [list {%time} "$timeremain "] $errstr(noflood)]]
      }
    }

    if { [llength [array names httpqueue -glob "http,*,$id"]] >= $maxreqperid } {
      return [list {inprogress} $errstr(inprogress)]
    }

    if { [llength [array names httpqueue]] >= $queuelength } {
      return [list {isfull} $errstr(isfull)]
    }

    return [list]
  }

  proc httpqueue_add { url id parser extra {redir 0} } {

    variable httpqueue
    variable timeout
    variable timerid

    variable errstr

    set errid [httpqueue_isfree $id]

    if { [llength $errid] != 0 } {
      return $errid
    }

    ::http::config -proxyfilter "[namespace origin httpqueue_proxy]"

    set bFail [catch {
      set token [::http::geturl $url \
                  -command [namespace origin httpqueue_done] \
                  -binary true \
                  -timeout [expr { $timeout * 1000 }]]
    } errid]

    if { $bFail } {
      set str [string map [list {%error} $errid] $errstr(fail)]
      return [list {fail} $str]
    }

    set httpqueue(http,$token,$id) [list $parser $extra $redir]
    set httpqueue(tstamp,$id) [list [unixtime] 0]

    if { $timerid eq {} } {
      httpqueue_removeoldstamps
    }

    return [list {ok} $errstr(ok)]
  }

  proc httpqueue_done { token } {
    upvar #0 $token state

    variable httpqueue
    variable maxredirects
    variable errstr

    set uid   [array get httpqueue "http,$token,*"]
    set nids  [llength $uid]

    while { true } {
      if { $nids != 2 } {
        set errid "inconsistent state of 'httpqueue': [expr { $nids < 2 ? {no entry} : {too many entries} }] for '$token'"
        debugout $errid {error}
        break
      }

      set id [string map {"http,$token," {}} [lindex $uid 0]]
      foreach {parser extra redir} [lindex $uid 1] { break }

      set errid   [::http::status $token]
      set errtxt  [::http::error  $token]
      set ncode 	[::http::ncode $token]

      if { $errid eq {ok} && $ncode != 200} {
        set errid  $ncode
      	set errtxt [::http::code $token]
      }

      if { $errid ne {ok} } {
        set errtxt [string map [list {%error} $errtxt] $errstr(fail)]
      }

      set fFail [catch {
        $parser {errid} {errtxt} {state(body)} {extra}
      } errid]


      if { $fFail } {

        if { [info exists ::errorInfo] } {
          set einfo $::errorInfo
        } else {
          set einfo $errid
        }

        debugout $einfo {error}
      }

      break
    }

    array unset httpqueue "http,$token,*"
    ::http::cleanup $token

    return
  }

  proc httpqueue_removeoldstamps {} {
    variable timerid
    variable httpqueue
    variable timeout
    variable resttime

    set ttl [expr { [unixtime] - $resttime + 1 }]
    set tsl [array names httpqueue -glob "tstamp,*"]
    set n   [llength $tsl]

    foreach { id } $tsl {
      foreach { laststamp floodcount } $httpqueue($id) { break }
      if { $laststamp < $ttl } {
        array unset httpqueue $id
        incr n -1
      }
    }

    if { $n != 0 } {
      set timerid [utimer [expr { $resttime * 2 }] [namespace origin [info level 0]]]
    } else {
      set timerid {}
    }

    return
  }

  proc httpqueue_proxy { url } {
    variable proxy
    return [split $proxy {:}]
  }

# ---------------------------------------------------------------------------
# Grabbed from esl-core.tcl
#
# ---------------------------------------------------------------------------
  proc makehelpstr { { bindproc {} } } {
    variable errstr

    if { $bindproc eq {} } {
      set iproc [namespace origin [lindex [info level -1] 0]]
    } else {
      set iproc $bindproc
    }

    set aliases [list]

    foreach { pb } [binds $iproc] {
      foreach { type flags alias hits procname } $pb { break }
      if { $procname eq $iproc } {
        lappend aliases $alias
      }
    }

    set alias0  [lindex $aliases 0]
    set alias1n [join [lrange $aliases 1 end] {, }]

    set helpstr {}
    if { $alias0 ne {} } {
    set helpstr [string map [list {%alias0} $alias0] $errstr(help)]
    if { $alias1n ne {} } {
    append helpstr " " [string map [list {%alias1n} $alias1n] $errstr(aliases)]
    }
    }
    return $helpstr
    }

  proc lput { cmd str args } {

    array set opts {
      -prefix     {}
      -wordwrap   no
      -putsempty  no
      -wraplen    0
    }

    array set types {
      -wordwrap   boolean
      -putsempty  boolean
      -wraplen    integer
    }

    set options [array names opts]

    set usage   [join $options {, }]
    set optpat  ^-([join [string map {- ""} $options] |])$

    foreach { flag value } $args {
      if { [regexp $optpat $flag] } {
          if {[info exists types($flag)] && \
            ![string is $types($flag) -strict $value]} {
          return -code error "Bad value '$value' for option '$flag', must be $types($flag)"
        }
        set opts($flag) $value
      } else {
          return -code error "Unknown option '$flag', can be: $usage"
      }
    }

    set plen [string length $opts(-prefix)]

    foreach { line } [split $str "\n"] {
      set slen [string length $line]
      set idx  0

      while {true} {

        if { $opts(-wraplen) != 0 && [expr { $slen + $plen }] > $opts(-wraplen) } {
          set nll [expr {$opts(-wraplen) - $plen}]
          if { $opts(-wordwrap) } {
            set nlw [string wordstart $line [expr {$idx + $nll - 1}]]
            if { $nlw > $idx } {
              set nll [expr {$nlw - $idx}]
            }
          }

        } else {
          set nll $slen
        }

        set oline [string range $line $idx [expr { $idx + $nll - 1}]]

        incr slen -$nll
        incr idx   $nll

        if { $opts(-putsempty) || ![string is space $oline]  } {
          eval "$cmd [list $opts(-prefix)$oline]"
        }

        if { $slen == 0 } {
          break;
        }
      }
    }
  }

  # bind one handler to multiplies aliases
  proc bindhandler { isbind forcebind type flags prefix aliases handler } {
    foreach { alias } $aliases {
      set bindargs  [list $type $flags $prefix$alias]
      set existbind [eval "bind $bindargs"]
      if { $isbind } {
        if { $existbind ne {} } {
          debugout "'$bindargs' already binded to '$existbind'"
          if { ! $forcebind } {
            continue
          }
          debugout "'$bindargs' force bind to '$handler'"
        }
        eval "bind $bindargs $handler"
      } else {
        if { $existbind eq {} } {
          debugout "'$bindargs' not binded"
          continue
        }
        if { $existbind ne $handler } {
          debugout "'$bargs' binded to '$exbindproc', not '$bp'"
          if { ! $force } {
            continue
          }
          debugout "'$bargs' force unbind from '$exbindproc'"
        }
        eval "unbind $bindargs $handler"
      }
    }
    return
  }

  proc autobinder { action { force {false} } } {

    foreach { bt } {pub msg dcc} {
      variable "${bt}prefix"
      foreach { bp } [info vars "[namespace current]::${bt}:*"] {
        set flag [lindex [set $bp] 0]
        foreach { alias } [lrange [set $bp] 1 end]  {
          set bargs [list $bt $flag [set ${bt}prefix]$alias]
          set exbindproc [eval "bind $bargs"]
          if { $action } {
            if { $exbindproc ne {} } {
              debugout "'$bargs' already binded to '$exbindproc'"
              if { ! $force } {
                continue
              }
              debugout "'$bargs' force bind to '$bp'"
            }
            eval "bind $bargs $bp"
          } else {
            if { $exbindproc eq {} } {
              debugout "'$bargs' not binded"
              continue
            }
            if { $exbindproc ne $bp } {
              debugout "'$bargs' binded to '$exbindproc', not '$bp'"
              if { ! $force } {
                continue
              }
              debugout "'$bargs' force unbind from '$exbindproc'"
            }
            eval "unbind $bargs $exbindproc"
          }
        }
      }
    }

    return
  }

  proc debugout { str { severity {warning} } } {
  lput putlog $str -prefix "[namespace current] $severity: " -wraplen 400
  return
  }
  startup
  }