######################################################
# Windrop  Vladislav 
# : adium
# : 0.1
# :     http://icmp.ru/phraser/
# : !
######################################################

namespace eval phrase {
	variable unamespace	[namespace tail [namespace current]]
	variable pause		20
	variable msgspeed		2
	variable prefix	      $::gprefix(1)
	variable flags		"-"
	variable binds		[list "phrase" ""]

      setudef flag nophrase

	foreach b $binds { bind pub ${flags} "${prefix}${b}" [namespace current]::main }
	bind pub ${flags} "${prefix}" [namespace current]::main2

	proc main {nick uhost hand chan text} {
	variable prefix; variable msgspeed
      if {[channel get $chan nophrase]} { return }
	if {[checkflood $nick $uhost [namespace tail [lindex [info lev 0] 0]]]} {
	output $nick [subst {   .  [timewait $nick $uhost [namespace tail [lindex [info lev 0] 0]]] .   ...}] -speed $msgspeed -type ntc
	return 0
	}
	::http::config -useragent "Mozilla/5.0 (X11; U; Linux i686; ru-RU; rv:1.8.1) Gecko/2006101023 Firefox/2.0"
	set url [::http::geturl "http://icmp.ru/phraser/" -timeout 15000]
	set html [::http::data $url]
	::http::cleanup $url
	regsub -all -- (\t|\n) $html "" html
	set html [string trim $html]
	regexp -- {<br><b>(.*?)</b><br>(.*?)<br>} $html -> str2 str1
	output $chan [subst {$::gcolor(6)$str1 $::gcolor(5)\[$::gcolor(14)$str2$::gcolor(5)\]\003}] -speed $msgspeed -type msg
	}
	proc main2 {nick uhost hand chan text} {
	variable prefix; variable msgspeed
      if {[channel get $chan nophrase]} { return }
	if {[checkflood $nick $uhost [namespace tail [lindex [info lev 0] 0]]]} {
	output $nick [subst {   .  [timewait $nick $uhost [namespace tail [lindex [info lev 0] 0]]] .   ...}] -speed $msgspeed -type ntc
	return 0
	}
	::http::config -useragent "Mozilla/5.0 (X11; U; Linux i686; ru-RU; rv:1.8.1) Gecko/2006101023 Firefox/2.0"
	set url [::http::geturl "http://icmp.ru/phraser/" -timeout 15000]
	set html [::http::data $url]
	::http::cleanup $url
	regsub -all -- (\t|\n) $html "" html
	set html [string trim $html]
	regexp -- {<meta http-equiv="Content-Type" content="text/html;charset=koi8-r">(.*?)</td>} $html -> str
	output $chan [subst {$::gcolor(6)$str\003}] -speed $msgspeed -type msg
	}
	proc checkflood {nick uhost comm} {
	variable pause; variable lastcall; variable prefix
	if {[matchattr $nick n] || [matchattr $nick m] || [matchattr $nick o]} { return 0 } else {
	if {[info exists lastcall($comm,$uhost)]} {
	if {[expr [expr [unixtime] - $lastcall($comm,$uhost)] < $pause]} {
	set det [expr [unixtime] - $lastcall($comm,$uhost)]
	set wtime [expr $pause - $det]
	return 1
	}
	}
	}
	set lastcall($comm,$uhost) [unixtime]
	return 0
	}
	proc timewait {nick uhost comm} {
	variable pause; variable lastcall; return [expr { $lastcall($comm,$uhost) + $pause - [unixtime] }]
	}
	proc output {c s args} {
	importvars [list] $args [list speed 2 type msg]
	if {[string tolower $type] eq "msg"} {
	set t "PRIVMSG"
	} elseif {[string tolower $type] eq "ntc"} {
	set t "NOTICE"
	} else {
	return -code error "wrong args: should be \"[namespace current]::output chan string -speed NUM -type NAME\""
	}
	if {[regexp -- {\d+} $speed]} {
	if {$speed == "0"} {
	set msg [string range $s 0 end]
	append msg "\n"
	putdccraw 0 [string length $msg] $msg
	} elseif {$speed == "1"} {
	putquick "$t $c :$s"
	} elseif {$speed == "2"} {
	putserv "$t $c :$s"
	} elseif {$speed == "3"} {
	puthelp "$t $c :$s"
	} else { return -code error "wrong args: should be \"[namespace current]::output chan string -speed NUM -type NAME\"" }
	}
	}
	proc importvars {lo {la {}} {ln {}}} {
	set lvars [list]
	foreach {var value} $ln {uplevel [list set $var $value]; lappend lvars $var}
	foreach {flag value} $la {
	if {[string index $flag 0] == "-"} {
	set var [string range $flag 1 end]
	uplevel [list set $var $value]
	lappend lvars $var
	}
	}
	foreach var $lo {
	if {[lsearch $lvars $var] < 0} {
	set value [uplevel 2 "if {\[info exists $var\]} {set $var} else {set $var \"\"}"]
	uplevel [list set $var $value]
	}
	}
	}
}