####################################################
# Windrop  Vladislav 
# : Vertigo
# : 0.1
# :          moskva.fm
# : !
####################################################

namespace eval radioonline {

bind pub - $::gprefix(1) [namespace current]::pub
bind msg - $::gprefix(1) [namespace current]::msg

variable timeout "30" ;#    
variable flood "10" ;#    
variable numsongs "3" ;#     (    )

setudef flag noradio

variable stations [list " " FM  " FM" -FM " FM" " FM" " Jazz" \
" FM" " FM"  "Relax FM" " " " " " " " " \
" " " " FM "   " " " RU.FM "ROCK FM" \
" " " " " FM" " " " " " FM" " " \
" " " Romantika" " " " FM" " " "Best FM" " Classic" \
DFM " " - " "  " " Maximum NRJ " 7" "Next FM" \
" " " " "Love Radio" "  " " FM" " "]

proc msg {nick uhost hand text} {
pub $nick $uhost $hand $nick $text
return
}

proc pub {nick uhost hand chan text} {
variable flood; variable stations
if {[validchan $chan] && [channel get $chan noradio]} {return 1}
if {[info exists [namespace current]::lastreq] && [set diff [expr [clock seconds] - $[namespace current]::lastreq]] < $flood} {putserv "NOTICE $nick :  .    [expr $flood - $diff] ."; return}
set [namespace current]::lastreq [clock seconds]
regsub -all -- {[^a-z-A-Z-߸0-9\x20\_\-]} $text "" text
if {[string is space $text]} {
putserv "NOTICE $nick :: $::lastbind <> -    ,    ."
::ccs::put_msgdest -type notice $nick ": [join $stations ", "]."
return }
if {[set station [selectstation $text]] eq "none"} {putserv "NOTICE $nick :  '$text'   ."; return 1}
::http::config -urlencoding utf-8 -useragent {Opera/9.80 (Windows NT 6.1; U; en) Presto/2.7.39 Version/11.00}
variable timeout
if {[catch {set token [::http::geturl "http://m.moskva.fm/stations/$station" -timeout [expr $timeout * 1000] -binary false -command [list [namespace current]::data $nick $chan $text]]} err]} {putserv "NOTICE $nick : ,       ."; putlog "::radioonline::connect error: $err"; return}}

proc data {nick chan text token} {
set status [::http::status $token]
set ncode [::http::ncode $token]
if {$status ne "ok"} {::http::cleanup $token; putserv "PRIVMSG $chan :  ,       ."; return}
if {$ncode != "200"} {::http::cleanup $token; putserv "PRIVMSG $chan :    ($ncode).     ."; return}
set data [::http::data $token]
::http::cleanup $token
if {![regexp -nocase -- {<h2>(.+?)<span>(.*?FM)</span></h2>\s*<hr/>} $data - st_name st_freq]} {set station $text} else {set station "[string trim $st_name] ([string trim $st_freq])"}
regsub -all -- "\n|\r|\t" $data "" data
if {[string match -nocase "*    *" $data]} {putserv "NOTICE $nick :  \"$station\"     ."; unset -nocomplain data; return}
set data [string map -nocase {{<p><small>} \n} $data]
set songs [list]
foreach _ [split $data \n] {
if {[regexp -nocase -- {(\d+\:\d+)</small>.*?class="artist">(.*?)</a>.*?class="song">(.*?)</a>.*?</a></small>} $_ - time artist title]} {lappend songs "$::gcolor(6)$artist $::gcolor(14)-$::gcolor(6) $title $::gcolor(14)( $::gcolor(5) $time$::gcolor(14))"}
}
if {![llength $songs]} {unset -nocomlain data; putserv "NOTICE $nick :    ."; return}
variable numsongs; set radpes ""
foreach _ [lrange $songs 0 [expr $numsongs - 1]] {lappend radpes $_}
::ccs::put_msgdest $chan "$::gcolor(14)     \"$::gcolor(5)$station$::gcolor(14)\"   : [join $radpes " $::gcolor(12)| "]"; unset -nocomplain data songs
}

proc selectstation {name} {
switch -glob [string tolower $name] {
" " {return "FM_66.44"}
"fm" - 
"" {return "FM_68.84"}
"" {return "FM_72.92"}
"*" {return "FM_87.5"}
"*" {return "FM_87.9"}
"*" {return "FM_88.3"}
"*" {return "FM_88.7"}
"*jazz" -
"*" {return "FM_89.1"}
"*" {return "FM_89.5"}
"*" {return "FM_89.9"}
"" {return "FM_90.3"}
"relax*" {return "FM_90.8"}
" " {return "FM_91.2"}
"*" {return "FM_91.6"}
" " {return "FM_92.0"}
"*" {return "FM_92.4"}
"*" {return "FM_92.8"}
"**" {return "FM_93.2"}
"*" {return "FM_93.6"}
"*" -
"  *" {return "FM_94.0"}
" " {return "FM_94.4"}
"ru.fm" {return "FM_94.8"}
"rock*" {return "FM_95.2"}
"*" {return "FM_95.6"}
"*" {return "FM_96.0"}
"*" {return "FM_96.4"}
"*" {return "FM_96.8"}
" " {return "FM_97.2"}
"*" {return "FM_97.6"}
"*" {return "FM_98.0"}
"*" {return "FM_98.4"}
"*" -
"*romantika" {return "FM_98.8"}
"*" {return "FM_99.2"}
"*" {return "FM_99.6"}
" " {return "FM_100.1"}
"best*" {return "FM_100.5"}
"*" -
"*classic" {return "FM_100.9"}
"dfm" -
"*" {return "FM_101.2"}
"*" {return "FM_101.7"}
"*" {return "FM_102.1"}
" *" {return "FM_102.5"}
"*" {return "FM_103.0"}
"*" {return "FM_103.4"}
"*maximum" -
"*" {return "FM_103.7"}
"nrj" -
"**" {return "FM_104.2"}
" 7" {return "FM_104.7"}
"next*" {return "FM_105.2"}
"*" {return "FM_105.7"}
"*" {return "FM_106.2"}
"love*" {return "FM_106.6"}
" *" {return "FM_107.0"}
"*" {return "FM_107.4"}
" " {return "FM_107.8"}
default {return none}
}
}
}

if {![info exists ::ccs::version]} {die "!!! Not Found CCS.tcl !!!"}