######################################################
# Windrop  Vladislav 
# : Kreon
# : 2.1
# :          .
# : !
######################################################

namespace eval statslev {}

foreach bind [binds "::statslev::*"] { catch {unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]} }
foreach p [array names statslev *] { catch {unset statslev($p) } }

setudef flag norang

#######################

set statslev(rank) {"" "" "" "" "" "" "" "" "" " " "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" " "}
set statslev(drank) {50 100 200 300 400 500 750 1000 1500 2000 3000 4000 5000 6000 7000 8000 9000 10000 15000 20000 25000 35000 50000 70000 90000 100000 150000 200000 300000 400000}
set statslev(dmax) " !" 

bind pub - $::gprefix(1)   ::statslev::pubrang

proc ::statslev::pubrang {nick uhost hand chan text} {
	global statslev
        if {[channel get $chan norang]} {return}
	if { $text == "" } {
	set vict [nick2suser $nick $chan]
	} else {
	set vict [nick2suser $text $chan]
	if { $vict == "" || $vict == "*" } { set vict $text }
	}
	set userstat [getstats $vict $chan words]
	if {!$userstat} { putserv "PRIVMSG $chan :    $vict."; return }
	set honor ""; set ko 0
	foreach item $statslev(drank) { 
	if {$userstat <= $item} { set honor [lindex $statslev(rank) $ko]; break}
	incr ko 
	} 
	if {$honor == ""} {set honor $statslev(dmax)}
	incr ko
        putserv "PRIVMSG $chan :$::gcolor(5)$vict $::gcolor(14)  $::gcolor(6)$honor$::gcolor(14),  $::gcolor(6)$ko $::gcolor(14)($::gcolor(5)$userstat $::gcolor(14)[lindex {.   } [numgrp $userstat]]$::gcolor(14))\003"
        }

proc ::statslev::numgrp {number} { switch -glob -- "$number" { *11 {return 3} *12 {return 3} *13 {return 3} *14 {return 3} *1 {return 1} *2 {return 2} *3 {return 2} *4 {return 2} default {return 3} } }	

setudef flag join-rang
bind join - * ::statslev::join     
proc ::statslev::join {nick uhost hand chan} {     
global statslev botnick lasttime6
if {![channel get $chan join-rang]} {return}
if { $nick == $botnick } { return } 
set userstat [getstats $nick $chan words] 
if {!$userstat} { return } 
if {[info exists lasttime6]} {   
if {[expr [expr [unixtime] - $lasttime6] < 10]} { return }   
} 
set vict [nick2suser $nick $chan]
if { $vict == "" || $vict == "*" } { set vict $nick }
set honor ""; set ko 0 
foreach item $statslev(drank) {   
if {$userstat <= $item} { set honor [lindex $statslev(rank) $ko]; break} 
incr ko   
}   
if {$honor == ""} {set honor $statslev(dmax)} 
incr ko 
putserv "PRIVMSG $chan :$::gcolor(5)$vict $::gcolor(14)  $::gcolor(6)$honor$::gcolor(14),  $::gcolor(6)$ko $::gcolor(14)($::gcolor(5)$userstat $::gcolor(14)[lindex {.   } [numgrp $userstat]]$::gcolor(14))\003" 
set lasttime6 [unixtime]    
return    
}