####################################################
# Windrop  Vladislav 
# : tvrsh
# : 1.0
# :    .
# : !
####################################################

namespace eval synonims {
foreach p [array names synonims *] { catch {unset synonims($p) } }

setudef flag nosynonims

###                            ###
#     : #
# ______________________________ #
###                            ###
	variable synonims
	array set synonims {
	binds {synonims }
	msg 1
	delay 10
	}

###                                                                  ###
#     ,       TCL: #
# ____________________________________________________________________ #
###                                                                  ###

#  .
foreach bind [split $synonims(binds) " "] {
bind pub -|- "$::gprefix(1)$bind" ::synonims::synonims_pub
if {$synonims(msg) >= 1} { bind msg -|- "$::gprefix(1)$bind" ::synonims::synonims_msg }
}

#    .
proc ::synonims::synonims_msg {nick uhost hand text} {
variable synonims
::synonims::synonims_proc $nick $uhost $hand $nick $text
}

#    .
proc ::synonims::synonims_pub {nick uhost hand chan text} {
variable synonims
if {[channel get $chan nosynonims]} { return }
::synonims::synonims_proc $nick $uhost $hand $chan $text
}

#   .
proc ::synonims::synonims_proc {nick uhost hand chan text} {
variable synonims
if {$text == ""} { putserv "NOTICE $nick :: $::gprefix(1) <>"; return }
if {[info exists synonims(lasttime,$chan)] && [expr $synonims(lasttime,$chan) + $synonims(delay)] > [clock seconds]} {
putserv "NOTICE $nick :      $synonims(delay) [lindex {.   } [::synonims::numgrp $synonims(delay)]]."
putserv "NOTICE $nick : [expr $synonims(delay) - [expr [clock seconds] - $synonims(lasttime,$chan)]] [lindex {.   } [::synonims::numgrp [expr $synonims(delay) - [expr [clock seconds] - $synonims(lasttime,$chan)]]]]   ."
return 0
}
    set synonims_tok [::http::config -urlencoding "cp1251" -useragent "Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; PPC; 240x320)"]
    set synonims_tok [::http::geturl "http://www.synonyms.ru/display.php?action=search&word=$text"]  
    set data [::http::data $synonims_tok]
    set data [encoding convertfrom cp1251 $data] 
    ::http::cleanup $synonims_tok
    regexp {</form>(.*?)<div align="center">} $data "" data
    regsub -all -- {\<[^\>]*\>|\n} $data "" data
    set data [string trim [join $data] "&nbsp;"]
    set data [string map {&nbsp; "$::gcolor(14), $::gcolor(5)"} $data]
    if {![llength $data]} {putserv "PRIVMSG $chan :  ."; return }
    set msg "$::gcolor(14)  $::gcolor(5)$text $::gcolor(14)( $::gcolor(6)[llength $data]$::gcolor(14)):$::gcolor(5) "
    append msg "$data$::gcolor(14).\003"
    ::synonims::largetext PRIVMSG $chan [subst -nocommands $msg]
    set synonims(lasttime,$chan) [clock seconds]
    return 0
}

proc ::synonims::largetext {type target text {delims {" ",.!?}}} {
     global synonims
     regsub -all {\s+} $text " " text
     regsub -all {\{} $text "" text
     regsub -all {\}} $text "" text
     set text [string map {&nbsp; " " &#1093; } $text]
     set lineLen [expr 512 - [string length ":$::botname $type [join $target] :\r\n"]]
     if {[string length $text] <= $lineLen} { 
     putserv "$type $target :$text"
     return 0
     }
    set _text [split $text $delims]
    set x 0
    set i 0
    while {$x < $lineLen} {
    if {$i >= [llength $_text]} { 
    return 0
    }
    set wordlen [string length [lindex $_text $i]]
    if {$x + $wordlen > $lineLen} { 
    break
    }
        incr x $wordlen
        incr x
        incr i
    }
putserv "$type $target :[string range $text 0 [expr $x - 1]]"
set color [string range [lindex [split $text "\003"] [expr [llength [split $text "\003"]] -1]] 0 1]
if {![isnumber $color]} {set color ""}
::synonims::largetext $type $target \003$color$::gcolor(5)[string trimleft [string range $text $x end]] $delims
}


proc ::synonims::numgrp {number} { 
    switch -glob -- "$number" { 
        *11 {return 3} 
        *12 {return 3} 
        *13 {return 3} 
        *14 {return 3} 
        *1 {return 1} 
        *2 {return 2} 
        *3 {return 2} 
        *4 {return 2} 
        default {return 3} 
    }
}
}