######################################################
# Windrop  Vladislav
# : anaesthesia
# : 1.3.5
# :    grooveshark.com / vpleer.ru / youtube.com
# : !3
######################################################

namespace eval tsong {
#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    , ,   
	variable author			"anaesthesia"
	variable version		"1.3.5"
	variable date			"28-Dec-2011"
	variable unamespace		[namespace tail [namespace current]]

	#     (   )
	variable pubprefix 		{}
	variable pubflag		{-|-}

	#   ()
	# pubcmd:_ "1 2 ..."
	#     ,      
	variable pub:tsong		"$::gprefix(1)mp3 $::gprefix(1)3 np: np :"

	#    ,   
	variable msgprefix		{}
	variable msgflag		{-|-}

	#       
	variable msg:tsong		${pub:tsong}
	variable act:tsong		${pub:tsong}

	#*      ,      
	#*     variable [pub|msg]:handler "string ..."

	#      
	#  $unick, $uhost, $uchan
	#  tcl ,    id   .
	variable requserid		{$uhost}
	
	#        id
	variable maxreqperuser	        5

	#     
	variable maxrequests	        15

	#   ,       ,  
	variable pause			5
	
	#  -
	#   "proxyhost.dom:proxyport"   ,  -  
	variable proxy 			{}

	#   ,   "" --  
	# ,         --  
	#  "no"        
	#         
	# (      ,     )
	variable flagactas		"no"
	
	#   ,   /   
	#          
	#        
	#      

	variable chflag		        "$flagactas$unamespace"
	setudef  flag 		        $chflag

	# API key  tinysong.com (  http://tinysong.com/api    )
	variable tskey		        "d3ab776da40b2c82bc48002aba4460d9"

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    --     
	#     
	variable logrequests	       {'$unick', '$uhost', '$handle', '$uchan', '$ustr'}
	
	#     ,   --  
	#  $uchan & $unick
	variable pubsend		{PRIVMSG $uchan :}

	#     ,   --  
	#   $unick ($uchan == $unick)
	variable msgsend		{PRIVMSG $unick :}
	
	#    / 
	#  $unick
	variable errsend		{NOTICE $unick :}

	#      
	variable maxredir		4
	
	#    
	variable timeout		40000

	#    
	variable err_ok			{}

	#     ,     
	#       
	variable err_fail		{}

	#     
	variable err_queue_full	        {}
	
	#       id
	variable err_queue_id	        {}
	
	#          
	#   $timewait --  ,   
	#   
	variable err_queue_time         {}
	
#----------------------------------------------------------------------------
#     
#----------------------------------------------------------------------------

	#    
	variable arep		1

	#    ()
	variable adel		10

	# ,     
	variable 		fetchurl		"http://tinysong.com/s/"
	variable 		fetchurl3		"http://vpleer.ru/?q="
	variable		furlyt			"http://gdata.youtube.com/feeds/api/videos?orderby=relevance&start-index=1&max-results=1&racy=include&vq="

	#  
	variable 		reqqueue
	array unset 	        reqqueue

	#  
	variable 		laststamp
	array unset		laststamp 

#---
	variable tdbg		0
#---

#---body---

	proc msg:tsong {unick uhost handle str} {pub:tsong $unick $uhost $handle $unick $str ; return}

	proc act:tsong {unick uhost uhand uchan ukey {str ""}} {
	variable act:tsong ; variable parm
	set parm "" ; set gout "" ; set vout "" ; set noud 1 ; set yout ""
	if {$uchan eq $::botnick} {set uchan $unick}
	if {[lindex [split $str] 0] in ${act:tsong}} {set sng [lrange $str 1 end]} {return} 
    	pub:tsong $unick $uhost $uhand $uchan [string trim $sng]
	}

	proc pub:tsong {unick uhost handle uchan str} {
		variable requserid ; variable unamespace
		variable chflag ; variable flagactas ; variable logrequests ; variable tskey
		variable pubprefix ; variable pubsend ; variable msgsend ; variable errsend
		variable furly ; variable furlyt ; variable query ; variable fetchurl ; variable fetchurl3 ; variable furl2 ; variable parm ; variable noud ; variable vout
		set id [subst -noc $requserid]
		set prefix [subst -noc $errsend]
		if {$unick ne $uchan} {if {![channel get $uchan $chflag] ^ $flagactas eq "no" } {return}}
		set why  [queue_isfreefor $id]
		if {$why != ""} {lput puthelp $why $prefix ; return}
		set query "" ; set parm "" ; set gout "" ; set vout "" ; set noud 1 ; set yout "" ; set tout ""
#---
		set ustr [string trim [stripcodes bcruag $str]]
		regsub -all -- {\((.*?)\)} $ustr "" ustr ; regsub -all -- {\[(.*?)\]} $ustr "" ustr
		regsub -- {^\d+.} $ustr "" ustr
		regsub -all -- {[[:punct:]]} $ustr " " ustr
		set ustr [string map {" " +} [string trim [sspace $ustr]]]
                if {$ustr == "" && ([string match "*3" [string tolower $::lastbind]] || [string match "*mp3" [string tolower $::lastbind]])} {putserv "NOTICE $unick :: $::lastbind < > -  ."; return}
		set furl "$fetchurl[uenc $ustr]?key=$tskey&limit=5" ; set parm $ustr
		set furl2 "$fetchurl3[uenc $ustr]"
		set furly "$furlyt[uenc [string map {+ " "} $ustr]]"
		::http::config -urlencoding utf-8 -useragent "Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; PPC; 240x320)"	
		if {$logrequests ne ""} {set logstr [subst -noc $logrequests] ; lput putlog $logstr "$unamespace: "}
		if {[queue_add "$furl" $id "[namespace current]::tsong:parser" [list $unick $uhost $uchan "gr"]]} {variable err_ok ; if {$err_ok ne ""} {lput puthelp "$err_ok." $prefix}} {variable err_fail ; if {$err_fail ne ""} {lput puthelp "$err_fail" $prefix}}
	        return
	}

#---parser
	proc tsong:parser {errid errstr body extra} {
		upvar $errid lerrid $errstr lerrstr $body lbody $extra lextra
		variable err_fail ; variable pubsend ; variable msgsend ; variable errsend
		variable gout ; variable furl2 ; variable parm ; variable noud ; variable vout ; variable yout ; variable tout
		variable arep ; variable adel ; variable furly ; variable tdbg
		foreach {unick uhost uchan ustr} $lextra {break}
		if {$uchan eq $unick} {set prefix [subst -noc $msgsend]} {set prefix [subst -noc $pubsend]}
		if {[info exists ::sp_version]} {set str [encoding convertfrom utf-8 $lbody]} {set str $lbody}

#----------------------------------------------------------------------------
##---parser-specific------
#----------------------------------------------------------------------------

	if {$ustr eq "gr"} {
	set tout [split [sconv $str] ";"] ; set yout ""
	foreach {url songid songname artistid artistname albumid albumname} $tout {
	if {[lindex $tout 0] ne "NSF" && [string match -nocase "*[string map {" " * , "" . ""} $songname]*" $parm]} {
	if {![string is space $songname]} {set gout "$::gcolor(14)\[\] \002\002:\017$songname $::gcolor(14)\002\002:\017$artistname $::gcolor(14)\002\002:\017$albumname $::gcolor(14)-> $::gcolor(12)\037$url\017 " ; break}
        } {set gout ""}
	}
	queue_add "$furly" [unixtime] "[namespace current]::tsong:parser" [list $unick $uhost $uchan "yt"]
	}

	if {$ustr eq "yt"} {
	set ystr ""
	regsub -all -- "\n" $str "" ystr
	regsub -all -- "</entry>" $ystr "</entry>\n" ystr
	if {[regexp -- {^(.*?)<entry>} $ystr -> yhead]} {
	regexp -- {<title type='text'>(.*?)</title>} $yhead -> ytitle
	regsub -- {^(.*?)<entry>} $ystr "" ystr
	regexp -- {<title type='text'>(.*?)</title>} $ystr -> ytshort
	regexp -- {<content type='text'>(.*?)</content>} $ystr -> ytlong
	regexp -- {<link rel='alternate' type='text/html' href='(.*?)'/>} $ystr -> ylink
	set yout "$::gcolor(14)\[\]\017 [sconv $ytshort] $::gcolor(14)-> $::gcolor(12)\037http://youtu.be/[lindex [split [lindex [split [sconv $ylink] &] 0] =] 1]\017"
	} {set yout ""}
	::http::config -urlencoding utf-8 -useragent "Mozilla/6.0 (compatible; MSIE 6.0;) Opera/7.7.1.88"	
	queue_add "$furl2" [unixtime] "[namespace current]::tsong:parser" [list $unick $uhost $uchan "mp"]
	}

	if {$ustr eq "mp"} {
	if {![string match -nocase "<ul class=\"list\">No audios found<br/>" $str]} {
	regsub -all -- "\n|\r" $str {} str
	foreach l [split [string map {"<div class=\"some\">" "<div class=\"some\">\n"} $str] "\n"] {
	if {[regexp -nocase -- {<li id="audio.*?>(.*?)<div class="some">} $l -> mpd]} {
	if {[regexp -nocase -- {onclick="return.*?'(.*?)'.*?<span class="ausong">(.*?)</span>.*?<span class="auname">(.*?)</span>.*?<div class="time">(.*?)</div>} $mpd -> mlink mname msong mtime]} {
	regsub -all -- "<.*?>" $mname "" mname ; regsub -all -- "<.*?>" $msong "" msong ; 
        if {[sconv $mname] == ""} {set vout "$::gcolor(14)\[3\]\017 [sconv $msong] $::gcolor(14)($mtime) -> $::gcolor(12)\037[http::data [http::geturl http://tinyurl.com/api-create.php?url=http://vpleer.ru/[uenc $mlink]]]\017 "} elseif {[sconv $msong] == ""} {set vout "$::gcolor(14)\[3\]\017 [sconv $mname] $::gcolor(14)($mtime) -> $::gcolor(12)\037[http::data [http::geturl http://tinyurl.com/api-create.php?url=http://vpleer.ru/[uenc $mlink]]]\017 "} {set vout "$::gcolor(14)\[3\]\017 [sconv $mname] - [sconv $msong] $::gcolor(14)($mtime) -> $::gcolor(12)\037[http::data [http::geturl http://tinyurl.com/api-create.php?url=http://vpleer.ru/[uenc $mlink]]]\017 "}
	if {![string is space $mname] && ![string is space $msong]} {break}
        } 
	}
	}
	}
	lput putserv "$gout$vout$yout" $prefix
	}
	
	if {$tdbg} {putlog "tsong - noud: $noud :: ustr: $ustr"; putlog "tsong: --$gout--$vout--$yout--"}
	return
	}		
#----------------------------------------------------------------------------
##---end-parser------
#----------------------------------------------------------------------------

	proc sspace {strr} {return [string trim [regsub -all {[\t\s]+} $strr { }]]}

	proc sconv {strr} {
	set escapes {
        &nbsp; \x20 &quot; \x22 &amp; \x26 &apos; \x27 &ndash; \x2D
        &lt; \x3C &gt; \x3E &tilde; \x7E &euro; \x80 &iexcl; \xA1
        &cent; \xA2 &pound; \xA3 &curren; \xA4 &yen; \xA5 &brvbar; \xA6
        &sect; \xA7 &uml; \xA8 &copy; \xA9 &ordf; \xAA &laquo; \xAB
        &not; \xAC &shy; \xAD &reg; \xAE &hibar; \xAF &deg; \xB0
        &plusmn; \xB1 &sup2; \xB2 &sup3; \xB3 &acute; \xB4 &micro; \xB5
        &para; \xB6 &middot; \xB7 &cedil; \xB8 &sup1; \xB9 &ordm; \xBA
        &raquo; \xBB &frac14; \xBC &frac12; \xBD &frac34; \xBE &iquest; \xBF
        &Agrave; \xC0 &Aacute; \xC1 &Acirc; \xC2 &Atilde; \xC3 &Auml; \xC4
        &Aring; \xC5 &AElig; \xC6 &Ccedil; \xC7 &Egrave; \xC8 &Eacute; \xC9
        &Ecirc; \xCA &Euml; \xCB &Igrave; \xCC &Iacute; \xCD &Icirc; \xCE
        &Iuml; \xCF &ETH; \xD0 &Ntilde; \xD1 &Ograve; \xD2 &Oacute; \xD3
        &Ocirc; \xD4 &Otilde; \xD5 &Ouml; \xD6 &times; \xD7 &Oslash; \xD8
        &Ugrave; \xD9 &Uacute; \xDA &Ucirc; \xDB &Uuml; \xDC &Yacute; \xDD
        &THORN; \xDE &szlig; \xDF &agrave; \xE0 &aacute; \xE1 &acirc; \xE2
        &atilde; \xE3 &auml; \xE4 &aring; \xE5 &aelig; \xE6 &ccedil; \xE7
        &egrave; \xE8 &eacute; \xE9 &ecirc; \xEA &euml; \xEB &igrave; \xEC
        &iacute; \xED &icirc; \xEE &iuml; \xEF &eth; \xF0 &ntilde; \xF1
        &ograve; \xF2 &oacute; \xF3 &ocirc; \xF4 &otilde; \xF5 &ouml; \xF6
        &divide; \xF7 &oslash; \xF8 &ugrave; \xF9 &uacute; \xFA &ucirc; \xFB
        &uuml; \xFC &yacute; \xFD &thorn; \xFE &yuml; \xFF
	}
	set strr [string map {\[ \\\[ \] \\\] \( \\\( \) \\\) \{ \\\{ \} \\\} \\ \\\\} [string map $escapes [join [lrange [split $strr] 0 end]]]] 
  	regsub -all -- {&#([[:digit:]]{1,5});} $strr {[format %c [string trimleft "\1" "0"]]} strr
 	regsub -all -- {&#x([[:xdigit:]]{1,4});} $strr {[format %c [scan "\1" %x]]} strr
 	regsub -all -- {&#?[[:alnum:]]{2,7};} $strr "" strr
        regsub -all -nocase -- {<.*?>} $strr {} strr
        regsub -all {^\s+} $strr "" strr; regsub -all {\s+$} $strr "" strr
	return [subst -nov $strr]
	}

	proc uenc {strr} {
	set str ""
	foreach byte [split [encoding convertto utf-8 $strr] ""] {scan $byte %c i ; if {[string match {[%<>"]} $byte] || $i < 65 || $i > 122} {append str [format %%%02X $i]} {append str $byte}}
	return [string map {%3A : %2D - %2B + %2E . %30 0 %31 1 %32 2 %33 3 %34 4 %35 5 %36 6 %37 7 %38 8 %39 9 \[ %5B \\ %5C \] %5D \^ %5E \_ %5F \` %60} $str]
        }

	proc lput {cmd str {prefix {}} {maxchunk 420}} {
	set buf1 ""; set buf2 [list]
	foreach word [split $str] {append buf1 " " $word ; if {[string length $buf1]-1 >= $maxchunk} {lappend buf2 [string range $buf1 1 end]; set buf1 ""}}
	if {$buf1 != ""} {lappend buf2 [string range $buf1 1 end]}
	foreach line $buf2 {$cmd $prefix$line}
	return
	}

	proc queue_isfreefor {{ id {}}} {
	variable reqqueue ; variable maxreqperuser ; variable maxrequests ; variable laststamp
	variable pause ; variable err_queue_full ; variable err_queue_id ; variable err_queue_time 
	if {[info exists laststamp(stamp,$id)]} {set timewait [expr {$laststamp(stamp,$id) + $pause - [unixtime]}] ; if {$timewait > 0} {return [subst -noc $err_queue_time]}}
	if {[llength [array names reqqueue -glob "*,$id"]] >= $maxreqperuser} {return $err_queue_id}
	if {[llength [array names reqqueue]] >= $maxrequests} {return $err_queue_full}		
	return
	}

	proc queue_add {newurl id parser extra {redir 0}} {
	variable reqqueue ; variable proxy ; variable timeout ; variable laststamp ; variable query ; variable type ; variable tparser ; variable textra
	::http::config -proxyfilter "[namespace current]::queue_proxy"
	set tparser $parser ; set textra $extra
	if {$query eq ""} {
	if {![catch {set token [::http::geturl $newurl -command [namespace current]::queue_done -binary true -timeout $timeout]} errid]} {					
	set reqqueue($token,$id) [list $parser $extra $redir] ; set laststamp(stamp,$id) [unixtime]
	} {return false}
	} {
	if {![catch {set token [::http::geturl $newurl -command [namespace current]::queue_done -binary true -timeout $timeout -query $query]} errid]} {					
	set reqqueue($token,$id) [list $parser $extra $redir] ; set laststamp(stamp,$id) [unixtime]
	} {return false}
	}
	return true
	}

	proc queue_proxy {url} {
	variable proxy
	if {$proxy ne {}} {return [split $proxy {:}]}		
	return [list]
	}
	
	proc queue_done {token} {
	upvar #0 $token state
	variable reqqueue ; variable maxredir ; variable fetchurl ; variable tparser ; variable textra
	set errid  	[::http::status $token]
	set errstr 	[::http::error  $token]	
	set	id  	[array  names reqqueue "$token,*"]
	if {$errid ne "timeout"} {foreach {parser extra redir} $reqqueue($id) {break}} {set parser $tparser ; set extra $textra ; array unset reqqueue}
	regsub -- "^$token," $id {} id
	while (1) {
	if {$errid == "ok" && [::http::ncode $token] == 302} {
	if {$redir < $maxredir} {			
	array set meta $state(meta)
	if {[info exists meta(Location)]} {queue_add "$fetchurl$meta(Location)" $id $parser $extra [incr redir]; break}
	} {set errid "error" ; set errstr "Max. redir."}
	} 	
	if {[catch {$parser {errid} {errstr} {state(body)} {extra}} errid]} {lput putlog $errid "[namespace current] "}
	break
	}			
	array unset reqqueue "$token,*"
	::http::cleanup $token
	return
	}

	proc queue_clear_stamps {} {
	variable laststamp ; variable timeout ; variable timerID
	set curr [expr {[unixtime] - 2 * $timeout / 1000}];
	foreach {id} [array names laststamp] {if {$laststamp($id) < $curr} {array unset laststamp $id}}		
	set timerID [timer 10 "[info level 0]"]
	}

	proc cmdaliases {{action {bind}}} {
	foreach {bindtype} {pub} {
	foreach {bindproc} [info vars "[namespace current]::${bindtype}:*"] {
	variable "${bindtype}prefix" ; variable "${bindtype}flag"			
	foreach {alias} [set $bindproc] {catch {$action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc}}				
	}
	}	
	return
	}

#---init
	if {[info exists timerID]} {catch {killtimer $timerID} ; catch {unset timerID}}	
	[namespace current]::queue_clear_stamps
	foreach bind [binds "[namespace current]::*"] {catch {unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]}}
	[namespace current]::cmdaliases
	bind ctcp - ACTION [namespace current]::act:tsong
}