######################################################
# Windrop  Vladislav
# : Adium
# : 0.2
# :   ,    .
######################################################

namespace eval anticapsnick {

variable banreason		"- ::  "
variable bantime			"60"
variable max_caps_letters	"3"
variable caps_percent		"50"
	
variable unamespace		[namespace tail [namespace current]]
variable flagactas		"no"
variable chflag			"$flagactas$unamespace"
setudef  flag 			$chflag

bind JOIN - * [namespace current]::onjoin
bind NICK - * [namespace current]::onchange

proc onjoin {nick uhost hand chan} {
		variable banreason; variable bantime
		variable chflag ; variable flagactas
		variable max_caps_letters; variable caps_percent
		if {![channel get $chan $chflag] ^ $flagactas eq "no" } {return 0}
		set len [regexp -all -- {[A-Z-ߨ]} [split $nick]]
		if {[format %.0f [expr $len/[string length $nick].0*100]] > $caps_percent && $len > $max_caps_letters} {
	      putquick "MODE $chan +b $nick!*@*"
		putquick "KICK $chan $nick :$banreason"
		newchanban $chan "$nick!*@*" $::botnick $banreason $bantime
		return 0
}
}

proc onchange {nick uhost hand chan newnick} {
		variable banreason; variable bantime
		variable chflag ; variable flagactas
		variable max_caps_letters; variable caps_percent
		if {![channel get $chan $chflag] ^ $flagactas eq "no" } {return 0}
		set len [regexp -all -- {[A-Z-ߨ]} [split $newnick]]
		if {[format %.0f [expr $len/[string length $newnick].0*100]] > $caps_percent && $len > $max_caps_letters} {
	      putquick "MODE $chan +b $newnick!*@*"
		putquick "KICK $chan $newnick :$banreason"
		newchanban $chan "$newnick!*@*" $::botnick $banreason $bantime
		return 0
}
}
}
putlog " : anticapsnick.tcl"