######################################################
# Windrop  Vladislav 
# : .
# : !bwhelp 
######################################################

# - -,      (    @)
set srmwebgates {
      "*!*@bnc.server.ru"
}
#    -.   - 4 (*!*ident*@full.host)  !bwhelp     .
set webgatemask 4

################################################################################################################
namespace eval smartrm {
#      bad-quit-line (10000 - ) 
  set BadQuitBan 300
#    ,    .chanset #chan bwmode
  set DefaultBantime 300
#          (1)   (0).
  set WarnKick 1
#  ( ),     .
  set WarnTime 30
#    (1)   (0).
  set PunishOps 0
#  ( )      
#  ,     WarnTime  .
  set ScanTime 5

#  ,  .      (    ).     .
  set WarnPubMessage {{ } {} {   }}

#  .
  set BadWords { ""
                 " "
                 "  "
                 " l "
                 "  "
                 "  "
                 " "
                 " li "
                 " hli "
                 " hli "
                 " "
                 " "
                 ""
                 ""
                 ""
                 "i"
                 ""
		     ""
		     " ?"
		     "?"
		     ""
                 "  "
                 ""
                 " "
                 " il"
                 " il"
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 " "
                 ""
                 " "
                 " "
                 " "
                 ""
                 " "
                 "dhi"
                 "di"
                 "i"
                 "dhi"
                 ""
                 ""
                 "izd"
                 "  "
                 " "
                 "  "
                 " "
                 " "
                 " "
                 " "
                 " l"
                 " l"
                 "  "
                 "  "
                 "  "
                 "  "
                 " "
                 " "
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 "dl"
                 "dl"
                 "djl"
                 " "
                 " "
                 " "
                 " "
                 " "
                 " idr"
                 " "
                 " "
                 ""
                 ""
                 ""
                 ""
                 " "
                 ""
                 ""
                 " "
                 " "
                 " "
                 ""
                 " "
                 ""
                 " "
                 " "
                 " z"
                 ""
                 ""
                 " z"
                 " "
                 ""
                 " "
                 " "
                 " "
                 ""
                 ""
                 ""
                 " "
                 " "
                 " rd"
                 " d"
                 " f"
                 " f "
                 " fi"
                 " t "
                 " h"
                 " h"
                 " ih "
                 " ih "
                 ""
                 ""
                 "  "
                 ""
                 " "
                 " "
                 ""
                 " "
                 " "
                 " "
                 "  "
                 "  "
                 " "
                 ""
                 ""
                 "  "
                 "  "
                 " "
                 ""
                 " "
                 "  "
                 " "
                 ""
                 " "
                 " "
                 ""
                 "xyNta"
                 "  "
                 ""
                 " "
                 " "
                 " "
                 " "
                 " "
                 " "
                 " "
                 ""
                 "zd"
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 ""
                 "z"
                 "z"
                 "z"
                 "z"
                 "9"
                 "i"
                 "i"
                 ""
                 ""
                 ""
                 "  "
                 "  "
               }
}
setudef flag badwords
setudef str bwmode

proc ::smartrm::tolower {text} { return [string map {     } [string tolower $text]] }
proc ::smartrm::DetectMat {text} {
  variable BadWords
  regsub -all {[\x02\x16\x1f]|\x03\d{0,2}(,\d{0,2})?} $text "" text
  regsub -all {\^} $text "" text;
  regsub -all {\!} $text "" text;
  regsub -all {\@} $text "" text;
  regsub -all {\$} $text "" text;
  regsub -all {\#} $text "" text;
  regsub -all {\%} $text "" text;
  regsub -all {\&} $text "" text;
  regsub -all {\*} $text "" text;
  regsub -all {\(} $text "" text;
  regsub -all {\)} $text "" text;
  regsub -all {\-} $text "" text;
  regsub -all {\_} $text "" text;
  regsub -all {\=} $text "" text;
  regsub -all {\+} $text "" text;
  regsub -all {\|} $text "" text;
  regsub -all {\\} $text "" text;
  regsub -all {\/} $text "" text;
  regsub -all {\.} $text "" text;
  regsub -all {\,} $text "" text;
  regsub -all {\'} $text "" text;
  regsub -all {\"} $text "" text;
  regsub -all {\;} $text "" text;
  regsub -all {\:} $text "" text;
  regsub -all {\[} $text "" text;
  regsub -all {\]} $text "" text;
  regsub -all {\{} $text "" text;
  regsub -all {\}} $text "" text;
  set text [string map {A  a  B  C  c  E  e  H  K  k  M  O  o  P  p  T  U  u  X  x  Y  y  3  4  6  0  b  g  n } $text]
  set text [tolower $text]
  set text " $text "
  set res ""
  set ch ""
  for {set i 0} {$i < [string length $text]} {incr i} {
  set newch [string index $text $i]
  if {$ch != $newch} {
  append res $newch
  }
  set ch $newch
  }
  set text $res
  foreach i $BadWords {
  set mask [split [string trim $i] {}]
  regsub -all { } $mask {\s*} mask
  set mask ".*\\s+$mask\\s+.*"
  if {[regexp $mask $text] || [string match *$i* $text]} { return 1 }
  }
  return 0
}

proc ::smartrm::PunishUser {nick host hand chan text} {
  global botnick
  variable WarnPubMessage; variable WarnKick; variable PunishOps
  variable WarnTime; variable DefaultBantime; variable Warnings
  if {![channel get $chan badwords]} { return 0 }
  if {[matchattr $hand "b"] || [matchattr $hand "n"]} { return 0 }
  if {![botisop $chan] && ![botishalfop $chan]} { return }
  if {($nick == "*") || ($nick == $botnick)} { return }
  if {!$PunishOps && [ishalfop $nick $chan]} { putserv "kick $chan $nick :   "; return }
  if {!$PunishOps && [isop $nick $chan]} { return }
  lappend Warnings($chan$host) [clock seconds]
  set WarnMessage "[lindex $WarnPubMessage [rand [llength $WarnPubMessage]]]"
  set ChannelKicks [join [string index [channel get $chan bwmode] 0]]
  if {$ChannelKicks != ""} {set MaxWarns $ChannelKicks} {set MaxWarns 1}
  set ChanBanTime [string range [join [channel get $chan bwmode]] 1 end]
  if {$ChanBanTime != ""} {set BanTime $ChanBanTime} {set BanTime $DefaultBantime}
  if {[llength $Warnings($chan$host)] > $MaxWarns} {
  set banident [lindex [split $host @] 0]
  set newbanmask [makesrmmask $nick $host $chan]
  newchanban $chan $newbanmask $botnick "$WarnMessage ::   $BanTime " $BanTime
  putserv "KICK $chan $nick :$WarnMessage ::   $BanTime "
  putcmdlog "<<$nick>> $chan = BADWORD DETECTED = < ban user > "
  } else {
  if {$WarnKick} {
  putserv "KICK $chan $nick :$WarnMessage"
  putcmdlog "<<$nick>> $chan = BADWORD DETECTED = < kick user > "
  }
  putserv "NOTICE $nick :    ,     $BanTime ."
  }
}

proc ::smartrm::RemoveWarns {} {
variable Warnings; variable WarnTime; variable ScanTime
foreach i [array names Warnings] {
while {[info exists Warnings($i)] && ([llength $Warnings($i)] > 0) && ([expr [clock seconds] - [lindex $Warnings($i) 0]] >= [expr $WarnTime * 60])} {
set Warnings($i) [lreplace $Warnings($i) 0 0]
if {[llength $Warnings($i)] == 0} {
unset Warnings($i)
}
}
}
timer $ScanTime ::smartrm::RemoveWarns
}

proc ::smartrm::CatchMsg {nick host hand chan text} {
if [DetectMat $text] { PunishUser $nick $host $hand $chan $text }
}
proc ::smartrm::CatchAction {nick host hand chan key text} {
CatchMsg $nick $host $hand $chan $text
}

proc ::smartrm::CatchNick {nick host hand chan {newnick ""}} { global botnick;
variable DefaultBantime
if {$newnick == ""} {set newnick $nick}
if {![channel get $chan badwords]} { return 0 }
set chident [lindex [split $host "@"] 0]
set chhost [lindex [split $host "@"] 1]
set text "[lindex [split $newnick] 0] $chident $chhost"
if {[DetectMat $text]} {
set nickbanmask [makesrmmask $nick $host $chan]
set NickBanTime [string range [join [channel get $chan bwmode]] 1 end]
if {$NickBanTime != ""} {set ntime $NickBanTime} {set ntime $DefaultBantime}
newchanban $chan $nickbanmask $botnick "  // ::   $ntime " $ntime
putcmdlog "<<$nick>> $chan = BAD NICK/HOST DETECTED = < BAN > "
}; }

proc ::smartrm::partsigncatch {nick uhost hand chan reason} {
global botnick
variable BadQuitBan
if { $nick == $botnick } { return 0	}
if {![channel get $chan badwords]} { return 0 }
if {[DetectMat $reason]} {
set quitbanmask [makesrmmask $nick $uhost $chan]
newchanban $chan $quitbanmask $botnick "  quit-line ::   $BadQuitBan " $BadQuitBan
putcmdlog "<<$nick>> $chan = BAD QUIT-LINE DETECTED = < BAN > "
}
}

timer $::smartrm::ScanTime ::smartrm::RemoveWarns

bind join - * ::smartrm::CatchNick
bind nick - * ::smartrm::CatchNick
bind pubm - * ::smartrm::CatchMsg
bind ctcp - ACTION ::smartrm::CatchAction
bind sign - ** ::smartrm::partsigncatch
bind part - ** ::smartrm::partsigncatch

bind pub n|n $::gprefix(1)bwmode srm:setmode
bind pub m|m $::gprefix(1)bwhelp srm:pubhelp
bind msg - $::gprefix(1)bwhelp srm:msghelp
bind msg - bwhelp srm:msghelp
bind pub n|n $::gprefix(1)bwmask srm:setmask

proc srm:setmode {nick uhost hand chan args} {
global botnick
if {$nick == $botnick} { return 0 }
set args [split [lindex $args 0]]
set modebw [lindex $args 0]
if { ([join $args] == "") || ([string length [join $args]] < 2) } {
if { [channel get $chan badwords] } { set mainmode "ON" } { set mainmode "OFF" }
if { [channel get $chan bwmode] != "" } { set curmode [channel get $chan bwmode] } { set curmode "default" }
puthelp "NOTICE $nick :SmartRusMat current mode\: Antimat - \002$mainmode\002 , Mode - \002$curmode\002"
return 0
}
if { [tolower $modebw] == "on" } {
channel set $chan "+badwords"
puthelp "NOTICE $nick : ."
return 0
}
if { [tolower $modebw] == "off" } {
channel set $chan "-badwords"
puthelp "NOTICE $nick : ."
return 0
}
if { [llength $args] > 1 } {
set bwkicks [join [lindex $args 0]]
set bwbans [join [lindex $args 1]]
set mainmode "$bwkicks$bwbans"
} else { set mainmode "[join [lindex $args 0]]" }
channel set $chan bwmode $mainmode
puthelp "NOTICE $nick : MODE $mainmode"
}

proc srm:setmask {nick uhost hand chan arg} {
global botnick
if { ($nick == $botnick) || ($hand == "*") } { return 0 }
set arg [split [lindex $arg 0]]
set arg [join [transkey $arg]]
if { $arg == "" } {
set curmode [join [channel get $chan defmask]]
if { ($curmode != 2) && ($curmode != 3) && ($curmode != 4) } { set answ "T   : \002*!*ident@*.host\002 " }
if { $curmode == 2 } { set answ "T   : \002*!*@full.host.ru\002 " }
if { $curmode == 3 } { set answ "T   : \002*nick*!*ident@*\002 " }
if { $curmode == 4 } { set answ "T   : \002*!*ident*@full.host\002 " }
puthelp "NOTICE $nick :$answ"
return 0
}
if { ($arg != 1) && ($arg != 2) && ($arg != 3) && ($arg != 4) } {
puthelp "NOTICE $nick :   : 1, 2, 3  4.   - \002$::gprefix(1)bwhelp\002"
return 0
}
if { $arg == 1 } { set tansw "    : \002*!*ident@*.host\002 " }
if { $arg == 2 } { set tansw "    : \002*!*@full.host.ru\002 " }
if { $arg == 3 } { set tansw "    : \002*nick*!*ident@*\002 " }
if { $arg == 4 } { set tansw "    : \002*!*ident*@full.host\002 " }
channel set $chan defmask $arg
puthelp "NOTICE $nick :$tansw"
}

proc srm:pubhelp {nick uhost hand chan arg} {
global botnick TcsVersion
if {$nick == $botnick} { return 0	}
puthelp "PRIVMSG $nick : \: \002.chanset #chan +badwords\002    \002$::gprefix(1)bwmode on\002      +n(  ). \: \002.chanset #chan -badwords\002    \002$::gprefix(1)bwmode off\002  ."
puthelp "PRIVMSG $nick :    ,     -       (0-9),   -    . : \002$::gprefix(1)bwmode 1300 \002 -  1        300 ."
puthelp "PRIVMSG $nick :       \: \002$::gprefix(1)bwmode on\002 - ,  \002$::gprefix(1)bwmode 1300\002 -   .   \002$::gprefix(1)bwmode on\002    ,    bwmode=1300 (1        300 )"
puthelp "PRIVMSG $nick :   \: \002$::gprefix(1)bwmask 1\002       +n(  ).  bwmask = 1    ,    \002*!*ident@*.host\002...  : bwmask = 2   \002*!*@full.host\002 .. bwmask = 3  \002*nick*!*ident@*\002 .. bwmask = 4  \002*!*ident*@full.host\002."
if { ([info exist TcsVersion]) && ([expr $TcsVersion > 051114]) } {
puthelp "PRIVMSG $nick :  ,   tcs -    $::gprefix(1)bwmask      ."
}
}

proc srm:msghelp {nick uhost hand arg} {
global botnick TcsVersion
if { ($nick == $botnick) || ($hand == "*") } { return 0	}
puthelp "PRIVMSG $nick : \: \002.chanset #chan +badwords\002    \002$::gprefix(1)bwmode on\002      +n(  ). \: \002.chanset #chan -badwords\002    \002$::gprefix(1)bwmode off\002  ."
puthelp "PRIVMSG $nick :    ,     -       (0-9),   -    . : \002$::gprefix(1)bwmode 1300 \002 -  1        300 ."
puthelp "PRIVMSG $nick :       \: \002$::gprefix(1)bwmode on\002 - ,  \002$::gprefix(1)bwmode 1300\002 -   .   \002$::gprefix(1)bwmode on\002    ,    bwmode=1300 (1        300 )"
puthelp "PRIVMSG $nick :   \: \002$::gprefix(1)bwmask 1\002       +n(  ).  bwmask = 1    ,    \002*!*ident@*.host\002...  : bwmask = 2   \002*!*@full.host\002 .. bwmask = 3  \002*nick*!*ident@*\002 .. bwmask = 4  \002*!*ident*@full.host\002."
if { ([info exist TcsVersion]) && ([expr $TcsVersion > 051114]) } {
puthelp "PRIVMSG $nick :  ,   tcs -    $::gprefix(1)bwmask      ."
}
}

proc tolower {text} { return [string map {                                                                 } [string tolower $text]] }
proc webgatedet {mask} { global srmwebgates;
set mask [lindex [split $mask "@"] 1]
foreach h $srmwebgates { if {[string match "*$mask*" "$h"]} {return 1}; }; return 0 }
setudef str defmask

proc makesrmmask {nick host tchan} { global webgatemask;
set maskmode [channel get $tchan defmask]
set userhost [MakeSrmIdent $host]
if {([string index $userhost 0] == "~") || ([string index $userhost 0] == "^")} { set userhost [string range [join $userhost] 1 end] } { set userhost [join $userhost] }
if { [webgatedet $userhost] } { set maskmode $webgatemask }
if { ($maskmode != 2) && ($maskmode != 3) && ($maskmode != 4) } { return "*!*[lindex [split $userhost "@"] 0]*@[lindex [split [maskhost $userhost] "@"] 1]" }
if { $maskmode == 2 } { return "*!*@[lindex [split $userhost "@"] 1]"}
if { $maskmode == 3 } { return "*$nick*!*[lindex [split $userhost "@"] 0]*@*"}
if { $maskmode == 4 } { return "*!*[lindex [split $userhost "@"] 0]*@[lindex [split $userhost "@"] 1]" }
}

proc MakeSrmIdent {umask} {
set che [lindex [split $umask "@"] 0]
set fh [lindex [split $umask "@"] 1]
if {[string length $che] > 9} {return "[string range $che 1 8]@$fh"}
if {[string length $che] > 8} {return "[string range $che 1 end]@$fh"}
return $umask; }

proc transkey {itext} {
regsub -all {[\x02\x16\x1f]|\x03\d{0,2}(,\d{0,2})?} $itext "" itext
regsub -all {([\`\~\@\%\^\*\(\)\_\=\{\}\[\]\;\:\'\"\<\>\,\.\/\?\|\\])+} $itext "" itext
return [string map {   } $itext]
}
putlog " : srm.tcl"