####################################################
# Windrop  Vladislav 
# : 1.3
####################################################

set quotepass_resyntax "must type /QUOTE PASS (\[^\" \]*)"

bind evnt - init-server quotepass_unbind
bind evnt - disconnect-server quotepass_unbind
bind evnt - connect-server quotepass_bind

proc quotepass_notice {from cmd text} {
global quotepass_resyntax
if {[regexp -nocase $quotepass_resyntax $text - pass]} {
putlog "Got a QUOTE PASS request from the server, sending \"PASS $pass\"" 
putserv "PASS $pass"
}
return 0
}

proc quotepass_unbind {type} {
catch {
unbind raw - NOTICE quotepass_notice
}
}

proc quotepass_bind {type} {
bind raw - NOTICE quotepass_notice
}