######################################################
# Windrop  Vladislav 
# : Buster
# : 0.2
# :  .
######################################################

set ns "bident"
catch { ${ns}::uninstall }

namespace eval $ns {

#   -      .
#
# WeNet:            "    ."
# RusNet:           "This nickname is owned by someone else."
# RusNet:           "   . ,   "
# DalNet:           ",   , .    "
# YakNet, V-IRC:    ",    ,   "
# IrcNet, IrcCity:  "    "

variable warning ".     -  "
    
######################################################
variable reply "NickServ"
variable anick "_${::nick}"
variable deltime 5

bind pub  n $::gprefix(1)identify            [namespace current]::ison
bind msg  n $::gprefix(1)identify            [namespace current]::ison
bind dcc  n identify                         [namespace current]::ison
bind evnt - init-server                      [namespace current]::ison
bind notc - "*${warning}*"                   [namespace current]::ison
bind raw  - 303                              [namespace current]::identify
bind raw  - 433                              [namespace current]::busy

proc putfast {text} {
putnow $text
return
}

proc putquick {text} {
putfast $text
return
}

proc ison {args} {
putquick "ISON Nickserv"
return
}

proc identify { unick uhand ustr } {
global nick altnick
variable anick; variable deltime; variable reply
if {$ustr eq ""} {
putlog "NickIdent:    $deltime "
after [expr {$deltime * 1000}] [list "[namespace current]::ison"]
} else {
if {[isbotnick $nick] || [isbotnick $anick] || [isbotnick $altnick]} {
putlog "NickIdent:    $nick"
putquick "$reply IDENTIFY $::gbpass"
} else {
putlog "NickIdent:    $nick"
putquick "$reply GHOST $nick $::gbpass"
}
}
return
}

proc busy { from keyword text } {
global nick
if {[isbotnick $nick]} {
putlog "NickIdent:    $nick"
putquick "NICK $nick"
putquick "ISON Nickserv"
}
return
}

bind evnt - prerehash [namespace current]::uninstall
proc uninstall {args} {
foreach bind [binds "[namespace current]::*"] {
catch {
unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]
}
}
namespace delete [namespace current]
}
return
}