####################################################
# Windrop  Vladislav
# : Zelik mod Vladislav
# : 3.0
# :     .
# : !
####################################################

bind join - *                          jn:cgreet
bind pub m|m $::gprefix(1)      pab:allgreet
bind pub m|m $::gprefix(1)-     pab:delgreetchan
bind pub m|m $::gprefix(1)+     pab:addgreetchan
bind pub m|m $::gprefix(1)         pab:listgreet
bind pub m|m $::gprefix(1)+        pab:addgreet
bind pub m|m $::gprefix(1)-        pab:delgreet
bind pub - $::gprefix(1)       pab:helpgreet

set gpath "data/greet"
########################################################################################################

setudef flag nozgreet

proc ischanflag {chan flag} { 
foreach f [channel info $chan] { 
if {$f == $flag} { 
return 1 
} 
} 
return 0 
}

proc pr:convtolow {a} { set b ""; for {set i 0} {$i < [string length $a]} {incr i} {append b [format %04d [scan [string index $a $i] %c]]}; return $b; }
proc pr:conv {a} { set b ""; for {set i 0} {$i < [string length $a]} {incr i 4} {append b [format %c [string trimleft [string range $a $i [expr $i+3]] 0]]}; return $b; }

proc jn:cgreet {nick host hand chan} {
set noconvnick $nick
global botnick gpath  
if { $nick == $botnick } {
return 1;
}
if {[ischanflag $chan "-cgreet"]} {
return 1;
}
set gchan [pr:convtolow $chan]
set gnick [pr:convtolow $nick]
if {[file exist "$gpath/$gchan"]} {
   set greet(info) [::egglib::readdata $gpath/$gchan]
   foreach greetstr $greet(info) {
   set testnick [lindex $greetstr 0]
   if {[string match "$testnick" $gnick]} {
      set greetmsg [lrange $greetstr 1 end]
      putserv "PRIVMSG $chan :[pr:conv $greetmsg]"
      return 1;
    }
    }
}
}

proc pab:addgreetchan {nick host hand chan args} {
global gpath 
if {[channel get $chan nozgreet]} { return }
set gchan [pr:convtolow $chan]
if {![file exist "$gpath/$gchan"]} {
   set greetfile [open "$gpath/$gchan" w+]
   putserv "NOTICE $nick :      $chan."
   close $greetfile
   return 1;
   }
putserv "NOTICE $nick : $chan     ."
return 1;
}

proc pab:delgreetchan {nick host hand chan args} {
global gpath 
if {[channel get $chan nozgreet]} { return }
set gchan [pr:convtolow $chan]
if {[file exist "$gpath/$gchan"]} {
   file delete $gpath/$gchan
   putserv "NOTICE $nick :      $chan."
   return 1;
   }
putserv "NOTICE $nick : $chan     .  $::gprefix(1)    ."
return 1;
}

proc pab:listgreet {nick host hand chan args} {
global gpath
if {[channel get $chan nozgreet]} { return }
set exist "0"
set gchan [pr:convtolow $chan]
if {[file exist "$gpath/$gchan"]} {
set exist "1"
set size [file size $gpath/$gchan]
   if { $size == 0 } {
   putserv "NOTICE $nick : $chan  ,   .   : $::gprefix(1)+ <> <>."
   return 1;
   }    
   set greet(info) [::egglib::readdata $gpath/$gchan]
   foreach greetstr $greet(info) {
   set gnick [lindex $greetstr 0]
   set greettext [lrange $greetstr 1 end]
   putserv "NOTICE $nick :[pr:conv $gnick]   [pr:conv $gchan]  : [pr:conv $greettext]"  
   }
   }
   if { $exist == "0" } {
   putserv "NOTICE $nick : $chan     .   : $::gprefix(1)+"
   return 1;
   }
return 1;
}

proc pab:allgreet {nick host hand chan args} {
global gpath
if {[channel get $chan nozgreet]} { return }
set fl "*"
set flist [glob $gpath/$fl]
putquick "NOTICE $nick :  ,    :"
foreach filename [concat $flist] {
set greetchan [file tail $filename]
set greet(info) [::egglib::readdata $filename]
set num "0"
foreach greetstr $greet(info) {
set num [ expr "$num + 1" ]
}
set empty ""
set numb "( $num () )."
set size [file size $filename]
if { $size == 0 } {
set empty "()"
set numb ""
}
putquick "NOTICE $nick : [pr:conv $greetchan] $empty$numb" 
}
return 1;
}

proc pab:addgreet {nick host hand chan text} {
global gpath
if {[channel get $chan nozgreet]} { return }
if {$text == ""} { putquick "NOTICE $nick :: $::gprefix(1)+ <> <>"; return 1; }
set gchan [pr:convtolow $chan]
set gnick [join [list [lindex [split $text] 0]]]
set gnick [pr:convtolow $gnick]

if {[file exist "$gpath/$gchan"]} {
set greetfile [open "$gpath/$gchan" r]
while {![eof $greetfile]} {
	set greetstr  [gets $greetfile]
	set testnick [lindex $greetstr 0]
	if {[string match "*$gnick*" $testnick]} {
	putquick "NOTICE $nick :  [pr:conv $gnick]      $chan."
	close  $greetfile
	return 1;
}
}
set greetfile [open "$gpath/$gchan" a+]
set gtext [lrange [split $text] 1 end]
if {$gtext == ""} { putquick "NOTICE $nick :: $::gprefix(1)+ <> <>"; return 1; }
set gtext [pr:convtolow [join $gtext]]
puts $greetfile "$gnick $gtext \n"
close $greetfile
putquick "NOTICE $nick :  [pr:conv $gnick]      $chan - [pr:conv $gtext]"
return 1;
}
putquick "NOTICE $nick : $chan     .   : $::gprefix(1)+"
return 1;
}

proc pab:delgreet {nick host hand chan text} {
global gpath
if {[channel get $chan nozgreet]} { return }
if {$text == ""} { putquick "NOTICE $nick :: $::gprefix(1)- <>"; return 1; }
set find "0"
set gchan [pr:convtolow $chan]
set gnick [lindex $text 0]
set gnick [pr:convtolow $gnick]

if {[file exist "$gpath/$gchan"]} {
   set s1 [file size $gpath/$gchan]
   set greet(info) [::egglib::readdata $gpath/$gchan]
   set greetfile [open "$gpath/$gchan" w+]
   foreach greetstr $greet(info) {
   set testnick [lindex $greetstr 0]
   if {![string match "*$gnick*" $testnick]} {
      puts $greetfile [join [list $greetstr]]
      }
   }
   close $greetfile
   set s2 [file size $gpath/$gchan]
   if { $s1 > $s2 } {
   putquick "NOTICE $nick :  [pr:conv $gnick]      $chan."
   return 1;
   } 

putquick "NOTICE $nick : [pr:conv $gnick]         $chan."     
return 1;
}
putquick "NOTICE $nick : $chan     .   : $::gprefix(1)+"
return 1;
} 

proc pab:helpgreet {nick host hand chan args} {
if {[channel get $chan nozgreet]} { return }
if {[matchattr $hand m|m $chan]} {
putquick "NOTICE $nick :$::gcolor(5)   . $::gcolor(14)(   )"
putquick "NOTICE $nick :$::gcolor(6)$::gprefix(1) $::gcolor(14)-     ."
putquick "NOTICE $nick :$::gcolor(6)$::gprefix(1)+ $::gcolor(14)<$::gcolor(6)$::gcolor(14)> $::gcolor(14)<$::gcolor(6)$::gcolor(14)> -     ."
putquick "NOTICE $nick :$::gcolor(6)$::gprefix(1)- $::gcolor(14)<$::gcolor(6)$::gcolor(14)> -     ."
putquick "NOTICE $nick :$::gcolor(6)$::gprefix(1) $::gcolor(14)-    ,    ."
putquick "NOTICE $nick :$::gcolor(6)$::gprefix(1)+ $::gcolor(14)-     ."
putquick "NOTICE $nick :$::gcolor(6)$::gprefix(1)- $::gcolor(14)-     ."
} else {
putquick "NOTICE $nick :,         +m."
}
}