####################################################
# Windrop  Vladislav
# : David Proper
# : 1.05.01
# :               , 
#                 .
####################################################

# [0/1]  ?
set IDLEOP(deop) 1
#   ()  ,     ?
set IDLEOP(maxidle) 60

# [0/1]  ?
set IDLEOP(dodehop) 1
#   ()  ,     ?
set IDLEOP(maxidleh) 120

# [0/1]     /?
set IDLEOP(voice) 0
#    ()    /  ?
set IDLEOP(timer) 10

# .
set IDLEOP(active) 1
set IDLEOP(warnidle) 0
set IDLEOP(warnmsg) "   !idle!   !channel!."

#      .
set IDLEOP(chans) "#windrop"

#       /.
set IDLEOP(exempt) "n"

bind dcc o idleopchk dcc_idleopchk
proc dcc_idleopchk {handle idx args} {
global IDLEOP
set chan [string tolower [lindex [console $idx] 0]]
putidx $idx "$IDLEOP(tag) Checking OP Idle times for $chan"
idleopchk $chan $idx
}

proc check_idleop {} {
global IDLEOP
timer $IDLEOP(timer) check_idleop
if {$IDLEOP(active) == 0} {putlog "IdleOP Checking is Deactivated. Skipping Check."
return 0}
foreach c [string tolower [channels]] {idleopchk $c 0}
}
timer $IDLEOP(timer) check_idleop

proc idleopchk {chan idx} {
global IDLEOP botnick
set dochan 999
foreach c [string tolower $IDLEOP(chans)] {
if {$c == $chan} {set dochan 1}
}
if {$dochan != 1} {return 0}

foreach user1 [chanlist $chan] {
subst -nobackslashes -nocommands -novariables user1
set ex 999
set hand [nick2hand $user1 $chan]
if { [isbotnick $user1] } {set ex 1}
if {([matchattr $hand $IDLEOP(exempt)] == 1) || ([matchchanattr $hand |$IDLEOP(exempt) $chan] == 1)} {set ex 1}

if {($ex != 1) && ([ishalfop $user1 $chan])} { 
set idletime [getchanidle $user1 $chan]
if {(($IDLEOP(dodehop)) && ($idletime > $IDLEOP(maxidleh)))} {
if {($idx > 0)} {putidx $idx "User $user1 idle for $idletime minutes. DeHop."
} else {putlog "User $user1 idle for $idletime minutes. DeHop."}
putserv "PRIVMSG $chan :\001ACTION   $user1\001"
#pushmode $chan -h $user1
putserv "MODE $chan -h $user1"
if {($IDLEOP(voice) == 1) && (![isvoice $user1 $chan])} {pushmode $chan +v $user1}
}
}

if {($ex != 1) && ([isop $user1 $chan])} {
set idletime [getchanidle $user1 $chan]
if {($IDLEOP(warnidle)>0) && ($idletime > $IDLEOP(warnidle))} {
set idlemsg $IDLEOP(warnmsg)
regsub -all {!idle!} $idlemsg "$idletime" idlemsg
regsub -all {!channel!} $idlemsg "$chan" idlemsg
putserv "NOTICE $user1 :$idlemsg"
} 
if {($idletime > $IDLEOP(maxidle)) && ($IDLEOP(deop) == 1)} {
if {($idx > 0)} {putidx $idx "User $user1 idle for $idletime minutes. DeOPing."
} else {putlog "User $user1 idle for $idletime minutes. DeOPing."}
putserv "PRIVMSG $chan :\001ACTION  $user1\001"
#putserv "PRIVMSG chanserv :deop $chan $user1"
#pushmode $chan -o $user1 
putserv "MODE $chan -o $user1"
if {($IDLEOP(voice) == 1) && (![isvoice $user1 $chan])} {pushmode $chan +v $user1}
}
}
}
}

bind dcc o idleop dcc_idleop
proc dcc_idleop {handle idx args} {
global IDLEOP
foreach c $IDLEOP(chans) {
listidleops $c $idx
}
}

proc listidleops {chan idx} {
global IDLEOP
putidx $idx "$IDLEOP(tag) Listing Idle times for $chan"
set exnum 0
foreach user1 [chanlist $chan] {
set hand [nick2hand $user1 $chan]
set ex " "
if {([matchattr $hand m] == 1) || ([matchchanattr $hand m $chan] == 1) || ([matchattr $hand b] == 1)} {set ex "E"; set exnum [expr $exnum + 1]}
if {$ex != " "} {set ex " \($ex\) "}
if {([isop $user1 $chan]) || ([isvoice $user1 $chan])} { putdcc $idx "$IDLEOP(tag)  User $user1${ex}has been idle [getchanidle $user1 $chan] mins." }
}
if {$exnum > 0} {putidx $idx "$IDLEOP(tag) NOTE: Users marked with a (E) after thier nick are exempted from idle-deop"}
}

bind pub o $::gprefix(1)idleop pub_idleop
proc pub_idleop {nick uhost hand channel rest} {
global IDLEOP
switch [string tolower [lindex $rest 0]] {
""    { putserv "NOTICE $nick :: $::gprefix(1)idleop \[on/off\]" }
"off" { set IDLEOP(active) 0 }
"on"  { set IDLEOP(active) 1 }
}
if {$IDLEOP(active) == 0} { putserv "NOTICE $nick :IdleOP - off"
} else { putserv "NOTICE $nick :IdleOP - on" }
}