####################################################
# Windrop  Vladislav 
# : BLaCkShaDoW mod Vladislav
# : 1.1
# :  -  .    6   1  49.
#             6 .  ,    .
# : ! 
####################################################

bind pub -|- $::gprefix(1) game:start
bind pub -|- $::gprefix(1) game:enter
bind pub -|- $::gprefix(1) game:numbers

setudef flag nolotto

proc game:start {nick host hand chan arg} {
global lotto botnick
set flag [lindex [split $arg] 0]
set choose_players [lrange [split $arg] 0 end]
set ::lotto_chan $chan
switch -exact -- [string tolower $flag] {

 {
if {[matchattr $hand mn|o $chan]} {
puthelp "PRIVMSG $chan :$::gcolor(14) '$::gcolor(5) 6-49$::gcolor(14)' ."
game:clear
return 0
}
}

 {
puthelp "NOTICE $nick :$::gcolor(14)  6 .    6   1  49."
puthelp "NOTICE $nick :$::gcolor(14)  : $::gcolor(6)$::gprefix(1)" 
puthelp "NOTICE $nick :$::gcolor(14) -:$::gcolor(6) $::gprefix(1) $::gcolor(14)<$::gcolor(6)1$::gcolor(14)> <$::gcolor(6)2$::gcolor(14)> <$::gcolor(6)$botnick$::gcolor(14)>..."
puthelp "NOTICE $nick :$::gcolor(14) : $::gcolor(6)$::gprefix(1) "
return 0 
} 
}

if {[info exists lotto(start)]} { puthelp "NOTICE $nick : ' 6-49'  !"; return 0; }
if {[channel get $chan nolotto]} { return 0 }
if {$choose_players != ""} {
lappend lotto(players:$chan) "[join $nick]"
foreach player $choose_players {
if {[onchan $player $chan] && ($player != $nick)} {
lappend lotto(players:$chan) "[join $player]"
set lotto(players:$chan) [lsort -unique $lotto(players:$chan)]
}
}

if {[llength $lotto(players:$chan)] < 2} {
puthelp "NOTICE $nick :    ."
game:clear  
return 0 
}
if {[info exists lotto(players:$chan)]} {
puthelp "PRIVMSG $chan :$::gcolor(14) '$::gcolor(5) 6-49$::gcolor(14)'    ."
utimer 3 [list game:run $chan] 
set lotto(start) 1
}
return 0
}

puthelp "PRIVMSG $chan :$::gcolor(14) '$::gcolor(5) 6-49$::gcolor(14)' .     : $::gcolor(4)$::gprefix(1) $::gcolor(14)   30 ."
lappend lotto(players:$chan) $nick
utimer 30 [list game:run $chan] 
set lotto(start) 1
}


proc game:clear {} {
global lotto
set chan $::lotto_chan
if {[info exists lotto(players:$chan)]} {
foreach playa $lotto(players:$chan) {
if {[info exists lotto(numbers:$playa:$chan)]} {
unset lotto(numbers:$playa:$chan)
}
if {[info exists lotto(setnumber:$playa:$chan)]} {
unset lotto(setnumber:$playa:$chan)
}
if {[info exists lotto(Waitnumber:$playa:$chan)]} {
unset lotto(Waitnumber:$playa:$chan)
}
if {[info exists lotto(count:results:$playa:$chan)]} {
unset lotto(count:results:$playa:$chan)
}

if {[info exists lotto(show:numbers:$playa:$chan)]} {
unset lotto(show:numbers:$playa:$chan)
}

if {[info exists lotto(cpu:numbers:$chan)]} {
unset lotto(cpu:numbers:$chan)
}

if {[info exists lotto(results:$playa:$chan)]} {
unset lotto(results:$playa:$chan)
}
}
}
foreach tmr [utimers] {
if {[string match "*game:*" [join [lindex $tmr 1]]]} {
killutimer [lindex $tmr 2]
}
}
if {[info exists lotto(start)]} {
unset lotto(start)
}
if {[info exists lotto(players:$chan)]} {
unset lotto(players:$chan)
}
if {[info exists lotto(i:$chan)]} {
unset lotto(i:$chan)
}
if {[info exists lotto(number:start:$chan)]} {
unset lotto(number:start:$chan)
}
if {[info exists lotto(won:players:$chan)]} {
unset lotto(won:players:$chan)
}

if {[info exists lotto(is:player:$chan)]} {
unset lotto(is:player:$chan)
}
if {[info exists lotto(extragere:$chan)]} {
unset lotto(extragere:$chan)
}

if {[info exists lotto(count:extragere:$chan)]} {
unset lotto(count:extragere:$chan)
}
}

proc game:enter {nick host hand chan arg} {
global lotto count
if {![channel get $chan nolotto]} {
if {![info exists lotto(start)]} {
return 0
}
foreach ply $lotto(players:$chan) {
if {[string equal -nocase $ply $nick]} {
puthelp "NOTICE $nick :   ."
return 0
}
}
if {[info exists lotto(number:start:$chan)]} {
puthelp "NOTICE $nick : .   ."
return 0
}
lappend lotto(players:$chan) "[join $nick]"
puthelp "PRIVMSG $chan :$::gcolor(5)$nick $::gcolor(14)   ."
}
} 

proc game:run {chan} {
global lotto
if {[llength $lotto(players:$chan)] == "1"} {
puthelp "PRIVMSG $chan :$::gcolor(4) . $::gcolor(14) '$::gcolor(5) 6-49$::gcolor(14)' ."
game:clear
return 0
}
puthelp "PRIVMSG $chan :$::gcolor(14) '$::gcolor(5) 6-49$::gcolor(14)' ."
puthelp "PRiVMSG $chan :$::gcolor(14): $::gcolor(5)$lotto(players:$chan)"
game:player $chan
} 

proc cpu:number:chose {chan} {
global lotto botnick
set maxnumber "48"
set randnumber [expr [rand $maxnumber] +1]
if {![info exists lotto(numbers:$botnick:$chan)]} {
lappend lotto(numbers:$botnick:$chan) "[join $randnumber]"
}
while {[lsearch -integer -exact $lotto(numbers:$botnick:$chan) $randnumber] < 0} {
lappend lotto(numbers:$botnick:$chan) "[join $randnumber]"
}
cpu:number:chose:again $chan
}

proc cpu:number:chose:again {chan} {
global lotto botnick
if {[llength $lotto(numbers:$botnick:$chan)] < 6} {
cpu:number:chose $chan
}
}


proc game:player {chan} {
global lotto botnick
if {![info exists lotto(i:$chan)]} {
set lotto(i:$chan) 0
}
set player [lindex $lotto(players:$chan) $lotto(i:$chan)]
incr lotto(i:$chan) +1
set lotto(Waitnumber:$player:$chan) 1
puthelp "PRIVMSG $chan :$::gcolor(5)$player$::gcolor(14),  : $::gcolor(4)$::gprefix(1)$::gcolor(14) <$::gcolor(6)  $::gcolor(4) 1 $::gcolor(6)$::gcolor(4) 49 $::gcolor(6) $::gcolor(14)>.   60 ."
if {[string equal -nocase $player $botnick]} { 
cpu:number:chose $chan   
set lotto(setnumber:$player:$chan) 1
utimer 3 [list puthelp "PRIVMSG $chan :$::gprefix(1) $lotto(numbers:$player:$chan)"]
utimer 4 [list game:player:start $chan $player]
return 0
}
set lotto(number:start:$chan) 1
utimer 60 [list game:player:start $chan $player]
}

proc game:player:start {chan player} {
global lotto
if {![info exists lotto(setnumber:$player:$chan)]} {
puthelp "PRIVMSG $chan :$::gcolor(5)$player $::gcolor(14), ..."
if {[info exists lotto(Waitnumber:$player:$chan)]} {
unset lotto(Waitnumber:$player:$chan) 
}
}
if {[llength $lotto(players:$chan)] != $lotto(i:$chan)} {
game:player $chan
} else {
if {[info exists lotto(players:$chan)]} {
foreach playa $lotto(players:$chan) {
if {[info exists lotto(numbers:$playa:$chan)]} {
lappend lotto(is:player:$chan) $playa
}
}
}
game:extragere $chan
utimer 2 [list game:output $chan]
}
}


proc game:output {chan} {
global lotto botnick
if {![info exists lotto(is:player:$chan)]} {
puthelp "PRIVMSG $chan :$::gcolor(14)  . $::gcolor(4) ."
game:clear
return 0
} 
puthelp "PRIVMSG $chan :$::gcolor(14) :$::gcolor(6) $lotto(extragere:$chan)"
foreach player $lotto(players:$chan) {
game:results:show $chan $player
if {[info exists lotto(show:numbers:$player:$chan)]} {
array set totalnum [list]
set num [llength $lotto(show:numbers:$player:$chan)]
lappend totalnum($num) $player
puthelp "PRIVMSG $chan :$::gcolor(5)$player $::gcolor(14)-  :$::gcolor(4) [llength $lotto(show:numbers:$player:$chan)] $::gcolor(14)$::gcolor(10) 6 $::gcolor(14)(-$::gcolor(6) $lotto(show:numbers:$player:$chan) $::gcolor(14)-)"
} else { puthelp "PRIVMSG $chan :$::gcolor(5)$player $::gcolor(14)-   ."}
}
foreach car [lsort -integer -increasing [array names totalnum]] {
set max "$car"
}
if {[info exists num]} {
lappend winners "$::gcolor(14):$::gcolor(5) [join $totalnum($max) "$::gcolor(14),$::gcolor(5) "]$::gcolor(14).    -$::gcolor(4) $max$::gcolor(14)."
} else { set winners "$::gcolor(14)    :(" }
game:clear
if {![info exists lotto(start:$chan)]} {
if {[info exists winners]} {
puthelp "PRIVMSG $chan :[join $winners]"
}
}
}

proc game:results:show {chan player} {
global lotto
if {[info exists lotto(numbers:$player:$chan)]} {
foreach ex $lotto(extragere:$chan) {
if {[lsearch -exact [join $lotto(numbers:$player:$chan)] $ex] > -1} {
lappend lotto(show:numbers:$player:$chan) "[join $ex]"
}
}
}
}

proc game:extragere {chan} {
global lotto
set lotto_numbers "1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49"
set randnumber [lindex $lotto_numbers [expr {int(rand()*[llength $lotto_numbers])}]]
if {![info exists lotto(extragere:$chan)]} {
lappend lotto(extragere:$chan) "[join $randnumber]"
}
while {[lsearch -integer -exact $lotto(extragere:$chan) $randnumber] < 0} {
lappend lotto(extragere:$chan) "[join $randnumber]"
}
game:extragere:again $chan
}

proc game:extragere:again {chan} {
global lotto
if {[llength $lotto(extragere:$chan)] < 6} {
game:extragere $chan
}
}

proc game:numbers {nick host hand chan arg} {
global lotto count
set numbers [lrange [split $arg] 0 5]
if {![info exists lotto(start)]} {
return 0
}
if {![info exists lotto(Waitnumber:$nick:$chan)]} {
return 0
}
if {[info exists lotto(setnumber:$nick:$chan)]} {
puthelp "Ti-ai setat deja numerele.."
return 0
}

foreach player $lotto(players:$chan) {
if {[string match -nocase $nick $player]} {
set numbers [lsort -unique $numbers]
if {([llength $numbers] > 6) || ([llength $numbers] < 6)} {
puthelp "NOTICE $nick :: $::gprefix(1) <1> <2> <3> <4> <5> <6> ( )"
puthelp "NOTICE $nick :: $::gprefix(1) 1 7 10 21 27 30"
return 0
}
foreach number $numbers {
if {![regexp {^[0-9]} $number]} {
puthelp "NOTICE $nick :: $::gprefix(1) <1> <2> <3> <4> <5> <6> ( )"
puthelp "NOTICE $nick :: $::gprefix(1) 1 7 10 21 27 30"
return 0
}
if {($number < 1) || ($number > 49)} {
puthelp "NOTICE $nick :   1  49."
puthelp "NOTICE $nick :: $::gprefix(1) 1 7 10 21 27 30"
return 0
}
}
set lotto(setnumber:$player:$chan) 1
lappend lotto(numbers:$player:$chan) "$numbers"
}
}
puthelp "NOTICE $nick :  : [join $lotto(numbers:$nick:$chan)]"
foreach tmr [utimers] {
if {[string match "*game:player:start*" [join [lindex $tmr 1]]]} {
killutimer [lindex $tmr 2]
game:player:start $chan $nick
}
}
}