######################################################
# Windrop  Vladislav 
# : Death_Lord
# : 2.6
# : IRC  " "
# : ! !
######################################################

#    :
set ruletka(dir) "data/ruletka/"

#     :
set ruletka(pref) $::gprefix(1)

#        :
set ruletka(min_games) "10"

#   
# 0 -    
# 1 -    
#   RANDNICK,    
set ruletka(result) {
	{1 %c14   %c05Desert Eagle%c14 50  ... %c04%c14 ... %c06 . %c14        ... }
	{1 %c14    Desert %c05Eagle%c14    ...        ... %c04%c14 ...     ,   ,          .}
	{1 %c14   %c05%c14 ...    ... %c04%c14 ...       ...}
	{0 %c14   %c05%c14 ...    ... %c04%c14 ...   ,      -.}
	{0 %c14 %c05%c14 ...   ... %c06   %c05RANDNICK%c06,   %c14 ...      %c05RANDNICK}
	{0 %c14 %c05-47%c14     ... %c06       %c14 ...        -   ...  -  %c05RANDNICK%c14 ...}
	{0 %c14     %c05%c14,    ... %c04%c14 ... '' ...   ... '' ...    ... ',    ' -   ...}
	{0 %c14 %c05%c14 ...    ,          '%c05%c14' ...}
	{0 %c14 %c05%c14 ...       ... %c04%c14 ... '' ...        '%c05%c14' ... }
}

#    =)
set ruletka(races) {
	{ } { } {  } {}
	{} { } {} {  }
	{} { } {} { } {}
	{ } {} {  } {  }
	{} { ,   } {} { }
	{ } { } { } {}
}

bind pub -|- ${ruletka(pref)} ::ruletka::reg
bind pub -|- ${ruletka(pref)} ::ruletka::game
bind pub -|- ${ruletka(pref)} ::ruletka::game
bind pub -|- ${ruletka(pref)} ::ruletka::game
bind pub -|- ${ruletka(pref)} ::ruletka::game
bind pub -|- ${ruletka(pref)} ::ruletka::stat
bind pub -|- ${ruletka(pref)} ::ruletka::top
bind pub -|- ${ruletka(pref)} ::ruletka::help

namespace eval ruletka {}
set ruletka(helpfile) "data/help/rhelp.txt"
setudef flag noruletka

proc ::ruletka::reg {nick uhost hand chan text} {
	global ruletka
	set uhost "\*\!\*\@[lindex [split $uhost "@"] 1]"
	if {[channel get $chan noruletka]} { return }
        set race [lindex $ruletka(races) [rand [llength $ruletka(races)]]]
	set file "$ruletka(dir)ruletka.user"
	set data [::egglib::readdata $file]
	if {[::ruletka::checkuser $file $data $nick $uhost] != ""} { ::egglib::outn $nick "$::gcolor(4)     ."; return }
	set user "--HAND $nick \| --HOSTS $uhost \| --RACE $race \| --DEATH 0 \| --SURV 0 \| --ALL 0 \|"
	set data [linsert $data end $user]
	::egglib::writedata $file $data
	::egglib::outn $nick "       , $nick!   $race!      : ${ruletka(pref)}"
}
proc ::ruletka::checkuser {file data nick uhost} {
	global ruletka
	set s ""
	foreach line $data {
        if {[regexp -nocase -- {--HAND\ (.*?)\ \|\ --HOSTS\ (.*?)\ \|\ --RACE\ (.*?)\ \|\ --DEATH\ (.*?)\ \|\ --SURV\ (.*?)\ \|\ --ALL\ (.*?)\ \|} $line garb uhand hosts race death surv all]} {
	if {($nick == $uhand) || ([lsearch $hosts $uhost] != "-1")} { set s "$uhand \{$hosts\} \{$race\} $death $surv $all" }
	}
	}
	return $s
}

proc ::ruletka::game {nick uhost hand chan text} {
	global ruletka botnick
        if {[channel get $chan noruletka]} { return }
	if {[llength [chanlist $chan]] < 3} { ::egglib::outn $nick ",      2 ."; return }
	set sc [lindex $text 0]
	if {$sc != ""} { ::egglib::outn $nick "  : $::gprefix(1) $::gprefix(1) $::gprefix(1) $::gprefix(1)"; return }
	set uhost "\*\!\*\@[lindex [split $uhost "@"] 1]"
	set file "$ruletka(dir)ruletka.user"
	set data [::egglib::readdata $file]
	set user [::ruletka::checkuser $file $data $nick $uhost]
	if {$user == ""} { ::egglib::outn $nick "        ${ruletka(pref)}"; return }
	if {![matchattr $hand m]} {
		set lines [utimers]
		set ttime ""
		foreach line $lines {
		if {"::ruletka::reset $uhost" == [lindex $line 1]} { set ttime [lindex $line 0] }
		}
		set ttime [duration $ttime]
		regsub -all -- "minutes" "$ttime" "" ttime
		regsub -all -- "minute" "$ttime" "" ttime
		regsub -all -- "seconds" "$ttime" "" ttime
		regsub -all -- "second" "$ttime" "" ttime
		if {[info exists ::ruletka::pub(host,$uhost)]} {
		::egglib::outn $nick "        3 .    $ttime."
		return
		}
		set ::ruletka::pub(host,$uhost) 1
		set ::ruletka::pub(timer,$uhost) [utimer 180 [list ::ruletka::reset $uhost]]
	}
	set uhand [lindex $user 0]
	set hosts [lindex $user 1]
	set race [lindex $user 2]
	set death [lindex $user 3]
	set surv [lindex $user 4]
	set all [expr [lindex $user 5] + 1]
	set result [lindex $ruletka(result) [rand [llength $ruletka(result)]]]
	set a [lindex $result 0]
	set result [lrange $result 1 end]
	set result [::egglib::meta_to_colors $result]
	if {[regexp -nocase -- "RANDNICK" $result]} { set rr 1 } else { set rr 0 }
	set randnick [lindex [chanlist $chan] [rand [llength [chanlist $chan]]]]
	while {($randnick == $botnick) || ($randnick == $nick)} { set randnick [lindex [chanlist $chan] [rand [llength [chanlist $chan]]]] }
	regsub -all -- "RANDNICK" $result "$randnick" result
	set rhost "\*\!\*\@[lindex [split [getchanhost $randnick $chan] "@"] 1]"
	set result2s {
		{%c05UHAND %c14  %c04RACE}
		{%c04RACE %c14(%c05UHAND%c14)}
		{%c05UHAND %c14-%c04 RACE}
	}
	set result2 [lindex $result2s [rand [llength $result2s]]]
	regsub -all -- "RACE" $result2 "$race" result2
	regsub -all -- "UHAND" $result2 "$uhand" result2
	set result2 [::egglib::meta_to_colors $result2]
	::egglib::out $chan $chan "$result2\003 $result"
	if {$a == 1} {
        if {[botisop $chan] || [botishalfop $chan]} {putkick $chan $nick "$::gcolor(4)!"}
        set death [expr $death + 1]
        } else {set surv [expr $surv + 1]}
	set ndata {}; set rrr 0
	foreach line $data {
	if {$rr == 1} {
	if {[regexp -nocase -- {--HAND\ (.*?)\ \|\ --HOSTS\ (.*?)\ \|\ --RACE\ (.*?)\ \|\ --DEATH\ (.*?)\ \|\ --SURV\ (.*?)\ \|\ --ALL\ (.*?)\ \|} $line garb rhand rhosts rrace rdeath rsurv rall]} {
	if {[lsearch $rhosts $rhost] != "-1"} {
	set rrr 1
	set rdeath [expr $rdeath + 1]
	set line "--HAND $rhand \| --HOSTS $rhosts \| --RACE $rrace \| --DEATH $rdeath \| --SURV $rsurv \| --ALL $rall \|"
	}
	}
        }
	if {[lsearch $line $uhand] != "-1"} {
	set line "--HAND $uhand \| --HOSTS $hosts \| --RACE $race \| --DEATH $death \| --SURV $surv \| --ALL $all \|"
	}
	set ndata [linsert $ndata end $line]
	}
	if {($rr == 1) && ($rrr == 0)} {
	set rrace [lindex $ruletka(races) [rand [llength $ruletka(races)]]]
	set ndata [linsert $ndata end "--HAND $randnick \| --HOSTS $rhost \| --RACE $rrace \| --DEATH 1 \| --SURV 0 \| --ALL 0 \|"]
	}
	::egglib::writedata $file $ndata
}

proc ::ruletka::reset { uhost } {
	global ::ruletka::pub
	catch {killutimer $::ruletka::pub(timer,$uhost)}
	catch {unset ::ruletka::pub(timer,$uhost)}
	catch {unset ::ruletka::pub(host,$uhost)}
}

proc ::ruletka::stat {nick uhost hand chan text} {
	global ruletka
	if {[channel get $chan noruletka]} { return }
	set uhost "\*\!\*\@[lindex [split $uhost "@"] 1]"
	set file "$ruletka(dir)ruletka.user"
	set data [::egglib::readdata $file]
	set sc [lindex $text 0]
	if {$sc == ""} {
	set user [::ruletka::checkuser $file $data $nick $uhost]
	if {$user == ""} { ::egglib::outn $nick "        ${ruletka(pref)}"; return }
	} else {
	set user [::ruletka::checkuser $file $data $sc "[getchanhost $sc $chan]"]
	if {$user == ""} { ::egglib::outn $nick "   $sc   "; return }
	}
	set uhand [lindex $user 0]
	set hosts [lindex $user 1]
	set race [lindex $user 2]
	set death [lindex $user 3]
	set surv [lindex $user 4]
	set all [expr $death + $surv]
	set games [lindex $user 5]
	if {$all != 0} { set vit [expr round(( $surv * 100 ) / ${all}.0)] } else { set vit 0 }
	set output "$::gcolor(5) \" \": $::gcolor(14)  $::gcolor(5)$uhand$::gcolor(14),  $::gcolor(4)$race$::gcolor(14),  $::gcolor(6)$death$::gcolor(14),  $::gcolor(6)$surv$::gcolor(14),   $::gcolor(6)$vit%$::gcolor(14),   $::gcolor(6)$games$::gcolor(14) ()."
       putserv "PRIVMSG $chan :$output"
}

proc ::ruletka::top {nick uhost hand chan text} {
	global ruletka
        if {[channel get $chan noruletka]} { return }
	set uhost "\*\!\*\@[lindex [split $uhost "@"] 1]"
	set file "$ruletka(dir)ruletka.user"
	set data [::egglib::readdata $file]
	if {[::ruletka::checkuser $file $data $nick $uhost] == ""} { ::egglib::outn $nick "        ${ruletka(pref)}"; return }
	set sc [lindex $text 0]
	set sur_top {}
	set death_top {}
	foreach line $data {
	if {[regexp -nocase -- {--HAND\ (.*?)\ \|\ --HOSTS\ (.*?)\ \|\ --RACE\ (.*?)\ \|\ --DEATH\ (.*?)\ \|\ --SURV\ (.*?)\ \|\ --ALL\ (.*?)\ \|} $line garb uhand hosts race death surv all]} {
	if {$all >= $ruletka(min_games)} {
	set vit [expr $surv * 100 / [expr $death + $surv]]
	set sur_top [linsert $sur_top end "$vit $uhand $race"]
        set death_top [linsert $death_top end "$death $uhand $race"]
        }
	}
	}
	set sur_top [lsort -dictionary -decreasing $sur_top]
	set death_top [lsort -dictionary -decreasing $death_top]
	if {$sc == "death" || $sc == ""} {
	set y "1"
        ::egglib::outn $nick "  ' '  :"
	foreach line $death_top {
	set d [lindex $line 0]
	set u [lindex $line 1]
	set r [lrange $line 2 end]
	if {$line != ""} {
	set out "$::gcolor(4)$y\003 | $::gcolor(14): $::gcolor(5)$u\003 | $::gcolor(14): $::gcolor(4)$r\003 | $::gcolor(14): $::gcolor(4)$d"
	::egglib::outn $nick $out
	}
	incr y
	}
	}
	if {($sc == "s") || ($sc == "")} {
	set x "1"
        ::egglib::outn $nick "  ' '  :"
	foreach line $sur_top {
	set s [lindex $line 0]
	set u [lindex $line 1]
	set r [lrange $line 2 end]
	if {$s > 90} { set rank " " }
	if {($s <= 90) && ($s > 80)} { set rank "" }
	if {($s <= 80) && ($s > 70)} { set rank "" }
	if {($s <= 70) && ($s > 60)} { set rank "" }
	if {($s <= 60) && ($s > 50)} { set rank " " }
	if {($s <= 50) && ($s > 20)} { set rank "" }
	if {($s <= 20) && ($s > 10)} { set rank " " }
	if {($s <= 10) && ($s > 0)} { set rank "..." }
	if {$s == 0} { set rank ": ''" }
	if {$line != ""} { ::egglib::outn $nick "$::gcolor(4)$x\003 | $::gcolor(14): $::gcolor(5)$u\003 | $::gcolor(14): $::gcolor(4)$r\003 | $::gcolor(14): $::gcolor(12)$rank\003 | $::gcolor(14): $::gcolor(6)${s}%" }
	incr x
	}
	}
}

proc ::ruletka::help {nick uhost hand chan text} {
	global ruletka
        if {[channel get $chan noruletka]} { return }
	set data [::egglib::readdata $ruletka(helpfile)]
	foreach line $data { ::egglib::outn $nick [::egglib::meta_to_colors $line] }
}

set ruletka(weapons) {
	{-47 | %c14      (   ) %c12%bAK-47%b%c14    Had Shot %c06NICK%c14,        ... |}
	{Rocket Launcher | %c14  %c06NICK%c14   %c12Rocket Launcher%c14 '%u !%u' ...             %c06NICK%c14 ... |}
	{Railgun | %c14      ...    '! ;)'   %c06NICK%c14  %c12Railgun-%c14 ...  %c05NNICK%c14    ;)) |}
	{Shotgun | %c14  %c12Shotgun%c14     ...  () %c06NICK%c14 ...        () ()    ... |}
	{ | %c14      %c12 ''%c14       ... %c06NICK%c14    () ()   %c05NNICK%c14 ... |}
	{ | %c14... %c14     ()  %c06NICK%c14   ()  %c12%c14 ...   ()  ()     ... |}
	{BFG | %c14 %c12BFG%c14     %c12Quad Damage%c14 ...   %c06NICK%c04     %c12NNICK%c14         ... |}
}

bind pub -|- $::gprefix(1) ::ruletka::rasstrelat
bind pub -|- $::gprefix(1) ::ruletka::rasstrelat

proc ::ruletka::rasstrelat {nick uhost hand chan text} {
	global ruletka botnick
        if {[channel get $chan noruletka]} { return }
	set target [lindex $text 0]
	set weapon [lrange $text 1 end]
	if {$weapon == ""} { ::egglib::outn $nick ": $::gprefix(1) <> <-47|||BFG|Shotgun|Railgun|Rocket Launcher>"; return }
        set find 0
	foreach line $ruletka(weapons) {
	if {[regexp -nocase -- {(.*?)\ \|\ (.*?)\ \|} $line grab cweapon cresult]} {
	if {[regexp -nocase -- "$weapon" $cweapon]} { set find 1; set result $cresult }
	}
	}
	if {$find == 0} { ::egglib::outn $nick "   .";  return }
	if {[onchan $target $chan]} {
	regsub -all -- "NNICK" $result "$nick" result
	regsub -all -- "NICK" $result "$target" result
	set result [::egglib::meta_to_colors $result]
	::egglib::out $chan $chan "$::gcolor(5)$nick\003 $result"
	} else { ::egglib::outn $nick "     $chan." }
}