######################################################
# Windrop  Vladislav 
# : E}|{uk
# : 2.0
# : !
######################################################

foreach p [array names slogan *] { catch {unset slogan($p) } }
namespace eval slogan {}

set slogan(timer) "60"

bind pub - $::gprefix(1)   ::slogan::pub
bind pub - $::gprefix(1)slogan   ::slogan::pub
bind msg - $::gprefix(1)   ::slogan::msg
bind msg - $::gprefix(1)slogan   ::slogan::msg

setudef flag noslogan

proc ::slogan::pub {nick uhost hand chan args} {
global slogan
if {[channel get $chan noslogan]} { return }
if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
::slogan::slogan $nick $uhost $hand $chan $args
}

proc ::slogan::msg {nick uhost hand args} {
if {[onchan $nick]} {} else { return }
if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
::slogan::slogan $nick $uhost $hand $nick $args
}

proc ::slogan::readdata {file} {
if {![file exists $file]} {
return ""
} else {
set fileio [open $file r]; set lines ""
while {![eof $fileio]} {
set line [gets $fileio]
if {$line != ""} { set lines [linsert $lines end $line] }
}
close $fileio
return $lines
}
}

proc ::slogan::slogan {nick uhost hand chan text} {
global slogan
regsub -all -- {\"} $text {} text
set text [string range [join $text] 0 end]
if {[llength $text] == 0} {puthelp "notice $nick :: $::gprefix(1) < ?>"; return }
set slogan(base) [::slogan::readdata data/slogan.txt]; set slogantimer [utimers]
foreach line $slogantimer {
if {"slogan:reset $uhost" == [lindex $line 1]} { set slogan(time) [lindex $line 0] }
}
if { [info exists slogan(host,$uhost)] } { 
set temp [duration $slogan(time)] 
regsub -all -- {minutes} $temp {.} temp
regsub -all -- {minute} $temp {} temp
regsub -all -- {seconds} $temp {} temp
regsub -all -- {second} $temp {} temp
if {$slogan(timer) > 0} { putserv "NOTICE $nick :    $::gprefix(1)  $temp."; return }
}    
set slogan(host,$uhost) 1; set slogan(timer,$uhost) [utimer $slogan(timer) [list slogan:reset $uhost ] ]
set params "$::gcolor(6)$text$::gcolor(14)"; set slogan(fraza) [lindex $slogan(base) [rand [llength $slogan(base)]]]
if { $nick == $chan } {putserv "PRIVMSG $nick :[subst -nobackslashes -nocommands $slogan(fraza)]"
} else {putserv "PRIVMSG $chan :$::gcolor(5):: $::gcolor(14)[subst -nobackslashes -nocommands $slogan(fraza)]"}
}

proc slogan:reset { uhost } {
global slogan 
catch {unset slogan(timer,$uhost)}
catch {unset slogan(host,$uhost)}
}

setudef flag join-slogan
bind join - * slogan-join   
proc slogan-join {nick uhost hand chan} {   
global slogan botnick lasttime
if {![channel get $chan join-slogan]} {return}
if { $nick == $botnick } { return } 
if {[info exists lasttime]} { 
if {[expr [expr [unixtime] - $lasttime] < 10]} { return } 
} 
set slogan(base) [::slogan::readdata data/slogan.txt]   
set params "$::gcolor(6)$nick$::gcolor(14)"   
set slogan(fraza) [lindex $slogan(base) [rand [llength $slogan(base)]]]   
putserv "PRIVMSG $chan :$::gcolor(5):: $::gcolor(14)[subst -nobackslashes -nocommands $slogan(fraza)]"  
set lasttime [unixtime]  
return  
}