####################################################
# Windrop  Vladislav 
# : I_strike
# : 3.1
# :    dns.
# : !
####################################################

setudef flag nodns

bind pub - $::gprefix(1)dns dns:res
bind pub - $::gprefix(1) dns:res

set dns_chan ""; set dns_host ""; set dns_nick ""; set dns_bynick ""; set dns_nick ""

proc raw:hostdns {from signal arg} {
global dns_chan dns_nick dns_host dns_bynick
set dns_nick "[lindex $arg 1]"
set dns_host "*!*[lindex $arg 2]@[lindex $arg 3]"
foreach dns_say $dns_chan { puthelp "PRIVMSG $dns_say :$::gcolor(5)$dns_nick $::gcolor(14)- $::gcolor(4)$dns_host" }
if {$dns_bynick == "oui"} {
set hostip [split [lindex $arg 3] ]
dnslookup $hostip resolve_rep $dns_chan $hostip
set dns_bynick "non"
}
unbind raw * 311 raw:hostdns
}

proc raw:faildns {from signal arg} {
global dns_nick
set arg "[lindex $arg 1]"
foreach dns_say $dns_nick { puthelp "NOTICE $dns_say :,  $arg    ." }
set dns_nick ""
unbind raw * 401 raw:faildns
}

proc dns:res {nick uhost hand chan text} {
global dns_chan dns_nick dns_bynick dnshost
if {[channel get $chan nodns]} { return }
set text [string trim [string map { {}} [stripcodes cubr $text]]]
if {$text == ""} { puthelp "notice $nick :: $::gprefix(1) <//>"; return }
if {[regexp -nocase -- {^([-]{1})} [lindex $text 0]]} {set text [::ccs::idna::encode [encoding convertto utf-8 [lindex $text 0]]]}
if {![string match "*\.*" $text] && ![string match "*:*" $text]} {
bind raw * 311 raw:hostdns; bind raw * 401 raw:faildns
set dns_chan "$chan"; set dns_nick "$nick"; set dns_bynick "oui"; putserv "WHOIS [lindex $text 0]"
} {
set hostip [split $text]; dnslookup $hostip resolve_rep $chan $hostip
}
}

proc resolve_rep {ip host status chan hostip} {
if {!$status} { puthelp "privmsg $chan :  $hostip"
} elseif {[regexp -nocase -- $ip $hostip]} { regsub -all -- {^(xn--.*?)$} [string map [list \[ \\\[ \] \\\] \{ \\\{ \} \\\} \$ \\\$ \\ \\\\] $host] "\[encoding convertfrom utf-8 \[::ccs::idna::decode \\1\]\]" host; set host [subst -novar $host]; puthelp "privmsg $chan :$::gcolor(14)IP$::gcolor(3) $ip $::gcolor(14)  :$::gcolor(6) $host"
} else { regsub -all -- {^(xn--.*?)$} [string map [list \[ \\\[ \] \\\] \{ \\\{ \} \\\} \$ \\\$ \\ \\\\] $host] "\[encoding convertfrom utf-8 \[::ccs::idna::decode \\1\]\]" host; set host [subst -novar $host]; puthelp "privmsg $chan :$::gcolor(14)$::gcolor(6) $host $::gcolor(14)  IP:$::gcolor(3) $ip"
}
}