####################################################
# Windrop  Vladislav 
# : Vladislav
# : 1.0
# :     .
# : !
#          ! #  -    ,    0 -    .
####################################################

namespace eval imhonet {

#----------------------------------------------------------------------------
#    (Suzi / http.tcl)
#----------------------------------------------------------------------------

#    , ,   
variable author			"Vladislav"
variable version		"1.0"
variable date			"03-03-2012"
variable unamespace		[namespace tail [namespace current]]

#     (   )
variable pubprefix 		$::gprefix(1)
variable pubflag		{-|-}

#     
variable pub:imhonet		"$unamespace "

#    ,   
variable msgprefix		$::gprefix(1)
variable msgflag		{-|-}

#       
variable msg:imhonet		${pub:imhonet}
#   ,      
variable setflag		{o|o}
#   ,       ,  
variable pause			30
#      ,  $unick, $uhost, $uchan
variable requserid		{$uhost}
#        id
variable maxreqperuser	        5
#     
variable maxrequests	        15	
#  -
#   "proxyhost.dom:proxyport"   ,  -  
variable proxy 			{}
#   ,   "" --   ,
#  "no"         
variable flagactas		"no"	
#  
variable chflag  "$flagactas$unamespace"
variable chflagt "${unamespace}\-time"
setudef flag     $chflag
setudef int      $chflagt

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------

#    --          
variable logrequests	        {'$unick', '$uhost', '$handle', '$uchan', '$ustr'}
#     
variable pubsend		{PRIVMSG $uchan :}
#     
variable msgsend		{PRIVMSG $unick :}
#    / 
variable errsend		{NOTICE $unick :}
#      
variable maxredir		1
#    ,   30 
variable timeout		30000
#    
variable err_ok	                {}
#     ,     
variable err_fail		{     .      -.}
#     
variable err_queue_full	        {           .   .}	
#       id
variable err_queue_id	        {    .}	
#          
variable err_queue_time         {   .       $timewait .}
	
#----------------------------------------------------------------------------
#     
#----------------------------------------------------------------------------

# ,     
variable fetchurl "http://films.imhonet.ru/rating/popular/month/?page="

#   
variable debug 0

#  
variable 		reqqueue
array unset 	        reqqueue

#  
variable 		laststamp
array unset		laststamp 
variable		updinprogress	0
variable		updatetimeout	60000

#---body--- 
proc tolow  {strr} {return [string tolower [string map {                                                                 } $strr]]}

#   
proc time:imhonet {} {
variable chflag ; variable chflagt ; variable flagactas ; variable debug
foreach ach [channels] {
if {[validchan $ach]} {
set acht [channel get $ach $chflagt]
if {![channel get $ach $chflag] ^ $flagactas eq "no"} {continue}
if {[botonchan $ach] && $acht > 0} {
if {[texists [list [namespace current]::pub:imhonet ntime time@time htime $ach time]] == ""} {
set achn($ach) [timer $acht [list [namespace current]::pub:imhonet ntime time@time htime $ach time]]
if {$debug} {putlog "time:imhonet :: set timer - $ach - $achn($ach) - [lindex [timers] [lsearch [timers] "*$achn($ach)*"] 0] ."}
}
}
} {putlog "invalid channel $ach" ; return}
}
}

#   
proc msg:imhonet {unick uhost handle str} {pub:imhonet $unick $uhost $handle $unick $str ; return}

#   
proc pub:imhonet {unick uhost handle uchan str} {
variable requserid ; variable fetchurl ; variable pubprefix ; variable logrequests
variable chflag ; variable chflagt ; variable flagactas ; variable setflag
variable errsend ; variable pubsend ; variable msgsend
variable maxres ; variable unamespace
if {$str ne "time"} {set id [subst -noc $requserid]} {set id [unixtime]}
set prefix [subst -noc $errsend]
if {$unick ne $uchan} {if {![channel get $uchan $chflag] ^ $flagactas eq "no"} { return }}

#  
if {[string first "#" [lindex $str 0]] == 0} {
if {[validchan [lindex $str 0]] && [string is digit [lindex $str 1]]} {
if {![matchattr [nick2hand $unick] $setflag [lindex $str 0]]} {lput putserv "       " $prefix ; return}
set atimer [string trim [lindex $str 1]]
channel set [lindex $str 0] $chflagt $atimer
channel set [lindex $str 0] "-$chflag"
savechannels
if {$atimer > 0} {
[namespace current]::time:imhonet
lput putserv "     [lindex $str 0] (  $atimer .)" $prefix
} {catch {killtimer [lindex [timers] [lsearch [timers] "*[lindex $str 0]*"] end]} ; lput putserv "     [lindex $str 0]" $prefix}
} {lput putserv ": $pubprefix$unamespace # " $prefix}
return
}
set why  [queue_isfreefor $id]
if {$why != ""} {lput puthelp $why $prefix ; return}

#   
set ustr [string trim [tolow $str]]

#    :
#if {[string is space $ustr]}
#    :
if {$ustr eq "?"} {
if {$uchan eq $unick} {set prefix [subst -noc $msgsend]} {set prefix [subst -noc $errsend]}
lput puthelp ": $::gprefix(1) -    ." $prefix ; return
} {
set aurl [expr [rand 10]+1]
}

#-- http- 
if {$logrequests ne ""} {set logstr [subst -noc $logrequests] ; if {$ustr ne "time"} {lput putlog $logstr "$unamespace: $fetchurl$aurl :: "}}
::http::config -useragent "Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; PPC; 240x320)"	
if {[queue_add "$fetchurl$aurl" $id "[namespace current]::imhonet:parser" [list $unick $uhost $uchan $str]]} {
variable err_ok ; if {$err_ok ne ""} {lput puthelp "$err_ok." $prefix}
} {
variable err_fail ; if {$err_fail ne ""} {lput puthelp $err_fail $prefix}
}
if {$uchan ne $unick} {
if {[channel get $uchan $chflagt]> 0} {[namespace current]::time:imhonet}
}
return
}

#---parser
proc imhonet:parser {errid errstr body extra} {
upvar $errid lerrid $errstr lerrstr $body lbody $extra lextra
variable err_fail ; variable upd ; variable debug
variable pubsend ;variable msgsend ; variable errsend
variable useurl ; variable maxres		
foreach {unick uhost uchan ustr} $lextra {break}
if {$lerrid ne {ok}} {lput putserv [subst -noc $err_fail] [subst -noc $errsend] ; return}
if {$uchan eq $unick} {set prefix [subst -noc $msgsend]} {set prefix [subst -noc $pubsend]}

#   suzi (     cp1251,     )
if {[info exists ::sp_version]} {set str [encoding convertfrom utf-8 $lbody]} {set str $lbody]]}

#     2     ,   , :
#if {[string length $str] > 800 && $uchan ne $unick} {set prefix [subst -noc $msgsend]}

#----------------------------------------------------------------------------
#  
#----------------------------------------------------------------------------

regsub -all -- "\n|\r|\t" $str {} str
regsub -nocase -- {.*?<div class="content">} $str "" str; regsub -nocase -- {<div class="pager">.*?} $str "" str
regsub -all -nocase -- {<a class="i-write show-on-hover.*?<div class="content">} $str "" str; regsub -all -- {<!--.*?-->} $str "" str
set amsg [list]; foreach _ [split [string map {"<div class=\"description\">" "\x1F"} $str] "\x1F"] {
if {[regexp -nocase -- {<span class="h3"><a href="(.*?)">(.*?)</a></span><div class="year">(.*?)</div><div class="styles">(.*?)</div>} $_ garb text1 text2 text3 text4]} {regsub -all -- {.*?/(\d+)/.*?} $text1 {\1} text0; regsub -all -- {, (\d+)} $text3 ". $::gcolor(5)\\1$::gcolor(14)" text3; lappend amsg "{$text0} {$::gcolor(5)[sspace $text2] $::gcolor(14)([string map {"," ", "} [string tolower [sspace $text4]]]) - [sspace $text3]. -> $::gcolor(12)${text1}links}"}
}                                                                                                                                 
if {$amsg != ""} {
set amsg [lindex $amsg [rand [llength $amsg]]]
	set otzivurl [http::geturl http://films.imhonet.ru/element/[lindex $amsg 0]/ -timeout 3000]
	set otstr [regsub -all -- {\n|\r|\t|\v} [::http::data $otzivurl] ""]; ::http::cleanup $otzivurl
        set amsg2 [list]; foreach _ [split [string map {"<div class=\"description\">" "\x1F"} $otstr] "\x1F"] {
        if {[regexp -nocase -- {<p class="opinion-text">(.*?)</p>} $_ garb text1]} {set text1 [sspace [sconv [string map {"<br />" " "} $text1]]]; if {[string length $text1] >= 700} {set text1 "[string range $text1 0 700]..."}; lappend amsg2 $text1}
        }
        if {[regexp -nocase -- {<p class="element-rating-stats">(.*?),} $otstr garb text1]} {regsub -- {<span class="average">(.*?)</span>} $text1 "$::gcolor(5)\\1$::gcolor(14) " text1; set amsg3 "$::gcolor(14)[sspace [sconv [string map {"  " "" "</span>" " "} $text1]]]. "} {set amsg3 "$::gcolor(14)"}
lput putserv [lindex $amsg 1] $prefix
if {$amsg2 != ""} {lput putserv "${amsg3}:\017 [lindex $amsg2 [rand [llength $amsg2]]]" $prefix}
} {lput putserv "   ." $prefix}
return 
}

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------

#   
proc texists {cmd} {foreach i [timers] {if {![string compare $cmd [lindex $i 1]]} {return [lindex $i 2]}} ; return}

#     
proc sspace {strr} {return [string trim [regsub -all {[\t\s]+} $strr { }]]}

#   -
proc sconv {strr} {
set escapes {
        &nbsp; \x20 &quot; \x22 &amp; \x26 &apos; \x27 &ndash; \x2D
        &lt; \x3C &gt; \x3E &tilde; \x7E &euro; \x80 &iexcl; \xA1
        &cent; \xA2 &pound; \xA3 &curren; \xA4 &yen; \xA5 &brvbar; \xA6
        &sect; \xA7 &uml; \xA8 &copy; \xA9 &ordf; \xAA &laquo; \xAB
        &not; \xAC &shy; \xAD &reg; \xAE &hibar; \xAF &deg; \xB0
        &plusmn; \xB1 &sup2; \xB2 &sup3; \xB3 &acute; \xB4 &micro; \xB5
        &para; \xB6 &middot; \xB7 &cedil; \xB8 &sup1; \xB9 &ordm; \xBA
        &raquo; \xBB &frac14; \xBC &frac12; \xBD &frac34; \xBE &iquest; \xBF
        &Agrave; \xC0 &Aacute; \xC1 &Acirc; \xC2 &Atilde; \xC3 &Auml; \xC4
        &Aring; \xC5 &AElig; \xC6 &Ccedil; \xC7 &Egrave; \xC8 &Eacute; \xC9
        &Ecirc; \xCA &Euml; \xCB &Igrave; \xCC &Iacute; \xCD &Icirc; \xCE
        &Iuml; \xCF &ETH; \xD0 &Ntilde; \xD1 &Ograve; \xD2 &Oacute; \xD3
        &Ocirc; \xD4 &Otilde; \xD5 &Ouml; \xD6 &times; \xD7 &Oslash; \xD8
        &Ugrave; \xD9 &Uacute; \xDA &Ucirc; \xDB &Uuml; \xDC &Yacute; \xDD
        &THORN; \xDE &szlig; \xDF &agrave; \xE0 &aacute; \xE1 &acirc; \xE2
        &atilde; \xE3 &auml; \xE4 &aring; \xE5 &aelig; \xE6 &ccedil; \xE7
        &egrave; \xE8 &eacute; \xE9 &ecirc; \xEA &euml; \xEB &igrave; \xEC
        &iacute; \xED &icirc; \xEE &iuml; \xEF &eth; \xF0 &ntilde; \xF1
        &ograve; \xF2 &oacute; \xF3 &ocirc; \xF4 &otilde; \xF5 &ouml; \xF6
        &divide; \xF7 &oslash; \xF8 &ugrave; \xF9 &uacute; \xFA &ucirc; \xFB
        &uuml; \xFC &yacute; \xFD &thorn; \xFE &yuml; \xFF
}
set strr [string map {\[ \\\[ \] \\\] \{ \\\{ \} \\\}} [string map $escapes [join [lrange [split $strr] 0 end]]]] 
regsub -all -nocase -- {<.*?>(.*?)</.*?>} $strr {\1} strr
regsub -all -nocase -- {<.*?>} $strr {} strr
regsub -all -nocase -- {&([a-z0-9]{1,10});} $strr {} strr
regsub -all -nocase -- {&#([a-z0-9]{1,10});} $strr {} strr
return [subst -nov $strr]
}

#  
proc lput {cmd str {prefix {}} {maxchunk 420}} {
set buf1 "" ; set buf2 [list]
foreach word [split $str] {append buf1 " " $word ; if {[string length $buf1]-1 >= $maxchunk} {lappend buf2 [string range $buf1 1 end]; set buf1 ""}}
if {$buf1 != ""} {lappend buf2 [string range $buf1 1 end]}
foreach line $buf2 {$cmd $prefix$line}
return
}

#  
proc queue_isfreefor {{id {}}} {
variable reqqueue ; variable maxreqperuser ; variable maxrequests ; variable laststamp ; variable pause
variable err_queue_full	; variable err_queue_id ; variable err_queue_time 
if {[info exists laststamp(stamp,$id)]} {
set timewait [expr { $laststamp(stamp,$id) + $pause - [unixtime]}]
if {$timewait > 0} {return [subst -nocommands $err_queue_time]}			
}
if {[llength [array names reqqueue -glob "*,$id"]] >= $maxreqperuser} {return $err_queue_id}
if {[llength [array names reqqueue]] >= $maxrequests} {return $err_queue_full}
return
}

#    
proc queue_add {newurl id parser extra {redir 0}} {
variable reqqueue ; variable proxy ; variable timeout ; variable laststamp
::http::config -proxyfilter "[namespace current]::queue_proxy"
if {![catch {set token [::http::geturl $newurl -command "[namespace current]::queue_done" -binary true -timeout $timeout]} errid]} {
set reqqueue($token,$id) [list $parser $extra $redir]		
set laststamp(stamp,$id) [unixtime]
} {return false}
return true
}

# 
proc queue_proxy {url} {variable proxy ; if {$proxy ne {}} {return [split $proxy {:}]} ; return [list]}
	
#  
proc queue_done {token} {
upvar #0 $token state
variable reqqueue ; variable maxredir ; variable fetchurl		
set errid  	[::http::status $token]
set errstr 	[::http::error  $token]
set	id  	[array  names reqqueue "$token,*"]
foreach {parser extra redir} $reqqueue($id) {break}
regsub -- "^$token," $id {} id	
while (1) {
if {$errid == "ok" && [::http::ncode $token] == 302} {
if {$redir < $maxredir} {			
array set meta $state(meta)
if {[info exists meta(Location)]} {queue_add "$fetchurl$meta(Location)" $id $parser $extra [incr redir] ; break}
} {set errid   "error" ; set errstr  "Maximum redirects reached"}
} 
if {[catch {$parser {errid} {errstr} {state(body)} {extra}} errid]} {lput putlog $errid "[namespace current] "}
break
}
array unset reqqueue "$token,*"
::http::cleanup $token
return
}

#  
proc queue_clear_stamps {} {
variable laststamp ; variable timeout ; variable timerID
set curr [expr {[unixtime] - 2 * $timeout / 1000}];
foreach {id} [array names laststamp] {if {$laststamp($id) < $curr} {array unset laststamp $id}}		
set timerID [timer 10 "[info level 0]"]
}

# 
proc cmdaliases {{action {bind}}} {
foreach {bindtype} {pub msg dcc} {
foreach {bindproc} [info vars "[namespace current]::${bindtype}:*"] {
variable "${bindtype}prefix" ; variable "${bindtype}flag"			
foreach {alias} [set $bindproc] {
catch {$action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc}
}			
}
}
bind pubm - "***" [namespace current]::pub:imhonet
bind pubm - "***" [namespace current]::pub:imhonet
bind pubm - "***" [namespace current]::pub:imhonet
bind pubm - "***" [namespace current]::pub:imhonet
return
}

# 
if {[info exists timerID]} {catch {killtimer $timerID} ; catch {unset timerID}}
[namespace current]::queue_clear_stamps
[namespace current]::cmdaliases
[namespace current]::time:imhonet
variable sfil [lindex [split [info script] "/"] end]
variable modf [clock format [file mtime [info script]] -format "%d-%b-%Y : %H:%M:%S"]
#if {[info exists ::sp_version]} {putlog "[namespace current] v$version (suzi_$sp_version) :: file:$sfil / rel:\[$date\] / mod:\[$modf\] :: by $author :: loaded."} {putlog "[namespace current] v$version :: file:$sfil / rel:\[$date\] / mod:\[$modf\] :: by $author :: loaded."}
}