######################################################
# Windrop  Vladislav 
# : anaesthesia
# : 01.0
# :      .
# : !
######################################################

namespace eval life {
#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    , ,   
	variable author			"anaesthesia"
	variable version		      "01.0"
	variable date			"01-jan-2008"
	variable unamespace		[namespace tail [namespace current]]

	#     (   )
	variable pubprefix 		$::gprefix(1)
	variable pubflag		      {-|-}

	#   ()
	# pubcmd:_ "1 2 ..."
	#     ,      
	variable pub:life		"$unamespace "

	#    ,   
	variable msgprefix		$::gprefix(1)
	variable msgflag		      {-|-}

	#       
	variable msg:life		      ${pub:life}

	#*      ,      
	#*     variable [pub|msg]:handler "string ..."

	#      
	#  $unick, $uhost, $uchan
	#  tcl ,    id   .
	variable requserid		{$uhost}
	
	#        id
	variable maxreqperuser	      5

	#     
	variable maxrequests	      15

	#   ,       ,  
	variable pause			15
	
	#  -
	#   "proxyhost.dom:proxyport"   ,  -  
	variable proxy 			{}

	#   ,   "" --  
	# ,         --  
	#  "no"        
	#         
	# (      ,     )
	variable flagactas		"no"
	
	#   ,   /   
	#          
	#        
	#      
	variable chflag			"$flagactas$unamespace"
	setudef  flag 			$chflag

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    --     
	#     
	variable logrequests	{'$unick', '$uhost', '$handle', '$uchan', '$ustr'}
	
	#     ,   --  
	#  $uchan & $unick
	variable pubsend		{PRIVMSG $uchan :}

	#     ,   --  
	#   $unick ($uchan == $unick)
	variable msgsend		{PRIVMSG $unick :}
	
	#    / 
	#  $unick
	variable errsend		{NOTICE $unick :}

	#      
	variable maxredir		3
	
	#    ,   30 
	variable timeout		30000

	#    
	variable err_ok		{}

	#     ,     
	#       
	variable err_fail		{     .      -.}

	#     
	variable err_queue_full	{           .   .}
	
	#       id
	variable err_queue_id	{    .}
	
	#          
	#   $timewait --  ,   
	#   
	variable err_queue_time {   .       $timewait .}
	
#----------------------------------------------------------------------------
#     
#----------------------------------------------------------------------------

	# ,     
	variable 		fetchurl		"http://istina.rin.ru/cgi-bin/lastlife.pl"
		
	#  
	variable 		reqqueue
	array unset 	reqqueue

	#  
	variable 		laststamp
	array unset		laststamp 
	variable		updinprogress	0
	variable		updatetimeout	60000

#---body---

	proc msg:life {unick uhost handle str} {pub:life $unick $uhost $handle $unick $str ; return}

	proc pub:life {unick uhost handle uchan str} {
		variable requserid ; variable unamespace
		variable chflag ; variable flagactas ; variable logrequests
		variable pubprefix ; variable pubsend ; variable msgsend ; variable errsend
		variable query ; variable fetchurl
		set id [subst -nocommands $requserid]
		set prefix [subst -nocommands $errsend]
		if {$unick ne $uchan} {if {![channel get $uchan $chflag] ^ $flagactas eq "no" } { return }}
		set why  [queue_isfreefor $id]
		if {$why != ""} {lput puthelp $why $prefix ; return}
		set query ""
		set ustr $str
		if {$uchan eq $unick} {set prefix [subst -nocommands $msgsend]} {set prefix [subst -nocommands $errsend]}
		if {[string is space $ustr] || ![regexp -- {(\d+)-(\d+)-(\d+)} $ustr -> day month year]} {
		lput puthelp ": $::gprefix(1) <-->" $prefix		
		return
		}
		set day [scan $day %d]; set month [scan $month %d]; set year [scan $year %d]
		if {$day > 31 || $day < 1 || $month > 12 || $month < 1 || $year > 2019 || $year < 1920} {
		lput puthelp "  : -- (1..31-1..12-1920..2019)" $prefix		
		return
		}
		::http::config -urlencoding cp1251 -useragent "Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; PPC; 240x320)"	
		set query [::http::formatQuery day $day month $month year $year sait 2 submit " "]
		if {$logrequests ne ""} {set logstr [subst -nocommands $logrequests] ; lput putlog $logstr "$unamespace: "}
		if {[queue_add "$fetchurl" $id "[namespace current]::dream:parser" [list $unick $uhost $uchan $str]]} {
		variable err_ok ; if {$err_ok ne ""} {lput puthelp "$err_ok." $prefix}
		} {
		variable err_fail ; if {$err_fail ne ""} {lput puthelp "$err_fail" $prefix}
		}
	      return
	      }

#---parser
	proc dream:parser {errid errstr body extra} {
		upvar $errid lerrid $errstr lerrstr $body lbody $extra lextra
		variable err_fail ; variable pubsend ; variable msgsend ; variable errsend
		foreach {unick uhost uchan ustr} $lextra {break}
		if {$lerrid ne {ok}} {lput putserv [subst -nocommands $err_fail] [subst -nocommands $errsend] ; return}
		if {$uchan eq $unick} {set prefix [subst -nocommands $msgsend]} {set prefix [subst -nocommands $pubsend]}
		if {[info exists ::sp_version]} {set str [encoding convertfrom cp1251 $lbody]} {set str $lbody}

#----------------------------------------------------------------------------
##---parser-specific------
#----------------------------------------------------------------------------
	if {[regexp -- {<a class=nav>(.+?)</td>} $str -> lres]} {
		regsub -all -- "\n|\r|\t" $lres "" lres
		regsub -all -- "<p.*?>" $lres " :: " lres
		regsub -all -nocase -- "<b>|</b>" $lres "\002" lres
		regsub -all -- "<.*?>" $lres " " lres
		lput putserv [sspace $lres] $prefix
	      } {lput putserv "\037 (001)\037" $prefix}
	      return
	      }		
#----------------------------------------------------------------------------
##---end-parser------
#----------------------------------------------------------------------------

	proc sspace {strr} {return [string trim [regsub -all {[\t\s]+} $strr { }]]}
	proc tolow  {strr} {return [string tolower [string map {                                                                 } $strr]]}

	proc lput {cmd str {prefix {}} {maxchunk 420}} {
	set buf1 ""; set buf2 [list]
	foreach word [split $str] {append buf1 " " $word ; if {[string length $buf1]-1 >= $maxchunk} {lappend buf2 [string range $buf1 1 end]; set buf1 ""}}
	if {$buf1 != ""} {lappend buf2 [string range $buf1 1 end]}
	foreach line $buf2 {$cmd $prefix$line}
	return
	}

	proc queue_isfreefor {{ id {}}} {
	variable reqqueue ; variable maxreqperuser ; variable maxrequests ; variable laststamp
	variable pause ; variable err_queue_full ; variable err_queue_id ; variable err_queue_time 
	if {[info exists laststamp(stamp,$id)]} {set timewait [expr {$laststamp(stamp,$id) + $pause - [unixtime]}] ; if {$timewait > 0} {return [subst -nocommands $err_queue_time]}}
	if {[llength [array names reqqueue -glob "*,$id"]] >= $maxreqperuser} {return $err_queue_id}
	if {[llength [array names reqqueue]] >= $maxrequests} {return $err_queue_full}		
	return
	}

	proc queue_add {newurl id parser extra {redir 0}} {
	variable reqqueue ; variable proxy ; variable timeout ; variable laststamp ; variable query
	::http::config -proxyfilter "[namespace current]::queue_proxy"
	if {$query eq ""} {
	if {![catch {set token [::http::geturl $newurl -command [namespace current]::queue_done -binary true -timeout $timeout]} errid]} {					
	set reqqueue($token,$id) [list $parser $extra $redir] ; set laststamp(stamp,$id) [unixtime]
	} {return false}
	} {
	if {![catch {set token [::http::geturl $newurl -command [namespace current]::queue_done -binary true -timeout $timeout -query $query]} errid]} {					
	set reqqueue($token,$id) [list $parser $extra $redir] ; set laststamp(stamp,$id) [unixtime]
	} {return false}
	}
	return true
	}

	proc queue_proxy {url} {
	variable proxy
	if {$proxy ne {}} {return [split $proxy {:}]}		
	return [list]
	}
	
	proc queue_done {token} {
	upvar #0 $token state
	variable reqqueue ; variable maxredir ; variable fetchurl
	set errid  	[::http::status $token]
	set errstr 	[::http::error  $token]		
	set	id  	[array  names reqqueue "$token,*"]
	foreach {parser extra redir} $reqqueue($id) {break}
	regsub -- "^$token," $id {} id
	while (1) {
	if {$errid == "ok" && [::http::ncode $token] == 302} {
	if {$redir < $maxredir} {			
	array set meta $state(meta)
	if {[info exists meta(Location)]} {queue_add "$fetchurl$meta(Location)" $id $parser $extra [incr redir]; break}
	} {set errid "error" ; set errstr "Max. redir."}
	} 	
	if {[catch {$parser {errid} {errstr} {state(body)} {extra}} errid]} {lput putlog $errid "[namespace current] "}
	break
	}			
	array unset reqqueue "$token,*"
	::http::cleanup $token
	return
	}

	proc queue_clear_stamps {} {
	variable laststamp ; variable timeout ; variable timerID
	set curr [expr {[unixtime] - 2 * $timeout / 1000}];
	foreach {id} [array names laststamp] {if {$laststamp($id) < $curr} {array unset laststamp $id}}		
	set timerID [timer 10 "[info level 0]"]
	}

	proc cmdaliases {{ action {bind}}} {
	foreach {bindtype} {pub msg dcc} {
	foreach {bindproc} [info vars "[namespace current]::${bindtype}:*"] {
	variable "${bindtype}prefix" ; variable "${bindtype}flag"			
	foreach {alias} [set $bindproc] {catch {$action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc}}				
	}
	}	
	return
	}

#---init
	if {[info exists timerID]} {catch {killtimer $timerID} ; catch {unset timerID}}	
	[namespace current]::queue_clear_stamps
	foreach bind [binds "[namespace current]::*"] {catch {unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]}}
	[namespace current]::cmdaliases
  	variable sfil [lindex [split [info script] "/"] end]
  	variable modf [clock format [file mtime [info script]] -format "%d-%b-%Y : %H:%M:%S"]

}
