######################################################
# Windrop  Vladislav 
# : Shrike
# : 1.2.1
# :       .
# : !
######################################################

setudef flag nonewyear

foreach p [array names newyear *] { catch {unset newyear($p) } }
namespace eval newyear {}

foreach bind [binds "::newyear::*"] {
catch {unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]}
}

set newyear(default_gmt) "+5"

bind pub - $::gprefix(1)  	        ::newyear::pub
bind msg - $::gprefix(1)  	        ::newyear::msg
bind pub - $::gprefix(1)newyear       ::newyear::pub
bind msg - $::gprefix(1)newyear       ::newyear::msg
bind time - "00 00 01 00 *"           ::newyear::banner
bind pub n|n $::gprefix(1) ::newyear::banner

#############################################################
set newyear(dur_array) {
	{	{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}}}
	{	{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}}} 
	{	{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}}} 
	{	{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}}} 
	{	{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}}} 
	{	{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}} {{} {} {} {}}
		{{} {} {} {}}}
}

proc ::newyear::duration { time {mode 0} {text ""} } {
	global newyear
	set ret ""; set m $mode; if { $text == "" } { set expire [::duration $time]} { set expire $text }
	for { set s1 0 } { $s1 <= 6 } { incr s1 } {
	if { $mode == 3 } { set s2 [expr {6-$s1}] } { set s2 $s1 }
	switch -exact $s2 {
			0 {	set re {([0-9]+?)\ year} }
			1 {	set re {([0-9]+?)\ month} }
			2 {	set re {([0-9]+?)\ week} }
			3 {	set re {([0-9]+?)\ day} }
			4 {	set re {([0-9]+?)\ hour} }
			5 {	set re {([0-9]+?)\ minute} }
			6 {	set re {([0-9]+?)\ second} }
		}
	if { [regexp -nocase -- $re $expire g d] } {
			set k $d
			while {$k>10} { incr k -10 }
			if {($d>10 && $d<21) || $k>4 || $d==0} {
			append ret " $d [lindex [lindex [lindex $newyear(dur_array) $m] $s2] 2]"
			} elseif {$k==1} { 
			if {$d==1} { 
			append ret " $d [lindex [lindex [lindex $newyear(dur_array) $m] $s2] 0]" 
			} else { 
			append ret " $d [lindex [lindex [lindex $newyear(dur_array) $m] $s2] 3]" 
			}
			} elseif {$k<5} {
			append ret " $d [lindex [lindex [lindex $newyear(dur_array) $m] $s2] 1]"
			} else {
			append ret " $d [lindex [lindex [lindex $newyear(dur_array) $m] $s2] 2]"
			}
		      }	
		
	if { $m == 3 && $ret != "" } { set m 2 }
	}
	set ret [string trim $ret]
	return $ret
      }

proc ::newyear::msg {nick uhost hand args} {
	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	::newyear::newyear $nick $uhost $hand $nick $args
      }

proc ::newyear::pub {nick uhost hand chan args} {
      if {[channel get $chan nonewyear]} { return }
	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	::newyear::newyear $nick $uhost $hand $chan $args
      }

proc ::newyear::banner { mi ho da mo ye } {
	foreach chan [channels] {
	if {![channel get $chan nonewyear]} {
	putquick "PRIVMSG $chan :$::gcolor(14)*$::gcolor(5)*$::gcolor(6)* $::gcolor(4)\002   $chan !!! \002$::gcolor(6)*$::gcolor(5)*$::gcolor(14)*"
	}
	}
      }

proc ::newyear::newyear {nick uhost hand chan args} {
      global newyear
	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	set gmt [string trim [lindex $args 0]]
	if {[string is space $gmt]} {set gmt $newyear(default_gmt)}
	set year [string trim [lindex $args 1]]
	if {[string is space $year]} {set year [clock format [clock scan "next year" -gmt 1] -format "%Y" -gmt 1]}
	if { ![regexp -- {^\-|\+[0-9]+$} $gmt ] } { set year $gmt; set gmt "" }
      if {[string is space $gmt]} {set gmt $newyear(default_gmt)}
	if { [expr {$gmt >12 || $gmt < -12}] } { ::egglib::outn $nick ": $::gprefix(1) \[+|- \] \[\]"; return }
	set thisy [clock format [clock scan "today" -gmt 1] -format "%Y" -gmt 1]
	if { ![regexp -- {^[0-9]+$} $year ] } { ::egglib::outn $nick ": $::gprefix(1) \[+|- \] \[\]"; return }
	if { [expr {$year < 1970}] } { ::egglib::outn $nick "    ..."; return }
	if { [expr {$year >= 2200}] } { ::egglib::outn $nick "      ..."; return }
	if { [catch {
	set today [expr {[clock scan "today" -gmt 1]+$gmt*60*60}]
	set next [clock scan "$year-01-01 00:00 GMT" -gmt 1]
	} err] } { ::egglib::outn $nick ": $::gprefix(1) \[+|- \] \[\]"; return }
	if { [expr {$next - $today < 0}] } {
	set out [::newyear::duration [expr {$today-$next}] 0]
	if { $year == $thisy } { putquick "PRIVMSG $chan :$::gcolor(5)   :$::gcolor(14) $out." } { putquick "PRIVMSG $chan :$::gcolor(5) $year  :$::gcolor(14) $out." }
	return
	}
	set out [::newyear::duration [expr {$next-$today}]]
	if { $thisy+1 == $year } { putquick "PRIVMSG $chan :$::gcolor(5)   :$::gcolor(14) $out." } { putquick "PRIVMSG $chan :$::gcolor(5) $year  :$::gcolor(14) $out." }
      }