######################################################
# Windrop  Vladislav 
# : Vertigo mod Vladislav
# : 1.2
# : C   Google Yandex.
# : ! !
######################################################

namespace eval ::poisk {

foreach _ [binds ::poisk::*] { catch {unbind [lindex $_ 0] [lindex $_ 1] [lindex $_ 2] [lindex $_ 4]} }

variable binds {google  yandex }
variable private 1

foreach _ $binds { bind pub - $::gprefix(1)$_ ::poisk::pub; if {$private} {bind msg - $::gprefix(1)$_ ::poisk::msg} }

variable cachetext {}
variable redirs 0

setudef flag nopoisk

proc msg {nick uhost hand text} {
main $nick $uhost $hand $nick $text
}

if {[string is space [info command ::putfast]]} {
proc putfast {text} {
putnow $text
}
}

proc pub {nick uhost hand chan text} {
if {[channel get $chan nopoisk]} { return }
main $nick $uhost $hand $chan $text
}

proc main {nick uhost hand chan text} {
variable cachetext
set opts [list "Accept-Encoding" None]
if {$nick eq $chan} {set dest ""; set how "PRIVMSG"} else {set dest ""; set how "NOTICE"}
if {$text eq ""} {usage $nick $dest $how; return 0}
if {[regexp -- {^-(\d+)\s} $text -> num]} { regsub -- "-$num " $text "" text } elseif {[regexp -- {^-(\d+)} $text -> num] && [llength [split $text]] eq 1} { regsub -- "-$num" $text "" text } else { set num 1 }
if {$text ne ""} {set cachetext $text}
if {$cachetext ne {} && $text eq ""} {set text $cachetext}
if {$text eq ""} {usage $nick $dest $how; return 0}
if {$num <= 0} {set num 1}
set page ""
switch -glob -- $::lastbind {
"**" -
"*google*" {set mode 1;
::http::config -useragent "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727; .NET CLR 3.0.04506.30)" -urlencoding utf-8
set text [::http::formatQuery [string map -nocase {def: define:} $text]]
if {$num <= 10 || [string match -nocase "*define:*" "*$text*"]} {set url "http://www.google.ru/search?hl=ru&lr=&newwindow=1&q=$text&start=0&sa=N&num=10&filter=0&nocalc=1"} else {
set num_ [expr $num-1]
set page [expr [expr {$num_/10}] * 10]
set url "http://www.google.ru/search?hl=ru&lr=&newwindow=1&q=$text&start=$page&sa=N&num=10&filter=0&nocalc=1"}
}
"**" -
"*yandex*" {set mode 2;
::http::config -useragent "Opera 9.52 (Windows NT 5.1; RU)" -urlencoding utf-8
set text [::http::formatQuery $text]
if {$num <= 10} {set url "http://yandex.ru/yandsearch?text=$text&rd=0&lr=1"} else {
set num_ [expr $num-1]
set page [expr {$num_/10}]
set url "http://yandex.ru/yandsearch?p=$page&text=$text&rd=0&lr=1"
set opts [list "Content-Encoding" None "Accept-Encoding" None Accept "text/html"]
}
}
default {putfast "NOTICE $nick :    ..."; return 0}
}
set extra [list $nick $chan $text $mode $num $page]
putloglev d * "::poisk_:: url: $url"
if {[catch {set token [::http::geturl $url -timeout 60000 -protocol 1.0 -headers $opts -blocksize 4096 -command [list ::poisk::done $extra]]} err]} {
putfast "NOTICE $nick :,      ."
return 1
}
}

proc out {msg dest} {
if {[string index $dest 0] == "#" && [validchan $dest] && [lsearch [split [getchanmode $dest] ""] "c"] != "-1"} { set msg [stripcodes c $msg] }
regsub -all -- {(xn--.+?\.?)(/)} [string map [list \[ \\\[ \] \\\] \{ \\\{ \} \\\} \$ \\\$ \\ \\\\] $msg] "\[encoding convertfrom utf-8 \[::ccs::idna::decode \\1\]\]\\2" msg; set msg [subst -novar $msg]
if {[string bytelength $msg] < 570} { putfast "PRIVMSG $dest :$msg" } else {
set i 0
set outmsg [list]
foreach _ [split $msg] {
incr i
lappend outmsg $_
if {[llength $outmsg] >= 50 || [string bytelength [join $outmsg]] >= 570 || $i == [llength [split $msg]]} { 
if {$i <= 50} {putserv "PRIVMSG $dest :[join $outmsg]"} else { putserv "PRIVMSG $dest :[join $outmsg]" }
set outmsg [list]
}
}
}
}

proc done {extra token} {
upvar #0 $token state
variable redirs
foreach {nick chan text mode num page} $extra {break}
set status $state(status)
if {$status ne "ok"} {
putlog "::poisk_::debug: status=$status :: errinfo=[::http::error $token]"
foreach {_ __} [::http::meta $token] {putlog "::poisk_:: meta_debug: \002$_\002 $__"}
foreach _ [split [::http::data $token] \n] {putlog "::poisk_:: debug: $_"}
out "    ." $chan; ::http::cleanup $token; return 1
}
set data [string map {{&amp;} {&} {&quot;} {"} {&middot;} {} {&#39;} {'} {&#036;} {$}} $state(body)]
array set meta $state(meta)
if {[info exists meta(Location)]} {
::http::cleanup $token
if {[incr redirs] >= 4} {putlog "::poisk_:: maximum redirects reached - stopping. mode=$mode"; set redirs 0; return}
if {[catch {set token [::http::geturl $meta(Location) -timeout 60000 -protocol 1.0 -blocksize 4096 -command [list ::poisk::done $extra]]} err]} {
putfast "NOTICE $nick :,          ."
return 1
}
return
}
if {[set ncode [http::ncode $token]] != "200"} {
::http::cleanup $token
putserv "NOTICE $nick :     . ($ncode)"
return 0
}
set redirs 0
::http::cleanup $token

# google
if {$mode eq 1} {
regsub -nocase -- {^.*?id=resultStats>} $data "" data
regsub -all -- "\n|\r|\t" $data "" data
set data [string map -nocase {{<h3 class="r">} "\n\<h3 class=\"r\"\>" {<li class=g><h3 class=r>} "\n\<h3 class=r\>" {</a></p>} "\n<\/a><\/p>" {</a><p><li>} "\n<\/a><\/p><li>" {</div></a><td valign=top style="padding-right:10px">} \n} $data]
set total ""; set maybe ""
if {![regexp -nocase -- {</b>   <b>(.*?)</b> } $data -> total] && ![regexp -nocase -- {  <b>(.*?)</b> } $data -> total] && ![regexp -nocase -- {  <b>(.*?)</b> } $data -> total] && ![regexp -nocase -- {<div>:\s* (.*?)</div></div></td>.*?</span> </li>} $data -> total]} {set total "N/A"} else {set total [string range $total 0 299]}
regsub -all -- {<.*?>} $total "" total
if {[regexp -nocase -- {warning.gif".*?>(.*?:)</div></div></div>} $data -> wmsg]} {
regsub -all -- {<.*?>} [string map {{"<b>} \002 {</b>"} \002 {<b>} \002 {</b>} \002 {&nbsp;} ""} $wmsg] " " wmsg
} else {
set wmsg ""
}
regexp -nocase -- {,    (.*?)</a>} $data -> maybe
regsub -all -nocase -- "</font>.*class=p>" $maybe "" maybe
regsub -all -nocase -- "<i>|</i>" $maybe "\037" maybe
regsub -all -nocase -- "<b>|</b>" $maybe "" maybe
regsub -nocase -- ".*class=spell>" $maybe " " maybe
regsub -all -- {<.*?>} $maybe "" maybe
regsub -all -nocase "&nbsp;" $total "" total
if {[regexp -nocase -- {did not match any documents} $data] || [regexp -nocase -- {    } $data]} {set notfound 1} else {set notfound 0}
set found ""
if {[string match -nocase "*<span class=med>  *" $data]} {regsub -nocase -- ".*<span class=med>  " $data "" data}
regsub -nocase -- {^.*?<h2 class=hd> } $data "" data
regsub -nocase -- {^.*<div id="ires">} $data "" data
foreach html [split $data \n] {
if {([regexp -nocase -- {<h3 class="r"><a href="(.*?)<br><div>} [string range $html 0 1999] -> info] || [regexp -nocase -- {^<a href=(\"http.*?</a><br>)} [string range $html 0 1999] -> info] || [regexp -nocase -- {</a></p>.*?<li>(.*?)<font color=} $html -> info]) && ![string match -nocase "*maps*google*" "*$info*"] && ![string match -nocase "*  *" "*$info*"]} {
lappend found $info
}
}
if {$total eq "N/A" && [string match -nocase "*define%3a*" "*$text*"]} {
set total [llength $found]
}
if {$found == {} && $maybe == "" && $notfound == 0} {
if {![string match -nocase "*define%3a*" "*$text*"]} {
putfast "NOTICE $nick :     .";unset -nocomplain data ""; return
} else {
putfast "NOTICE $nick :     ."
unset -nocomplain data
return
}
}
if {$maybe != "" && $num <= 1} {out ",    $maybe." $chan}
if {$notfound == 1} {out "  ." $chan; return 0}
set num [scan $num %d]
set len [llength $found]
set pos $num
if {$num < 11 || [string match -nocase "*define%3a*" "*$text*"]} {set num $num} else {set num [string index [scan $num %d] end]}
if {$num > $len} {out "    $len ." $chan; return 0}
set res [string map -nocase {"<b>" "\002" "</b>" "\002" "<em>" "\002" "</em>" "\002" "</a></h3>" "\017\" :: " "</a><br>" "\017\" :: " "<br>" " "} [lindex $found [expr $num-1]]]
regsub -nocase -- {</cite>.*?$} $res "" res
regsub -nocase -- {/url\?q=(http.*?)&sa=.*?>} [string map [list \[ \\\[ \] \\\] \{ \\\{ \} \\\} \$ \\\$ \\ \\\\] $res] "\037$::gcolor(12)\[encoding convertfrom utf-8 \[string urldecode \\1\]\]\017 - \"$::gcolor(5)" res; set res [subst -novar $res]
regsub -all -nocase -- {<cite>.*?$} $res "~@@~" res
regsub -nocase -- {\s?onmousedown=\".*?\)\">} $res "" res
regsub -all -nocase -- ".*? " $res "" res
regsub -all -nocase -- "~@@~(.+?) -.*" $res " \017\(\\1\)\017" res
regsub -all -nocase -- "<span class=f>(.*?)HTML</a><br>" $res "" res
regsub -all -nocase -- "<span\ (.*?)</span>" $res "" res
regsub -all -- "<.*?>" $res "" res
regsub -all -- {[\x20\x09]+} $res " " res
set res [string map {"~@@~\} \{" "" "\ \}" "" "\ \{" "" "~@@~" "" "&nbsp;" " " {&lt;} {<} {&gt;} {>} {&amp;} {&} %3F \x3F %3D \x3D %26 \x26} $res]
if {![string is space $wmsg]} {out "$::gcolor(4)$wmsg" $chan}
out "$::gcolor(14)$pos.\017 $res $::gcolor(14)\[\003: $total$::gcolor(14)\]\003" $chan
}

# yandex
if {$mode eq 2} {
regsub -all -- "\n|\r|\t" $data "" data
regsub -nocase -- "<div class=\"b-pager\">.*" $data "" data
set data [string map -nocase {{<div class="title">} \n {<div class="cr">} \n {<li class="cr">} \n {<b class="cu">} \n {<b class="b-serp-item__number">} \n} $data]
if {![regexp -nocase -- {<strong class="text">(.+?)</strong></div>} $data -> total] && ![regexp -nocase -- {<strong class="l">(.+?)</strong></div>} $data -> total] && ![regexp -nocase -- {<strong class="b-head-logo__text">(.+?)</strong>} $data -> total]} {set total 0}
set total [string map -nocase {"" "" "" "" " " "" " " "" " " "" "" "" <br/> "" <br> "" "&nbsp;" " "} $total]
set results [list]
set url ""; set title ""; set descr ""
if {([regexp -nocase -- {<td> .*\)\;\">(.+?)</a></td></tr>} $data -> mb] || [regexp -nocase -- {<div class="z-misspell__text">.*?onmousedown=.*?;">(.*?)</a>} $data -> mb]) && $num <= 1} {out ",  : [string map -nocase {{<b class="z-misspell__error">} \037 {</b>} \037 "&laquo;" {"} "&raquo;" {"} {<span style="color: red;">} "\037" {</span>} "\037"} $mb.]" $chan}
if {[string match -nocase "*******" $data]} {out "  ." $chan; return 0}
regsub -nocase -- {^.*?<div class="b-body-items\s?"\s?>} $data "" data
foreach line [split $data \n] {
if {[regexp -nocase -- {.*" href="(http.+?)"\s?.*?target=_blank>(.+?)<div class="kk">(.*?<span class=).*?</span></div>} $line -> url title descr] || [regexp -nocase -- {.*?href="(http.+?)"\s?.*?target="?_blank"?>(.+?)</a>.*?(?:.*?<div class="b-serp-item__text">(.*?)</div>)?.*?</li>} $line -> url title descr]} {lappend results "{$url} {$title} {$descr}"}
}
if {![llength $results] && $total ne 0} {out "     ." $chan; return 0}
if {![llength $results] && $total eq 0} {out "  ." $chan; return 0}
set len [llength $results]
set num [scan $num %d]
set pos $num
if {$num < 11} {set num [expr $num -1]} else {set num [string index [scan $num %d] end]}
if {$num >= $len} {out "    $len ." $chan; return 0}
set string [string map -nocase {"<b>" "\002" "</b>" "\002" "<em>" "\037" "</em>" "\037" "<wbr />" "" "</a>" "" "<span>" "" "</span>" " " "<br>" "" "<br/>" " " "&lt;" "<" "&gt;" ">" {&nbsp;} { } {&mdash;} {} {&ndash;} {} {&laquo;} {} {&raquo;} {}} [lindex $results $num]]
set url [lindex $string 0]
set title [string trim [lindex $string 1]]
set descr_ [lindex $string 2]
if {![regexp -nocase -- {<div class="text">(.+?)</div>} $descr_ -> descr] && ![regexp -nocase -- {(.+?)<span class=} $descr_ -> descr]} {set descr ""}
if {$descr ne ""} {regsub -all -- "<.*?>" $descr "" descr}
if {$title ne ""} {regsub -all -- "<.*?>" $title "" title}
if {![regexp -nocase -- {.*&middot(.+?)</div>.*<div class="info">} $descr_ -> size]} {set size ""}
if {$url eq "" && $title eq ""} {out "     ." $chan; return 0}
if {$url ne ""} {set url "$::gcolor(12)\037$url\017"}
if {$title ne ""} {set title " - \"$::gcolor(5)$title\017\" ::"}
if {$descr ne ""} {set descr " \017[string trim [regsub -all -- {[\x20]+} $descr " "]]"}
if {$size ne ""} {set size " \017- [string trim $size]"}
if {$len eq 1} {out "$url$title$descr$size$::gcolor(14)\[\003: $total$::gcolor(14)\]\003" $chan} else {
out "$::gcolor(14)$pos.\017 $url$title$descr$size $::gcolor(14)\[\003: $total$::gcolor(14)\]\003" $chan
}
}
}

proc usage {nick dest how} { puthelp "$how $nick :: $::lastbind \[-\] <> -   ." }
return
}