####################################################
# Windrop  Vladislav 
# : Vertigo
# : 1.8
# :       http://uptime.eggheads.org
# : !rank [-] <- >
#          !rank <>    ,   <>.
####################################################

namespace eval rank {

variable prefix $::gprefix(1)
set check(delay) "10"

bind pub - ${prefix}rank [namespace current]::pub
bind pub - ${prefix} [namespace current]::pub
bind msg - ${prefix}rank [namespace current]::msg
bind msg - ${prefix} [namespace current]::msg

setudef flag norank
############################################################

proc msg { nick uhost hand text } {
main $nick $uhost $nick $nick $text
}

proc pub { nick uhost hand chan text } {
if {[channel get $chan norank]} { return }
main $nick $uhost $hand $chan $text
}

proc main {nick uhost hand chan text} {
if {[info exists rank::check(lasttime,$uhost)] && [expr $rank::check(lasttime,$uhost) + $rank::check(delay)] > [clock seconds] && ![matchattr $hand n]} { putserv "NOTICE $nick : $::gprefix(1)      [rank::duration [expr $rank::check(delay) - [expr [clock seconds] - $rank::check(lasttime,$uhost)]]]."; return }
if {[regexp -nocase -- {^-(\d+)} $text -> num]} {regsub -- {-\d+\s?} $text "" text} {set num 1}
if {[string is space $text]} {putserv "NOTICE $nick :: $::gprefix(1) \[-\] \[-top \[-\]\] \<- \>"; return }
set rank::check(lasttime,$uhost) [clock seconds]
::http::config -urlencoding utf-8 -useragent {Opera/9.80 (Windows NT 6.1; U; ru) Presto/2.6.30 Version/10.60}
set opts "?botnick=[::http::formatQuery $text]"
if {[regexp -nocase -- {^-top} $text]} {
regsub -- {\s?-top\s?} $text "" text
if {[regexp -- {^(\d+)-(\d+)$} $text -> rangemin rangemax]} {set rangemin [scan $rangemin %d]; set rangemax [scan $rangemax %d]} else {set rangemin 1; set rangemax 10}
if {$rangemin > $rangemax || [expr {$rangemax-$rangemin}] eq "0"} {putserv "PRIVMSG $chan :$nick:   ."; return}
if {[expr {$rangemax-$rangemin}] > 10} {putserv "PRIVMSG $chan :$nick,   . ";return}
if {$rangemin eq 0} {set rangemin 1; set rangemax 10}
set opts "?top=10&offset=[expr $rangemin - 1]"
set text [list top $rangemin $rangemax]
}
if {[string is integer $text] && [llength [split $text]] eq 1 && $text > 0} {
set opts "?top=5&offset=[expr $text - 1]"
set text "place"
}
if {[catch {set token [http::geturl http://uptime.eggheads.org/$opts -timeout "16000" -command [list [namespace current]::data $nick $chan [scan $num %d] $text]]} err]} {
putserv "NOTICE $nick :    !"
return
}
}

proc data {nick chan num text token} {
if {[::http::status $token] ne "ok" || [::http::ncode $token] ne "200"} {
putserv "NOTICE $nick :    ..."
::http::cleanup $token
return
}
set data [::http::data $token]
::http::cleanup $token
set res [regsub -all -- {<.*?>} [parse $data] ""]
if {[lindex $text 0] eq "top"} {
set rmin [lindex $text 1]
set rmax [lindex $text 2]
set rmid [expr ($rmax - $rmin)]
set msg [list]
set i 0
foreach _ $res {
lappend msg "[lindex $_ 0]. $::gcolor(4)[lindex $_ 1]$::gcolor(14) \($::gcolor(6)[string trim [string map {" years" "." " days" "." " hours" "." " hour" "." " day" "." " year" "."} [lindex $_ 3]]]$::gcolor(14)\)\003" 
if {[incr $i] == $rmid} {break}
}
out $chan "$::gcolor(14) :$::gcolor(5) [join $msg "$::gcolor(14),$::gcolor(5) "]$::gcolor(14)."
return
}
if {$text eq "place"} {
lassign [lindex $res 0] place botname version uptime
if {[string is space $place]} {
putserv "PRIVMSG $chan : ..."
return
}
if {$place eq "****"} { set place " " } else { set place " $::gcolor(4) $place$::gcolor(14) " }
out $chan "$::gcolor(14) $::gcolor(4)$botname$::gcolor(14) ($::gcolor(5)$version$::gcolor(14), :$::gcolor(6) [string trim [string map {" years" "." " days" "." " hours" "." " hour" "." " day" "." " year" "."} $uptime]]$::gcolor(14)) $place.\003"
return
}
if {$res eq 0} { out $chan "    $text."; return }
set total [llength $res]
if {$num > $total} {
set num $total
out $chan "     .    ."
}
set str [lindex $res [expr $num - 1]]
lassign $str place botname version uptime
if {[string is space $place]} { out $chan "    $text."; return }
if {$place eq "****"} { set place " " } else { set place " $::gcolor(4) $place$::gcolor(14) " }
out $chan "$::gcolor(14)\[$::gcolor(6)$num$::gcolor(14)/$total\]  $::gcolor(4)$botname$::gcolor(14) ($::gcolor(5)$version$::gcolor(14), :$::gcolor(6) [string trim [string map {" years" "." " days" "." " hours" "." " hour" "." " day" "." " year" "."} $uptime]]$::gcolor(14)) $place.\003"
}

proc out {dest text} {
putserv "PRIVMSG $dest :$text"
}

proc parse {data} {
set data [string map {\n "" \t "" \r "" {<td class="botrank"} \n} $data]
set res [list]
foreach _ [split $data \n] {
if {[regexp -nocase -- {<a class="menu".*?">(.*?)</a></td><td class="dataitem".*?">(.*?)</a></td><td class="dataitem".*?">(.*?)</a></td><td class="dataitem".*?">(.*?)</a></td>\s?</tr>} $_ -> place botname version uptime]} {
lappend res [list $place $botname $version $uptime]
}
}
if {![llength $res]} {
return 0
} else {
return $res
}
} 

proc duration {seconds} {
	set years [expr {$seconds / 31449600}]
	set seconds [expr {$seconds % 31449600}]
	set weeks [expr {$seconds / 604800}]
	set seconds [expr {$seconds % 604800}]
	set days [expr {$seconds / 86400}]
	set seconds [expr {$seconds % 86400}]
	set hours [expr {$seconds / 3600}]
	set seconds [expr {$seconds % 3600}]
	set minutes [expr {$seconds / 60}]
	set seconds [expr {$seconds % 60}]
	set res ""
	if {$years != 0} {lappend res [numgrp $years "" "" ""]}
	if {$weeks != 0} {lappend res [numgrp $weeks "" "" ""]}
	if {$days != 0} {lappend res [numgrp $days "" "" ""]}
	if {$hours != 0} {lappend res [numgrp $hours "" "" ""]}
	if {$minutes != 0} {lappend res [numgrp $minutes "" "" ""]}
	if {$seconds != 0} {lappend res [numgrp $seconds "" "" ""]}
	return [join $res ", "]
}
proc numgrp {val str1 str2 str3} {
	set d1 [expr $val % 10]
	set d2 [expr $val % 100]
	if {$d2 < 10 || $d2 > 19} {
	if {$d1 == 1} {return "$val $str2"}
	if {$d1 >= 2 && $d1 <= 4} {return "$val $str3"}
	}
	return "$val $str1"
}
}