####################################################
# Windrop  Vladislav 
# : Vertigo
# : 1.4
# :     sonni.ru      ;)
# : !
####################################################

namespace eval ::sonnic {

bind pub - $::gprefix(1) 	::sonnic::sonnic_pub
bind pub - $::gprefix(1) 	      ::sonnic::sonnic_pub
bind msg - $::gprefix(1) 	::sonnic::sonnic_msg
bind msg - $::gprefix(1) 	      ::sonnic::sonnic_msg

setudef flag nosonnic

proc sonnic_msg {nick uhost hand text} {
sonnic_pub $nick $uhost $hand $nick $text
}

proc sonnic_pub {nick uhost hand chan text} {
if {[string index $chan 0] eq "#" && [channel get $chan nosonnic]} { return }
if {$nick eq $chan} {set method "PRIVMSG"} else {set method "NOTICE"}
if {[string is space $text]} { putserv "$method $nick :: $::gprefix(1) <    >"; return }
::http::config -urlencoding cp1251 -useragent "Opera/9.62; Windows NT 6.0; RU_ru; Presto/2.2.1"
set extra [list $nick $chan $text]
set text [::http::formatQuery $text]
set token [::http::geturl "http://sonnic.ru/search.php?key=$text" -timeout 20000 -command [list ::sonnic::sonnic_data $extra]]
return 0
}

proc sonnic_data {extra token} {
foreach {nick chan text} $extra {break}
if {$nick eq $chan} {set method "PRIVMSG"} else {set method "NOTICE"}
if {[::http::status $token] eq "ok" && [string index [::http::ncode $token] 0] eq "3"} {
	array set meta [::http::meta $token]
	if {[info exists meta(Location)]} {
		::http::geturl "$meta(Location)" \
		-timeout 20000 \
		-command [list ::sonnic::sonnic_data $extra]
		::http::cleanup $token
		return 0
		}
		putlog "::sonnic:: error while redirecting!"
		return 1
	}

if {[::http::status $token] eq "ok" && [::http::ncode $token] eq "200"} {
	set html [::http::data $token]
	::http::cleanup $token
	regsub -all -- "\n|\r|\t" $html "" html
	if {[regexp -nocase -- {<div id="mntxt"><p id="main3"><div id="hypercontext"><index>(.+?)</index></div></p>.*?<p class="smalltxt">(.+?)<br><noindex><strong>} $html -> info words] || [regexp -nocase -- {<div id="hypercontext"><index>(.+?)</index></div>.*?<p><strong>(.+?)</p><br>} $html -> info words]} {
	regsub -all -- "<a href.*?>(.+?)</a>" $words "\\1" words
	set words [split $words]
	set info [split [string map -nocase {"&laquo;" "'" "&raquo;" "'" "&nbsp;" "\x20" "<nobr>" "\x02" "</nobr>" "\x02" "&#8212;" "-" "&rsquo;" "'" "&mdash;" "-" "&ndash;" "" "<strong>" "" "</strong>" "" "<p>" "" "</p>" "\x20" "<br>" "" "<br />" ""} $info]]
	set words [string map -nocase {"&nbsp;" "\x20" "<nobr>" "\x02" "</nobr>" "\x02" "&#8212;" "-" "&rsquo;" "'" "&mdash;" "-" "&ndash;" "" "<strong>" "" "</strong>" "" "<p>" "" "</p>" "\x20" "<br>" "" "<br />" ""} $words]
	putserv "PRIVMSG $nick :$::gcolor(14)    $::gcolor(5)\"$text\"$::gcolor(14)..."
	set start 0
	set end 60
	set i 0
	while {[llength $info]} {
		incr i
		if {$i >= 15} {putlog "::sonnic:: Too long text, aborting..."; break}
		set info_ [join [lrange $info $start [expr $end -1]]]
		if {[string is space $info_]} {break}
		putserv "PRIVMSG $nick :$info_"
		incr start 60
		incr end 60
	}
	putserv "PRIVMSG $nick :[join $words]"
	return

} elseif {[regexp -nocase -- {<div id="tdmain"><h2>.*?" href="(.+?)">} $html -> link]} {
	putserv "$method $nick :  \002$text\002  ,     . ..."
	::http::geturl "http://sonnic.ru${link}" \
	-timeout 20000 \
	-command [list ::sonnic::sonnic_data $extra]
	return 0
} elseif {[string match -nocase "******" $html]} {
	putserv "$method $nick :  \002$text\002   ...  -."
	return 0
} else {
	putserv "$method $nick :  -_-"
	return 0
	}
} else {
if {[::http::status $token] ne "ok"} {
	putserv "$method $nick :      -_-"
	return 0
	} elseif {[::http::ncode $token] eq "404"} {	
	putserv "$method $nick :  \002$text\002   ...  -."
	return 0
	} else {
	putserv "$method $nick :unknown error."
	return 0
	}
}
}
}