######################################################
# Windrop  Vladislav
# : Vertigo
# : 2.1
# :    URL-,     .
#   - .chanset #chan +badtitle
#    .  I ()
#       .
######################################################

namespace eval ::title {

###############
#  
###############

#  ,       
variable denyprefixes {"!" "$" "." "^"}
#       ( http://)
variable domains {".ru" ".com" ".org" ".su" ".info" ".net" ".de" ".au" ".ua"}
#    ,    ( http://) [0/1]
variable nodomains 0
#   
variable maxredirects 5
#   ( )
variable timeout 30
#      (,    Accept-Range)
variable readlimit 11564
# -
variable useragent {Opera/9.52 (Windows NT 5.1; U; en)} 
#  ? [0/1]
variable debug 0
#     
variable deftemplate {\002Title\002:}
#    ( )
variable flood 3
#  , /  
variable flagactas		"no"
variable chflag			"$flagactas[namespace tail [namespace current]]"
setudef  flag 			$chflag


#################
#  
#################


if {![catch {package require tls} err]} {::http::register https 443 ::tls::socket; variable using_ssl 1} else {variable using_ssl 0}
setudef flag badtitle
variable redir 0
variable template ""

bind pubm - * ::title::pub
bind ctcp - "ACTION" ::title::actn

if {[info exists sp_version]} {set ::max_tcl_events 20; set ::select_timeout 100}

proc pub {nick uhost hand chan text} {
variable chflag ; variable flagactas
if {![channel get $chan $chflag] ^ $flagactas eq "no" } {return}
if {[info exists ::vktitle::vkvers] && ([string match "*http://vkontakte.ru*" $text] || [string match "*http://vk.com*" $text])} {return} 
if {[info exists ::ourtube(version)] && [string match "*http://*youtube*watch*" $text]} {return}
::title::main $nick $uhost $hand $chan $text
return
}

proc actn {nick uhost hand chan key text} {
variable chflag ; variable flagactas
if {[string match "*#*" $chan]} {if {![channel get $chan $chflag] ^ $flagactas eq "no" } {return}}
::title::main $nick $uhost $hand $chan $text
return
}

proc nodomain {text} {
variable domains
foreach _ $domains {
if {![string match "*$_*" "$text"]} {continue}
if {[string match "*$_*" "$text"]} {return 0}
}
return 1
}


proc main {nick uhost hand chan text} {
if {[matchattr $hand I]} {return}
variable denyprefixes; variable using_ssl; variable debug; variable nodomains
set text [split $text]
regsub -all {[\[\]\{\}\(\)\"\'\>\<]} $text "" text
set text [stripcodes bcruag $text]
foreach _ $denyprefixes {
if {[string index $text 0] eq $_} {if {$debug} {putlog "::title:: \[main\] Found denied prefix. Not responding."};return}
}
if {![string match "*http://*" $text] && ![string match "*https://*" $text] && ![string match "*www.*" $text] && ![string match "*wap.*" $text] && [nodomain $text]} {if {$debug} {putlog "::title:: \[main\] Links not found."}; return}
variable flood
if {[info exists ::title::check(lasttime,$nick)] && [expr $::title::check(lasttime,$nick) + $flood] > [clock seconds]} {
putserv "NOTICE $nick :  URL    1 ."
newignore "*!*@[lindex [split $uhost @] 1]" $::botnick "URL's flooder." 1
putlog "::title:: Ignored mask: *!*@[lindex [split $uhost @] 1], nick - $nick."
return
}
foreach _ $text {
if {[regexp -nocase -- {^(http://.+?)$} $_ -> url] || [regexp -nocase -- {^(www.*?|wap.*?)$} $_ -> url]} {request $url $nick $uhost $chan}
if {$using_ssl && [regexp -nocase -- {^(https://.+?)$} $_ -> url]} {request $url $nick $uhost $chan}
if {![regexp -nocase -- {^(http://.+?)$} [lindex $_ 0]] && $nodomains} {if {![nodomain [lindex $_ 0]]} {request "http:\/\/[lindex $_ 0]" $nick $uhost $chan}}
}
}

proc request {url nick uhost chan} {
variable useragent; variable debug; variable timeout; variable readlimit
if {[string range $url 0 7] eq "http://-"} {set url "http://[string range [string trim $url "-"] 8 end]"}
if {![regexp -nocase -- {^(https://.+?)$} $url] && [string range $url 0 6] ne "http://"} {set url "http://$url"}
set extra [list $nick $uhost $chan $url]
if {[regexp -nocase -- {^http://[-]{1}.+?\.?} $url] || [regexp -nocase -- {^http://www.[-]{1}.+?\.?} $url]} {
regsub -all -nocase -- {^http://([-]{1}.+?\.?)(/)} [string map [list \[ \\\[ \] \\\] \{ \\\{ \} \\\} \$ \\\$ \\ \\\\] $url] "http://\[::ccs::idna::encode \[encoding convertto utf-8 \\1\]\]\\2" url; set url [subst -novar $url]
regsub -all -nocase -- {^http://([-]{1}.+?\.?)$} [string map [list \[ \\\[ \] \\\] \{ \\\{ \} \\\} \$ \\\$ \\ \\\\] $url] "http://\[::ccs::idna::encode \[encoding convertto utf-8 \\1\]\]" url; set url [subst -novar $url]
regsub -all -nocase -- {^http://www.([-]{1}.+?\.?)(/)} [string map [list \[ \\\[ \] \\\] \{ \\\{ \} \\\} \$ \\\$ \\ \\\\] $url] "http://\[::ccs::idna::encode \[encoding convertto utf-8 \\1\]\]\\2" url; set url [subst -novar $url]
regsub -all -nocase -- {^http://www.([-]{1}.+?\.?)$} [string map [list \[ \\\[ \] \\\] \{ \\\{ \} \\\} \$ \\\$ \\ \\\\] $url] "http://\[::ccs::idna::encode \[encoding convertto utf-8 \\1\]\]" url; set url [subst -novar $url]
}
::http::config -useragent $useragent
if {$debug} {putlog "::title \[request\] Extra: $extra."}
if {[catch {set token [::http::geturl $url -binary 1 -timeout [expr $timeout*1000] -headers [list "Range" "bytes=0-$readlimit"] -command [list [namespace current]::data $extra]]} err]} {return}
set ::title::check(lasttime,$nick) [clock seconds]
}

proc data { extra token } {
variable maxredirects; variable deftemplate; variable debug; 
variable redir; variable maxredirects; variable using_ssl; variable template
set status [::http::status $token]
set ncode [::http::ncode $token]
array set meta [::http::meta $token]
if {$debug} {putlog "::title:: \[data\] status: $status\; metacode: $ncode\."}
if {![info exists meta(Content-Length)]} {set Size "Unknown size"} else {set Size [fsize $meta(Content-Length)]}
if {[info exists meta(Content-Range)]} {set Size [fsize [lindex [regexp -inline -- {bytes.*?\/(.+?)$} $meta(Content-Range)] 1]]}
if {[info exists meta(Content-Type)]} {set Type $meta(Content-Type)} else {set Type "Unknown type"}
if {$Size eq "Unknown size" && $Type eq "Unknown type"} {::http::cleanup $token; return}
set nick [lindex $extra 0]; set uhost [lindex $extra 1]; set chan [lindex $extra 2]; set url [lindex $extra 3]
	set tempurl [regsub -nocase -- "http.*://" $url ""]
	set query [join [lindex [split $tempurl "/"] 0] "/"]
	set get [join [lrange $tempurl 1 end] "/"]
if {[info exists meta(Location)]} {
	if {$debug} {putlog "::title:: \[data\] query: $query\; get: $get"}
	set simb "/"
    if {![string match "*http://*" $meta(Location)] && [string range $meta(Location) 0 0] == "/"} { set link "http://$host$meta(Location)"}
if {![string match "*http://*" $meta(Location)] && ![string match "*https://*" $meta(Location)] && [string range $meta(Location) 0 0] != "/"} { set link "http://$query$simb$meta(Location)"}
if {[string match "http://*" $meta(Location)]} {set link $meta(Location)}
	if {![string match "*https://*" $meta(Location)] && ![info exists link] && $using_ssl == 1} {set link "https://$query$simb$meta(Location)"}
	if {[string match "*https://*" $meta(Location)] && $using_ssl == 1} {set link $meta(Location)}
if {$meta(Location) != "" && [string match "*domain=*" [::http::meta $token]] && ![string match "http*" $meta(Location)]} {set link "http://[lindex [split http://$query "/"] 2]$simb$meta(Location)"}
	if {($ncode eq "301" || $ncode eq "302") && $status eq "ok"} {
if {$debug} {putlog "::title:: \[data\] redirect detected."}
incr redir
if {$debug} {putlog "::title:: \[data\] Redirect \#$redir."}
if {$redir >= $maxredirects} {if {$debug} {putlog "::title:: \[data\] Max. redirects reached. Stopping."}; set redir 0; return}
set url $link
::http::cleanup $token
::title::request $url $nick $uhost $chan
}
} else {
if {$debug} {putlog "::title:: \[data\] Data received. Processing..."}
catch {array unset meta; unset -nocomplain meta}
set html [::http::data $token]
set meta [::http::meta $token]
::http::cleanup $token

append meta $html
set charset ""
set charset [lindex [regexp -all -inline -nocase -- ".*?charset=(.+?)\"" $meta] 1]
unset -nocomplain meta


if {[string length $html] <5000 && [regexp -nocase -- "<meta http-equiv=\"refresh\" content=\".*URL=(.+?)\".*</head>" $html -> redirr]} {
		regsub -all -- {\"\>} $redirr {} redirr
		set simb "/"
		if {![string match "*http://*" $redirr] && [string index $redirr 0] != "/"} {set redirr "http://$query$simb[lindex [split $get "/"] 0]$simb$redirr"}
		if {![string match "*http://*" $redirr] && [string index $redirr 0] == "/"} {set redirr "http://$query$redirr"}
		::title::request $redirr $nick $uhost $chan
	if {$debug} {putlog "::title:: \[data\] meta-refresh redirect detected. URL: $redirr"}
	return
}

switch -glob -- [string range $html 0 19] {
"GIF8*" {set title [gif_dimensions $html]; set sh_size 1}
"\x89PNG\r\n\x1a\n*" {set title [png_dimensions $html]; set sh_size 1}
"\xFF\xD8\xFF*" {set title [jpeg_dimensions $html]; set sh_size 1}
"BM*" {set title [bmp_dimensions $html]; set sh_size 1}
default {set title [::title::decode $html $charset]; set template $deftemplate; set sh_size 0}
}


if {$title ne ""} {
if {[channel get $chan badtitle] && [DetectMat [encoding convertto cp1251 $title]]} {set title " "}
if {$sh_size} {append title " @ $Size"}
putserv "PRIVMSG $chan :[subst $template] $title"

variable redir
set redir 0
} else {
putserv "PRIVMSG $chan :\002File\002: \037Type\037: $Type @ $Size"
return
}
}
}

proc bmp_dimensions {data} {
variable template
set template "\002Image\002: \037Format\037: bmp ::"
binary scan [string range $data 18 25] ii width height
set ret [list $width $height]
return "\037Dimensions\037: [join $ret x] px."
}

proc jpeg_dimensions {data} {
variable template
set template "\002Image\002: \037Format\037: jpeg ::"
                set ret [list]
                set i 2
                    while {[string index $data $i] eq "\xFF"} {
                        binary scan [string range $data [incr i] [expr $i+2]] H2S type len
                        incr i 3
                        # convert to unsigned
                        set len [expr {$len & 0x0000FFFF}]
                        # decrement len to account for marker bytes
                        incr len -2
                        if {[string match {c[0-3]} $type]} {
                            set p $i
                            break
                        }
                        incr i $len
                    }

                    if {[info exists p]} {
                        binary scan [string range $data $p [expr $p+4]] cSS precision height width
                        set ret [list $width $height]
                    }
                return "\037Dimensions\037: [join $ret x] px."
            }
			
proc png_dimensions {data} {
variable template
set template "\002Image\002: \037Format\037: png ::"
                set ret [list]
                    set i 0
                    binary scan [string range $data [incr i 8] [expr $i+7]] Ia4 len type
                    set r [string range $data [incr i 8] [expr $i+$len]]
                    if {$i < [string length $data] && $type eq "IHDR"} {
                        binary scan $r II width height
                        set ret [list $width $height]
                    }
                
                return "\037Dimensions\037: [join $ret x] px."
            }
        
proc gif_dimensions {data} {

variable template
set template "\002Image\002: \037Format\037: gif ::"
                set sig [string range $data 0 3]
			    set ret [list]
                    binary scan [string range $data 6 7] s wid
                    binary scan [string range $data 8 9] s hgt
                    set ret [list $wid $hgt]
               return "\037Dimensions\037: [join $ret x] px."
}


proc decode {data charset} {
variable debug
		
		regsub -all -- {[\x5C\x27\x2F\x3E\x3C\x22\x5F\x7B\x5D\x7D\x5B]+} $charset "" charset
		set charset [string trim $charset]
		regsub -all -nocase "fc|!.*" $charset "" charset
		set charset [string trim [string tolower $charset] \x5D\x7D\x7B\x5B\x3C\x3E\x22\x27]
		set charset [lindex [split $charset] 0]
		if {$charset == "" || $charset == "windows-1251" || $charset == "no"} {set charset cp1251}
		set charset0 ""
		set charset [string map {"win-" "cp" "windows-" "cp" "iso-" "iso" "cp-" "cp" "utf8" "utf-8"} $charset]
		if {[string is space [lsearch -all [encoding names] $charset]]} {if {$debug} {putlog "::title:: \[decode\] Encoding $charset was not found! Setting to default..."}; set charset [encoding system]}
		set info ""
		set info [string trim [lindex [regexp -nocase -inline -- "<title>(.+?)</title>" $data] 1]]
		if {$info == ""} {set info [string trim [lindex [regexp -nocase -inline -- "<title.*>(.+?)</title>" $data] 1]]}
		if {$info == "" && [string match "*card*" $data]} {set info [lindex [regexp -nocase -all -inline -- {title=\"(.*?)\"} $data] 1]}
		if {$info == "" && [string match "*meta name*" $data]} {set info [lindex [regexp -nocase -all -inline -- {name=\"title\" content=\"(.*?)\"} $data] 1]}
		if {$debug} {putlog "::title:: \[decode\] Raw title: $info"}
		regsub -all "\n|\r|\t" $info " " info
		regsub -all {  } $info { } info
		if {$data == {}} {if {$debug} {putlog "::title:: \[decode\] Data not present!"}; return ""}
		if {$charset == {}} {set charset cp1251}
		set info000 [encoding convertfrom [encoding system] $info]
		set enc_need ""
		if {[string match -nocase "*windows-1251*" $data] && ![regexp -nocase -- {[--߸]} $data]} {set enc_need 1}
		if {![regexp -- {[--߸]} $info]} {set enc_need auto}
		if {[string match "*\\\?\\\?\\\?*" $info] && ![string match "*charset=*" $data]} {set enc_need 2}
		if {[string match "*е*" $info] || [string match "*?*" $info] || ([string match "*?*" $info] && ![string match "*-?*" $info]) || [string match -nocase "<meta http-equiv*charset=utf-8" $data]} {set enc_need 3}
		if {([string match -nocase "*koi8-r*" $data] && $enc_need != "3" && $charset != "cp1251") || ([string tolower $charset] == "koi8-r" && $enc_need != "3")} {set enc_need 2}
		if {[string range $info000 1 4] ==[string toupper [string range info000 1 4]] && [regexp -- {[-]} $info]} {set enc_need 2}
		if {[string match "*&#1072;*" $info]} {set enc_need "not_need"}
		if { $info == "" } {return} 
		if {[string match "\\\?\\\?\\\?\\\?*" $info]} {set enc_need "auto"}
		if {$debug} {putlog "::title:: \[decode\] Charset detected: $charset\; Encoding mode: $enc_need."}
			switch -glob -- $enc_need {
			"1" {set info [encoding convertfrom [encoding system] $info]}
			"2" {set info [encoding convertfrom koi8-r $info]}
			"3" {set info [encoding convertfrom utf-8 $info]}
			"auto" {set info [encoding convertfrom $charset $info]}
			default {set info [lindex $info]}
			}
		set debinfo [regsub -all -- {\x20|[^--]} $info ""]
		if {[issmall [string range $debinfo 0 0]] && ![issmall [string range $debinfo 1 15]] && [regexp -- {[-ߨ]} $debinfo] && $charset != "utf-8"} {set info [encoding convertfrom koi8-r [encoding convertto cp1251 $info]]}
		
		set info [::title::webstrip $info]
		if {![regexp -all -- {[--߸a-zA-Z]} $info]} {set info [encoding convertfrom [encoding system] $info]}
		if {[string match "*а*р*" $info] || [string match "*л*п*" $info]} {set info [encoding convertfrom utf-8 [encoding convertto [encoding system] $info]]}		
		set enc_need 0
		return $info
}


proc issmall {{t ""}} {
if {$t eq ""} {return 1}
set a [regexp -all --  {[-]} $t];
set b [format %.1f [expr $a/[string length $t].0*100]]
if {$b >=40} {return 1} else {return 0}
}

proc regsub-eval {re string cmd} {
  return [subst [regsub -all $re [string map {\[ \\[ \] \\] \$ \\$ \\ \\\\} $string] "\[format %c \[$cmd\]\]"]]
}

proc fsize {bytes} {
if {![string is digit $bytes]} {error "value must be a valid digit, more then zero"}
if {$bytes >=0 && $bytes < 1024} {return "$bytes byte\(s\)"
} elseif {$bytes >= 1024 && $bytes < 1024000} {return "[format %.2f [expr $bytes /1024.0]] KB"
} elseif {$bytes >= 1024e3 && $bytes < 1024e6} {return "[format %.2f [expr $bytes/1024.0/1024.0]] MB"
} elseif {$bytes >= 1024e6 && $bytes < 1024e9} {return "[format %.2f [expr $bytes/1024.0/1024.0/1024.0]] GB"
} elseif {$bytes >= 1024e9 && $bytes < 1024e12} {return "[format %.2f [expr $bytes/1024.0/1024.0/1024.0/1024.0/1024.0]] TB"
} elseif {$bytes >= 1024e12 && $bytes < 1024e15} {return "[format %.2f [expr $bytes/1024.0/1024.0/1024.0/1024.0/1024.0/1024.0]] PB"
} elseif {$bytes >= 1024e15 && $bytes < 1024e18} {return "[format %.2f [expr $bytes/1024.0/1024.0/1024.0/1024.0/1024.0/1024.0/1024.0]] EB"
} elseif {$bytes >= 1024e18 && $bytes < 1024e21} {return "[format %.2f [expr $bytes/1024.0/1024.0/1024.0/1024.0/1024.0/1024.0/1024.0/1024.0]] ZB"
} else {return "[format %.2f [expr $bytes/1024.0/1024.0/1024.0/1024.0/1024.0/1024.0/1024.0/1024.0/1024.0]] IB"
}
}



proc webstrip {t} {
  regsub -all -nocase -- {<.*?>(.*?)</.*?>} $t {\1} t
  regsub -all -nocase -- {<.*?>} $t {} t

  set t [string map -nocase {{&#x202c;} {} {&#x202a;} {} {&rlm;} {} {&rln;} {} {&mdash;} {-} {&raquo;} {} {&laquo;} {} {&quot;} {"}  \
		{&lt;} {<} {&gt;} {>} {&nbsp;} { } {&amp;} {&} {&copy;} {} {&#169;} {} {&bull;} {} {&#183;} {-} {&sect;} {} {&reg;} {} \
		  &#8214;    || \
		&#38;      &     &#91;      (     &#92;      /     &#93;      )      &#123;     (     &#125;     ) \
		&#163;          &#168;          &#169;          &#171;           &#173;          &#174;      \
		&#161;          &#191;          &#180;          &#183;           &#185;          &#187;      \
		&#188;          &#189;          &#190;          &#192;           &#193;          &#194;      \
		&#195;          &#196;          &#197;          &#198;           &#199;          &#200;      \
		&#201;          &#202;          &#203;          &#204;           &#205;          &#206;      \
		&#207;          &#208;          &#209;          &#210;           &#211;          &#212;      \
		&#213;          &#214;          &#215;          &#216;           &#217;          &#218;      \
		&#219;          &#220;          &#221;          &#222;           &#223;          &#224;      \
		&#225;          &#226;          &#227;          &#228;           &#229;          &#230;      \
		&#231;          &#232;          &#233;          &#234;           &#235;          &#236;      \
		&#237;          &#238;          &#239;          &#240;           &#241;          &#242;      \
		&#243;          &#244;          &#245;          &#246;           &#247;          &#248;      \
		&#249;          &#250;          &#251;          &#252;           &#253;          &#254;      \
		&#176;          &#8231;         &#716;     .     &#363;     u      &#299;     i     &#712;     ' \
		&#596;     o     &#618;     i     &apos;     ' } $t]
	set t [string map -nocase {&iexcl;    \xA1  &curren;   \xA4  &cent;     \xA2  &pound;    \xA3   &yen;      \xA5  &brvbar;   \xA6 \
		&sect;     \xA7  &uml;      \xA8  &copy;     \xA9  &ordf;     \xAA   &laquo;    \xAB  &not;      \xAC \
		&shy;      \xAD  &reg;      \xAE  &macr;     \xAF  &deg;      \xB0   &plusmn;   \xB1  &sup2;     \xB2 \
		&sup3;     \xB3  &acute;    \xB4  &micro;    \xB5  &para;     \xB6   &middot;   \xB7  &cedil;    \xB8 \
		&sup1;     \xB9  &ordm;     \xBA  &raquo;    \xBB  &frac14;   \xBC   &frac12;   \xBD  &frac34;   \xBE \
		&iquest;   \xBF  &times;    \xD7  &divide;   \xF7  &Agrave;   \xC0   &Aacute;   \xC1  &Acirc;    \xC2 \
		&Atilde;   \xC3  &Auml;     \xC4  &Aring;    \xC5  &AElig;    \xC6   &Ccedil;   \xC7  &Egrave;   \xC8 \
		&Eacute;   \xC9  &Ecirc;    \xCA  &Euml;     \xCB  &Igrave;   \xCC   &Iacute;   \xCD  &Icirc;    \xCE \
		&Iuml;     \xCF  &ETH;      \xD0  &Ntilde;   \xD1  &Ograve;   \xD2   &Oacute;   \xD3  &Ocirc;    \xD4 \
		&Otilde;   \xD5  &Ouml;     \xD6  &Oslash;   \xD8  &Ugrave;   \xD9   &Uacute;   \xDA  &Ucirc;    \xDB \
		&Uuml;     \xDC  &Yacute;   \xDD  &THORN;    \xDE  &szlig;    \xDF   &agrave;   \xE0  &aacute;   \xE1 \
		&acirc;    \xE2  &atilde;   \xE3  &auml;     \xE4  &aring;    \xE5   &aelig;    \xE6  &ccedil;   \xE7 \
		&egrave;   \xE8  &eacute;   \xE9  &ecirc;    \xEA  &euml;     \xEB   &igrave;   \xEC  &iacute;   \xED \
		&icirc;    \xEE  &iuml;     \xEF  &eth;      \xF0  &ntilde;   \xF1   &ograve;   \xF2  &oacute;   \xF3 \
		&ocirc;    \xF4  &otilde;   \xF5  &ouml;     \xF6  &oslash;   \xF8   &ugrave;   \xF9  &uacute;   \xFA \
		&ucirc;    \xFB  &uuml;     \xFC  &yacute;   \xFD  &thorn;    \xFE   &yuml;     \xFF} $t]
  set t [::title::regsub-eval {&#([0-9]{1,5});} $t {string trimleft \1 "0"}]
  regsub -all {\s+} $t " " t
  return $t
}

variable BadWords { 
	"" " " "  " " l " "  " "  " " " " li " " hli " " hli " " " " " "" \
	"" "" "i" "" "" " ?" "?" "" "  " "" " " " il" " il" "" \
	"" "" "" "" "" "" "" "" " " "" " " " " " " "" \
	" " "  " " " " " " " " " " " " " " " " " " " " " "dhi" \
	"di" "i" "dhi" "  " "" "" "izd" "  " " " " " " l" " l" "  " "  " \
	"  " "  " " " " " "" "" "" "" "" "" "" "" "" "" \
	"" "" "" "" "dl" "dl" "djl" " " " " " " " " " " \
	" idr" " " " " "" "" "" "" " " "" "" " " " " " " "" \
	" " "" " " " " " z" "" "" " z" " " "" " " " " " " "" \
	"" "" " " " " " rd" " d" " f" " f " " fi" " t " " h" " h" " ih " \
	" ih " "" "" "  " "" " " " " "" ""	""
}

proc DetectMat {text} {
  variable BadWords

  regsub -all {[\x02\x16\x1f]|\x03\d{0,2}(,\d{0,2})?} $text "" text
  set text [encoding convertfrom [encoding system] $text]
  set text [string map {A  a  B  C  c  E  e  H  K  k  M  O  o  P  p  T  U  u  X  x  Y  y  3  4  6  0  b  g  n } $text]
  set text [string tolower $text]
  set text " $text "
  regsub -all {\.\`\~\!\@\#\$\%\^\&\*\(\)\_\-\+\=\{\}\[\]\;\:\'\"\<\>\,\.\/\?\|\\} $text " " text";
  set res ""
  set ch ""
  for {set i 0} {$i < [string length $text]} {incr i} {
    set newch [string index $text $i]
    if {$ch != $newch} {
      append res $newch
    }
    set ch $newch
  }
  set text $res

  foreach i $BadWords {
    set mask [split [string trim $i] {}]
    regsub -all { } $mask {\s*} mask
    set mask ".*\\s+$mask\\s+.*"
    if {[regexp $mask $text] || [string match *$i* $text]} { return 1 }
  }
  return 0
}
}