######################################################
# Windrop  Vladislav 
# : 0.8
# :        .
# : ! !
######################################################

namespace eval ::wiki {

variable redir 0
variable count 1
variable debug 0

#         " "
#bind pubm - "* *" ::wiki::pub

bind pub - $::gprefix(1)wiki ::wiki::pub
bind pub - $::gprefix(1) ::wiki::pub
bind pub - $::gprefix(1)egghelp ::wiki::pub
bind pub - $::gprefix(1) ::wiki::pub

set ::wiki::check(delay) "30"

setudef flag nowiki

proc checklang {lang} {
set langs {ar bg be ca cs da de el en eo es et fa fi fr he hr hu id it ja ko lt mk nl nn no pl pt ro ru sk sl sr sv tr uk vi zh}
foreach _ $langs {
if {![string match $_ $lang]} {continue}
if {[string match $_ $lang]} {return 1}
}
return 0
}

proc pub {nick uhost hand chan text} {
if {[channel get $chan nowiki]} { return }
regsub -all {.*? } $text "" text
set text [string map [list "\?" ""] $text]
main $nick $uhost $hand $chan $text
}

proc main {nick uhost hand chan text} {
variable redir
variable count
set count 1
if {$text eq ""} {putserv "NOTICE $nick :: $::lastbind \[-\] \<\> \[ \] -   . (    ,    .     3,     ,  -  )."; return}
if {[info exists ::wiki::check(lasttime,$nick)] && [expr $::wiki::check(lasttime,$nick) + $::wiki::check(delay)] > [clock seconds] && ![matchattr $hand n]} {
putfast "NOTICE $nick :      [expr $::wiki::check(delay) - [expr [clock seconds] - $::wiki::check(lasttime,$nick)]] ."
return
}
set ::wiki::tmpcount $count
if {[regexp -- {\s(\d+)$} $text -> cnt]} {if {$cnt <= 20 && $cnt > 0} {set count $cnt; regsub -- " $cnt$" $text "" text} else {putserv "NOTICE $nick :   !"; regsub -- " $cnt$" $text "" text; set cnt ""}} 
if {![regexp -nocase -- {^-(..)} $text -> lang]} {set lang "ru"} else {set lang $lang}
::http::config -useragent "Opera/9.52 (Windows NT 5.1; U; en)" -urlencoding utf-8
regsub -- "-$lang " $text "" text
set text [::http::formatQuery $text]
if {![checklang $lang]} {putserv "NOTICE $nick :  ! : ar, bg, be, ca, cs, da, de, \
el, en, eo, es, et, fa, fi, fr, he, hr, hu, id, it, ja, ko, lt, mk, nl, nn, no, pl, pt, ro, ru, sk, sl, sr, sv, tr, uk, vi, zh."; return}
if {$::lastbind eq "$::gprefix(1)wiki" || $::lastbind eq "$::gprefix(1)" || $::lastbind eq "* *"} {set s 0; set url "http://$lang.wikipedia.org/w/index.php?title=%D0%A1%D0%BB%D1%83%D0%B6%D0%B5%D0%B1%D0%BD%D0%B0%D1%8F:Search&search=$text&ns0=1&redirs=0"}
if {$::lastbind eq "$::gprefix(1)egghelp" || $::lastbind eq "$::gprefix(1)"} {set s 1; set url "http://wiki.egghelp.ru/:Search?search=$text&go=%D0%9F%D0%B5%D1%80%D0%B5%D0%B9%D1%82%D0%B8"}
#putserv "PRIVMSG $chan wiki-url - $url"
set extra [list $nick $chan $lang $s]
request $url $extra
}

proc request {url extra} {
variable redir
variable debug
set nick [lindex $extra 0]; set chan [lindex $extra 1]
if {$debug} {putfast "PRIVMSG $chan :\002request-url\002: $url"}
if {$redir > 4} {putlog "Maximum redirects!";set redir 0; return}
incr redir
if {[catch {set token [::http::geturl $url -timeout 20000 -binary 0 -blocksize 32760 -command [list [namespace current]::data $extra $url]]} err]} {
putserv "PRIVMSG $chan :$nick:      -.- ($err)"; return}
}

proc data {extra url token} {
variable redir; variable count
set nick [lindex $extra 0]; set chan [lindex $extra 1]; set lang [lindex $extra 2]; set s [lindex $extra 3]
set status [::http::status $token]
set ncode [::http::ncode $token]
if {$status eq "timeout"} {putserv "PRIVMSG $chan :$nick:  ."; ::http::cleanup $token; return}
if {$status eq "error"} {putserv "PRIVMSG $chan :$nick:    . [lindex [::http::error $token] 0]"; ::http::cleanup $token; return}
set ::wiki::check(lasttime,$nick) [clock seconds]
array set meta [::http::meta $token]
#putserv "PRIVMSG $chan :wiki-data: $nick/$chan :: $status :: $ncode"
if {[string match "30?" $ncode] && [info exists meta(Location)]} {
::http::cleanup $token
request $meta(Location) $extra
} else {
set data [::http::data $token]
::http::cleanup $token
if {[regexp -nocase -- {.*<div class="searchdidyoumean">.*":Search">(.+?)</a></div>.*} $data -> vozm]} {putfast "PRIVMSG $chan :$nick,     : [string map {"<em>" "\037" "</em>" "\037" "<b>" "\002" "</b>" "\002"} $vozm ]"; return}
if { [regexp -nocase -- {<ul class='mw-search-results'>.<li><a href="(.+?)" title=.*<div class='searchresult'>} $data - res]} {
if {$s eq 0} {request "http://$lang.wikipedia.org$res" $extra; return}
if {$s eq 1} {request "http://wiki.egghelp.ru$res" $extra; return}
}
if {[string match -nocase "******" $data] || [string match -nocase "*****" $data ] || [string match -nocase "*<title> \*\  </title>*" $data]} {putserv "PRIVMSG $chan :  ."; return}
regsub -nocase -- {.*<!-- start content -->} $data "" data
regsub -nocase -- {<!-- end content -->.*$} $data "" data
regsub -all -- "\n|\r|\t" $data "" data
set data [parser $data]
set data [encoding convertfrom utf-8 [encoding convertto cp1251 $data]]
out $url $data $nick $chan $count
}
set redir 0
}

proc parser {data} {
# 
if {[regsub -nocase -- {(.*?)<p><strong class=\"selflink\">(.*?)} $data {\2} data] || [regsub -nocase -- {(.*?)<p>(<b>.*?)} $data {\2} data]} {} else {putlog "wiki regsub error!"}
# 
regsub -all -nocase -- {<table id=\"toc\" class=\"toc\".*</ul></td></tr></table>} $data "" data
regsub -nocase -- {<table.*</table></td></tr></table>} $data "" data
#   
regsub -all -nocase -- {</span></h2><ul><li><i>.*?</a></td><td><i>} $data "" data
regsub -all -nocase -- {<dl><dd>.+?</dd></dl>} $data "" data
#   
regsub -nocase -all -- {<div class=\"noprint\">(.+?)</li></ul></li></ul></li></ul>} $data {\1} data
regsub -nocase -all -- {<!--.*/scri-->} $data "" data
regsub -all -nocase -- {</li>} $data " *" data
#regsub -all -nocase -- {</a></li>} $data { *} data
# c  ""
#regsub -all -nocase -- {<h2><span.*</span></h2>} $data "" data
#  ". "
regsub -all -nocase -- {<td><i><span style=\"white-space:nowrap\".*</span></i></td>} $data "" data
#  html-   IRC
set data [string map -nocase {"<b>" "\002" "</b>" "\017" "<i>" "\037" "</i>" "\017" "<span class=\"mw-headline\">" "|| \037\002" "</span></h2>" "\017: " "</span></h3>" "\017: " "</p>" " "} $data]
regsub -all -nocase -- {<div style=\"position: absolute.+?</td></tr></table>} $data {} data
#   
regsub -all -nocase -- {<style.*?>.*?</style>} $data {} data
regsub -all -nocase -- {<script.*?>.*?</script>} $data {} data
regsub -all -nocase -- {<.*?>(.*?)</.*?>} $data {\1} data
regsub -all -nocase -- {\[.*?\]} $data {} data
regsub -all -nocase -- {<.*?>} $data { } data
#     
set data [webstrip $data]
regsub -all -nocase -- {   |// } $data {} data
set data [string map {" , " ", " " ( " " (" "́" "" "&#160;" " " "&#32;" "" "&rarr;" "->"} [encoding convertfrom cp1251 [encoding convertto utf-8 $data]]]
return $data
}

proc out { url data nick chan {maxcount ""}} {
set maxmsg 430
variable count
set lengthdata [string length $data]
if {$maxcount <=2 || $lengthdata <430} {set dest $chan} else {set dest $nick}
if {$maxcount eq ""} {set maxcount [expr {round(double($lengthdata)/$maxmsg) + 1}]}
if {$lengthdata <430} {putserv "PRIVMSG $dest :$data"} else {
for {set count 1} {$count <= $maxcount} {incr count} {
set msg [string range $data [expr {$maxmsg*$count-$maxmsg}] [expr {$maxmsg*$count-1}]]
if {$msg ne ""} {putserv "PRIVMSG $dest :$msg"}
}
}
if {$msg ne ""} {putserv "PRIVMSG $dest :$::gcolor(12)\037[encoding convertfrom utf-8 [string urldecode $url]]\017"}
catch {set count 1}
}

proc webstrip {t} {
set t [string map -nocase {{&mdash;} {-} {} {-} {&raquo;} {"} {&laquo;} {"} {&quot;} {"}  \
		{&lt;} {<} {&gt;} {>} {&nbsp;} { } {&amp;} {&} {&copy;} {} {&#169;} {} {&bull;} "\002\xB7\002" {&#183;} {-} {&sect;} {} {&reg;} {} \
		  &#8214;    "" { } {"} { } {"} {} {"} {} {"} \
		&#38;      &     &#91;      (     &#92;      /     &#93;      )      &#123;     (     &#125;     ) \
		&#163;          &#168;          &#169;          &#171;     \"      &#173;     -     &#174;      \
		&#161;          &#191;          &#180;          &#183;           &#185;          &#187;     \" \
		&#188;          &#189;          &#190;          &#192;           &#193;          &#194;      \
		&#195;          &#196;          &#197;          &#198;           &#199;          &#200;      \
		&#201;          &#202;          &#203;          &#204;           &#205;          &#206;      \
		&#207;          &#208;          &#209;          &#210;           &#211;          &#212;      \
		&#213;          &#214;          &#215;          &#216;           &#217;          &#218;      \
		&#219;          &#220;          &#221;          &#222;           &#223;          &#224;      \
		&#225;          &#226;          &#227;          &#228;           &#229;          &#230;      \
		&#231;          &#232;          &#233;          &#234;           &#235;          &#236;      \
		&#237;          &#238;          &#239;          &#240;           &#241;          &#242;      \
		&#243;          &#244;          &#245;          &#246;           &#247;          &#248;      \
		&#249;          &#250;          &#251;          &#252;           &#253;          &#254;      \
		&#176;          &#8231;         &#716;     .     &#363;     u      &#299;     i     &#712;     ' \
		&#596;     o     &#618;     i     &apos;     ' } $t]
	set t [string map -nocase {&iexcl;    \xA1  &curren;   \xA4  &cent;     \xA2  &pound;    \xA3   &yen;      \xA5  &brvbar;   \xA6 \
		&sect;     \xA7  &uml;      \xA8  &copy;     \xA9  &ordf;     \xAA   &laquo;    \xAB  &not;      \xAC \
		&shy;      \xAD  &reg;      \xAE  &macr;     \xAF  &deg;      \xB0   &plusmn;   \xB1  &sup2;     \xB2 \
		&sup3;     \xB3  &acute;    \xB4  &micro;    \xB5  &para;     \xB6   &middot;   \xB7  &cedil;    \xB8 \
		&sup1;     \xB9  &ordm;     \xBA  &raquo;    \xBB  &frac14;   \xBC   &frac12;   \xBD  &frac34;   \xBE \
		&iquest;   \xBF  &times;    \xD7  &divide;   \xF7  &Agrave;   \xC0   &Aacute;   \xC1  &Acirc;    \xC2 \
		&Atilde;   \xC3  &Auml;     \xC4  &Aring;    \xC5  &AElig;    \xC6   &Ccedil;   \xC7  &Egrave;   \xC8 \
		&Eacute;   \xC9  &Ecirc;    \xCA  &Euml;     \xCB  &Igrave;   \xCC   &Iacute;   \xCD  &Icirc;    \xCE \
		&Iuml;     \xCF  &ETH;      \xD0  &Ntilde;   \xD1  &Ograve;   \xD2   &Oacute;   \xD3  &Ocirc;    \xD4 \
		&Otilde;   \xD5  &Ouml;     \xD6  &Oslash;   \xD8  &Ugrave;   \xD9   &Uacute;   \xDA  &Ucirc;    \xDB \
		&Uuml;     \xDC  &Yacute;   \xDD  &THORN;    \xDE  &szlig;    \xDF   &agrave;   \xE0  &aacute;   \xE1 \
		&acirc;    \xE2  &atilde;   \xE3  &auml;     \xE4  &aring;    \xE5   &aelig;    \xE6  &ccedil;   \xE7 \
		&egrave;   \xE8  &eacute;   \xE9  &ecirc;    \xEA  &euml;     \xEB   &igrave;   \xEC  &iacute;   \xED \
		&icirc;    \xEE  &iuml;     \xEF  &eth;      \xF0  &ntilde;   \xF1   &ograve;   \xF2  &oacute;   \xF3 \
		&ocirc;    \xF4  &otilde;   \xF5  &ouml;     \xF6  &oslash;   \xF8   &ugrave;   \xF9  &uacute;   \xFA \
		&ucirc;    \xFB  &uuml;     \xFC  &yacute;   \xFD  &thorn;    \xFE   &yuml;     \xFF "?" ""} $t]
regsub -all {\s+} $t " " t
return $t
}
return 
}